package edu.indiana.extreme.q.impl;

import java.io.IOException;
import java.sql.SQLException;
import java.util.concurrent.ConcurrentLinkedQueue;

import edu.indiana.extreme.q.Queue;

import wsmg.db.PersistantQueueDB;


/**
 * @author Chathura Herath (cherath@cs.indiana.edu)
 */

public class QueueImpl implements Queue {

	private java.util.Queue queue;

	private PersistantQueueDB queueDB;

	private java.util.Queue disposeQueue;

	public static int DISPOSE_QUEUE_FLUSH_SIZE = 100;

	public QueueImpl() throws SQLException {

		this.queue = new ConcurrentLinkedQueue();
		this.disposeQueue = new ConcurrentLinkedQueue();
		this.queueDB = PersistantQueueDB.getInstance();
		KeyValueWrapper obj = null;
		try {
			obj = this.queueDB.retrive();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		while (obj != null) {
			this.queue.add(obj);
			obj = null;
			try {
				obj = this.queueDB.retrive();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	public void enqueue(Object object, String trackId) {
		KeyValueWrapper wrappedInstance = null;
		try {
			wrappedInstance = this.queueDB.getWrappedInstance(object);
			this.queueDB.save(wrappedInstance, trackId);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.queue.add(wrappedInstance);

	}

	public synchronized Object blockingDequeue() {

		while(queue.size() ==0);
		KeyValueWrapper obj = (KeyValueWrapper) this.queue.remove();
		this.disposeQueue.add(obj);
		if (this.disposeQueue.size() >= DISPOSE_QUEUE_FLUSH_SIZE) {
			try {
				this.queueDB.delete(this.disposeQueue);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return obj.getValue();
	}

	public int size() {
		return this.queue.size();
	}

	public void flush() {
		throw new UnsupportedOperationException();
	}
	
	public void cleanup() {
		throw new UnsupportedOperationException();
	}

}


/*
 * Indiana University Extreme! Lab Software License, Version 1.2
 * 
 * Copyright (C) 2004 The Trustees of Indiana University. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 * 
 * 2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 * 
 * 3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 * 
 * "This product includes software developed by the Indiana University Extreme!
 * Lab. For further information please visit http://www.extreme.indiana.edu/"
 * 
 * Alternatively, this acknowledgment may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 * 
 * 4) The name "Indiana University" or "Indiana University Extreme! Lab" shall
 * not be used to endorse or promote products derived from this software without
 * prior written permission from Indiana University. For written permission,
 * please contact http://www.extreme.indiana.edu/.
 * 
 * 5) Products derived from this software may not use "Indiana University" name
 * nor may "Indiana University" appear in their name, without prior written
 * permission of the Indiana University.
 * 
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of any
 * other entity. Indiana University disclaims any liability to any recipient for
 * claims brought by any other entity based on infringement of intellectual
 * property rights or otherwise.
 * 
 * LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 * NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 * INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 * "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 * LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 * GENERATED USING SOFTWARE.
 */
