package wsmg;

import java.io.IOException;
import java.sql.SQLException;

import org.exolab.jms.util.CommandLine;

import edu.indiana.extreme.q.QueueFactory;

import wsmg.config.WSMGParameter;
import wsmg.measure.profile.RunTimeStatistics;
import wsmg.processors.DeliveryThread;
import xsul.processor.DynamicInfosetProcessorException;

public class Messenger {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		System.out.println("Starting messenger: version:"+WsmgVersion.getImplementationVersion()+" "+WSMGParameter.versionSetUpNote);
		if(WSMGParameter.queueType == WSMGParameter.EXTREME_DISTRIBUTED_QUEUE){
			try {
				WSMGParameter.OUT_GOING_QUEUE = QueueFactory.createDistrebutedQueue();
			} catch (SQLException e) {
				throw new NotificationException("Unable to Create Extreme Queue", e);
			}
		}		
		DeliveryThread publisherThread = new DeliveryThread();
		new Thread(publisherThread).start();
		RunTimeStatistics.setStartUpTime();
		if(WSMGParameter.enableMessengerStatucCheckPort){
        int port;
        CommandLine cmdline = new CommandLine(args);
        // Default port 12345
        port = Integer.parseInt(cmdline.value("port", "12347"));
        try {
            new MessengerSOAPServer(port).start();
        } catch (DynamicInfosetProcessorException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
		}
	}

}
