package wsmg;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Writer;

import org.xmlpull.v1.XmlPullParserException;
import org.xmlpull.v1.XmlSerializer;
import org.xmlpull.v1.builder.XmlBuilderException;
import org.xmlpull.v1.builder.XmlElement;

import wsmg.measure.profile.RunTimeStatistics;
import xsul.http_server.HttpServerException;
import xsul.http_server.HttpServerRequest;
import xsul.http_server.HttpServerResponse;
import xsul.processor.DynamicInfosetProcessorException;
import xsul.processor.soap_over_http.SoapHttpDynamicInfosetProcessor;
import xsul.soap.SoapUtil;
import xsul.soap11_util.Soap11Util;
import xsul.soap12_util.Soap12Util;

/**
 * @author Chathura Herath (cherath@cs.indiana.edu)
 */

public class MessengerSOAPServer extends SoapHttpDynamicInfosetProcessor {

    public MessengerSOAPServer(int port) {
        super();
        this.setServerPort(port);
        this.setSupportedSoapFragrances(new SoapUtil[] {
                Soap12Util.getInstance(), Soap11Util.getInstance() });

    }

    public void service(HttpServerRequest req, HttpServerResponse res)
            throws HttpServerException {

        String method = req.getMethod();
        final String responseEnc = "UTF-8";
        res.setContentType("text/html; charset=\"" + responseEnc + "\"");

        if ("GET".equalsIgnoreCase(method)) {

            Writer out = new PrintWriter(res.getOutputStream());

            try {
                out.write("<form name=\"input\" action=\"shutdown\" method=\"post\">"
                                + "Shutdown Messenger:"
                                + "<input type=\"Submit\" value=\"ShutDown\">"
                                + "</form>");
                out.write(RunTimeStatistics.getHtmlString());
                out.flush();
            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }else if("post".equalsIgnoreCase(method)){
            System.exit(0);
        }

    }

    private void doGet(String path, String query, HttpServerRequest req,
            HttpServerResponse res) {
        String method = req.getMethod();
        final String responseEnc = "UTF-8";
        res.setContentType("text/html; charset=\"" + responseEnc + "\"");

        if ("GET".equals(method)) {

            Writer out = new PrintWriter(res.getOutputStream());

            try {
                out.write("<form name=\"input\" action=\"shutdown\" method=\"get\">"
                                + "Shutdown Messenger:"
                                + "<input type=\"ShutDown\" value=\"Submit\">"
                                + "</form>");
                out.write(RunTimeStatistics.getHtmlString());
            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }

    }

    public XmlElement processMessage(XmlElement arg0)
            throws DynamicInfosetProcessorException {
        // TODO Auto-generated method stub
        return null;
    }

}

/*
 * Indiana University Extreme! Lab Software License, Version 1.2
 * 
 * Copyright (C) 2004 The Trustees of Indiana University. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 * 
 * 2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 * 
 * 3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 * 
 * "This product includes software developed by the Indiana University Extreme!
 * Lab. For further information please visit http://www.extreme.indiana.edu/"
 * 
 * Alternatively, this acknowledgment may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 * 
 * 4) The name "Indiana University" or "Indiana University Extreme! Lab" shall
 * not be used to endorse or promote products derived from this software without
 * prior written permission from Indiana University. For written permission,
 * please contact http://www.extreme.indiana.edu/.
 * 
 * 5) Products derived from this software may not use "Indiana University" name
 * nor may "Indiana University" appear in their name, without prior written
 * permission of the Indiana University.
 * 
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of any
 * other entity. Indiana University disclaims any liability to any recipient for
 * claims brought by any other entity based on infringement of intellectual
 * property rights or otherwise.
 * 
 * LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 * NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 * INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 * "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 * LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 * GENERATED USING SOFTWARE.
 */

