package wsmg;

import java.net.URI;
import java.net.URISyntaxException;

import org.xmlpull.v1.builder.XmlElement;
import org.xmlpull.v1.builder.XmlInfosetBuilder;
import xsul.MLogger;
import xsul.XmlConstants;
import xsul.soap11_util.Soap11Util;
import xsul.ws_addressing.WsaEndpointReference;
import xsul.ws_addressing.WsaInvoker;

/**
 * <p>
 * Title:
 * </p>
 * <p>
 * Description:
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * <p>
 * Company:
 * </p>
 *
 * @author not attributable
 * @version 1.0
 */

public class NotificationProducer {

    private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;

    private final static MLogger logger = MLogger.getLogger();

    private final WsaInvoker invoker;

    protected final static URI WSN_NOTIFY_URI =
    URI.create(WsmgConstants.WSN_ActionPrefix + "/Notify");
    protected final static URI EXTREME_NOTIF_URI =
    URI.create("http://www.extreme.indiana.edu/WseNotification");

    public NotificationProducer() {
        // super(consumeReference);
        // logger.finest("NotificationConsumerReference:"+builder.serializeToString(consumeReference));
        invoker = new WsaInvoker();
        // invoker.setTargetEPR(resourceEpr);
        invoker.setSoapFragrance(Soap11Util.getInstance());
        //invoker.setIndent("  ");
        invoker.setIndent(null); // disable indenting to improve performance
        // to improve interop do not use KA
        invoker.setUseHttpKeepAlive(false);

    }

    public synchronized void sendNotification(XmlElement notificationMessage,
                                              String type, WsaEndpointReference consumeReference) {
        // try{
        // //
        // System.out.println("########Message="+builder.serializeToString(notificationMessage));
        // // String
        // msqN=notificationMessage.requiredElement(WidgetService.WSNT_NS,"Message").requiredElement(null,"NCSAEvent").attribute("MessageSequenceNumber").getValue();
        // // System.out.println("SequenceNumberInHandleNotify="+msqN);
        // }catch (Exception e){
        // e.printStackTrace();
        // }

        XmlElement message;
        // if(type.compareTo("wsnt")==0){
        // message=builder.newFragment(WsmgConstants.WSNT_NS, "Notify");
        // message.addElement(WsmgConstants.WSNT_NS,
        // "NotificationMessage").addChild(notificationMessage);
        // }else{ //wse
        // try {
        message = notificationMessage;
        // message =(XmlElement) notificationMessage.clone();
        // }
        // catch (CloneNotSupportedException ex1) {
        // ex1.printStackTrace();
        // }
        // message=builder.newFragment(WidgetService.WSNT_NS, "NotifyWSE");
        // message.addChild(notificationMessage);
        // }

        invoker.setMessageId(null);

        // If no action specified in WSE, create a default one
        URI wsaActionUri = "wsnt".equals(type) ? WSN_NOTIFY_URI : EXTREME_NOTIF_URI;
//        try {
			invoker.setDefaultAction(wsaActionUri);
//		} catch (URISyntaxException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}

        // invoker.setDefaultAction(URI.create(message.getNamespace().
        // getNamespaceName() +
        // "/" + message.getName()));
        invoker.setTargetEPR(consumeReference);
//        System.out.println("SENDING NOTIFCATION "
//                + builder.serializeToString(message) + " to "
//                + builder.serializeToString(consumeReference));
        if (logger.isFinestEnabled()) {
            logger.finest("Message Namespace" + message.getNamespace().getNamespaceName());
            logger.finest("SENDING NOTIFCATION "
                          + builder.serializeToString(message) + " to "
                          + builder.serializeToString(consumeReference));
        }
        // System.out.println("BEfore invoke
        // EPR="+builder.serializeToString(getResourceEpr()));
        XmlElement responseMessage = invoker.invokeMessage(message);
        // System.out.println("After invoke
        // EPR="+builder.serializeToString(getResourceEpr()));
        // logger.finest("SUCCESS SENDING NOTIFCATION to
        // "+builder.serializeToString(notificationMessage)
        // +" to "+builder.serializeToString(getResourceEpr()) );

        // assert responseMessage == null
        // logger.finest("\n\nRESPONSE="+Util.safeXmlToString(responseMessage.getRoot())+"\n\n\n");
        // return null; //one way message!

    }
}
