package wsmg;

import javax.jms.Connection;
import javax.jms.DeliveryMode;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.ObjectMessage;
import javax.jms.Session;

import org.activemq.ActiveMQConnectionFactory;

import wsmg.config.WSMGParameter;
import wsmg.processors.DeliveryThread;
import wsmg.processors.OutGoingMessage;
import wsmg.util.Counter;
import wsmg.util.TimerThread;

/**
 * <p>
 * Title:
 * </p>
 * <p>
 * Description:
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * <p>
 * Company:
 * </p>
 * 
 * @author not attributable
 * @version 1.0
 */

public class OutGoingQueue {

    private MessageProducer producer = null;

    private Session session = null;

    private Counter storeToOutQueueCounter;

    public OutGoingQueue() {
        if (WSMGParameter.queueType == WSMGParameter.ACTIVE_MQ_QUEUE) {
            try {
                ActiveMQConnectionFactory connectionFactory = new ActiveMQConnectionFactory(
                        WSMGParameter.OUTGOING_QUEUE_BROKER);

                // Create a Connection
                Connection connection = connectionFactory.createConnection();
                connection.start();

                // Create a Session
                session = connection.createSession(false,
                        Session.AUTO_ACKNOWLEDGE);

                // Create the destination (Topic or Queue)
                Destination destination = session.createQueue("OUTGOING");

                // Create a MessageProducer from the Session to the Topic or
                // Queue
                producer = session.createProducer(destination);
                producer.setDeliveryMode(DeliveryMode.NON_PERSISTENT);
            } catch (Exception e) {
                System.out.println("Caught: " + e);
                e.printStackTrace();
            }
        }
        boolean startDeliveryThreadInBroker=true;
        if(WSMGParameter.enableDeliveryThreadInStandAloneBroker==false 
        		&& WsmgConfig.getBrokerWebServiceStack()==WsmgConstants.BROKER_WEB_SERVICE_STACK_STANDALONE_XSUL){
        	startDeliveryThreadInBroker=false;
        }else if(WSMGParameter.enableDeliveryThreadInTomcatBroker==false 
        		&& (WsmgConfig.getBrokerWebServiceStack()==WsmgConstants.BROKER_WEB_SERVICE_STACK_TOMCAT_AXIS2
        		|| WsmgConfig.getBrokerWebServiceStack()==WsmgConstants.BROKER_WEB_SERVICE_STACK_TOMCAT_XSUL)){
        	startDeliveryThreadInBroker=false;
        }
        if (startDeliveryThreadInBroker) {
            DeliveryThread publisherThread = new DeliveryThread();
            new Thread(publisherThread).start();

            System.out.println("***Delivery Thread started.");
        }
        if (WSMGParameter.measureMessageRate) {
            storeToOutQueueCounter = new Counter();
            TimerThread timerThread = new TimerThread(storeToOutQueueCounter,
                    " StoreToOutQueueCounter");
            new Thread(timerThread).start();
        }

    }

    // need synchronized???
    public void storeNotification(OutGoingMessage outGoingMessage,
            long listenerId, long messageId, boolean showTrace) {

        boolean loop = false;
        do {
            if (WSMGParameter.queueType == WSMGParameter.ACTIVE_MQ_QUEUE) {
                try {
                    ObjectMessage messageOdj = session
                            .createObjectMessage(outGoingMessage);

                    producer.send(messageOdj);
                } catch (JMSException e1) {

                    System.out
                            .println("Error in putting outgoing messages in queue.");
                    e1.printStackTrace();
                }
            } else if (WSMGParameter.queueType == WSMGParameter.EXTREME_QUEUE
                    || WSMGParameter.queueType == WSMGParameter.EXTREME_DISTRIBUTED_QUEUE) {
                WSMGParameter.OUT_GOING_QUEUE.enqueue(outGoingMessage, outGoingMessage.getAdditionalMessageContent().getTrackId());

            }
            if (WSMGParameter.measureMessageRate) {
                storeToOutQueueCounter.addCounter();
            }
            if (WSMGParameter.testOutGoingQueueMaxiumLength
                    && storeToOutQueueCounter.getCounterValue() < 1000000) {
                loop = true;
            }
        } while (loop);

    }
}
