/* -*- mode: Java; c-basic-offset: 4; indent-tabs-mode: nil; -*-  //------100-columns-wide------>|*/
/*
 * Copyright (c) 2004 Extreme! Lab, Indiana University. All rights reserved.
 *
 * This software is open source. See the bottom of this file for the licence.
 *
 * $Id: Server.java,v 1.7 2006/03/18 02:10:06 cherath Exp $
 */

package wsmg;

import org.exolab.jms.util.CommandLine;

import wsmg.config.WSMGParameter;
import wsmg.xsul.XSULDedicatedBrockerService;

/**
 * Implementaiton of Widget service for <a
 * href="http://www-106.ibm.com/developerworks/offers/WS-Specworkshops/ws-rf200404.html">WSRF
 * Interop</a>
 * 
 * @version $Revision: 1.7 $
 * @author <a href="http://www.extreme.indiana.edu/~aslom/">Aleksander Slominski</a>
 */
public class Server {
	/*
	 * private final static MLogger logger = MLogger.getLogger(); private final
	 * static XmlInfosetBuilder builder = XmlConstants.BUILDER;
	 */

	private static WSMGService service;

	// private Server() {}

	public static void main(String[] args) throws Exception {
		WsntClientAPI client = new WsntClientAPI();
		String carrier;
		String carrierLocation;
		int port, rmport;
		CommandLine cmdline = new CommandLine(args);
		// Default port 12345
		port = Integer.parseInt(cmdline.value("port", "12345"));
		rmport = Integer.parseInt(cmdline.value("rmport", "-1"));
		carrier = cmdline.value("carrier", null);
		carrierLocation = cmdline.value("carrierLocation", null);
		boolean wsrmEnabled = rmport!=-1 ? true:false;
		client.startBrokerService(port, carrier, carrierLocation, wsrmEnabled, rmport);
		
	}

	public static void shutdown() {
		if (service != null) {
			System.out.println("Widget shutdown requested");
			service.shutdown();
		}
	}

	public static String getLocation() {
		return service != null ? service.getXsulServer().getServer().getLocation() : null;
	}

}
/*
 * Indiana University Extreme! Lab Software License, Version 1.2
 * 
 * Copyright (C) 2004 The Trustees of Indiana University. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 * 
 * 2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 * 
 * 3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 * 
 * "This product includes software developed by the Indiana University Extreme!
 * Lab. For further information please visit http://www.extreme.indiana.edu/"
 * 
 * Alternatively, this acknowledgment may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 * 
 * 4) The name "Indiana University" or "Indiana University Extreme! Lab" shall
 * not be used to endorse or promote products derived from this software without
 * prior written permission from Indiana University. For written permission,
 * please contact http://www.extreme.indiana.edu/.
 * 
 * 5) Products derived from this software may not use "Indiana University" name
 * nor may "Indiana University" appear in their name, without prior written
 * permission of the Indiana University.
 * 
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of any
 * other entity. Indiana University disclaims any liability to any recipient for
 * claims brought by any other entity based on infringement of intellectual
 * property rights or otherwise.
 * 
 * LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 * NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 * INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 * "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 * LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 * GENERATED USING SOFTWARE.
 */
