package wsmg;

import java.net.URI;
import java.util.Iterator;

import javax.xml.namespace.QName;

import org.xmlpull.v1.builder.XmlElement;
import org.xmlpull.v1.builder.XmlInfosetBuilder;

import wsmg.processors.ConsumerInfo;
import xsul.MLogger;
import xsul.XmlConstants;
import xsul.ws_addressing.WsaEndpointReference;

/**
 * <p>
 * Title:
 * </p>
 * <p>
 * Description:
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * <p>
 * Company:
 * </p>
 * 
 * @author not attributable
 * @version 1.0
 */

public class SubscriptionState {
	private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;

	private final static MLogger logger = MLogger.getLogger();

	public String curNotif;

	private String localTopicString;	
	private String xpathString;
	WsaEndpointReference producerRef;

	WsaEndpointReference consumerReference;

	URI consumerURI = null;

	private OutGoingQueue outGoingQueue;

	private WsmgAdapterConnection wsntAdapterConnection = null;

	private long creationTime = 0;
	
	private int unAvailableCounter=0;

	// public final static XmlNamespace EXTREME_NS = builder.newNamespace(
	// "extreme", "http://extreme.indiana.edu");

	/*
	 * public final static XmlNamespace WSNT_NS = builder.newNamespace( "wsnt",
	 * "http://www.ibm.com/xmlns/stdwip/web-services/WS-BaseNotification");
	 */

	// private boolean useNotify;
	// private String type=null; //Either "wsnt" or "wse"
	// private String consumeReferenceStr=null;
	// private boolean paused;
	ConsumerInfo consumerInfo = null;

	/**
	 * @return Returns the creationTime.
	 */
	public long getCreationTime() {
		return creationTime;
	}

	/**
	 * @param creationTime
	 *            The creationTime to set.
	 */
	public void setCreationTime(long creationTime) {
		this.creationTime = creationTime;
	}

	//TODO: outGoingQueue is not belong to this class. Move it to elsewhere related to notification handler in wsntAdapter. 
	public SubscriptionState(WsaEndpointReference consumeReference,
			boolean useNotify, boolean wsrmEnabled, String topic, String xpath,
			WsaEndpointReference producerRef, String type,
			OutGoingQueue outGoingQueue) {
		this.consumerReference = consumeReference;
		consumerURI = consumeReference.getAddress();
		this.outGoingQueue = outGoingQueue;
//		if (topic == null) {
//			throw new IllegalArgumentException();
//		}
		this.localTopicString = topic;
		this.xpathString=xpath;
		this.producerRef = producerRef;
		consumerInfo = new ConsumerInfo();
		consumerInfo.setUseNotify(useNotify);
        consumerInfo.setWsrmEnabled(wsrmEnabled);
		consumerInfo.setType(type);
		String consumeReferenceStr = builder
				.serializeToString(consumeReference);
		consumerInfo.setConsumerEprStr(consumeReferenceStr);
	}

	public void resume() {
		consumerInfo.setPaused(false);
	}

	public void pause() {
		consumerInfo.setPaused(true);
	}

	/*
	 * public void sendNotification(String rawNotif){ //TODO: add support to
	 * string only message
	 *  } public void sendNotification(XmlElement rawNotif){
	 *  }
	 */

	// /**if pure String,
	// if WSNT and UseNotify: ==><wsnt:message>test message</wsnt:Message>
	// if WSE or UseNotify=false ==><widget:TestNotification>test
	// message</widget:TestNotification>
	// if String is and Xml (starts with <)
	// if WSNT and UseNotify: =><wsnt:message>String message</wsnt:Message>
	// if WSE or UseNotify=false =>keep the Xml.
	// */
	// public static XmlElement convertStringMessageToXmlElement(String
	// message,boolean useNotify){
	// XmlElement messageToNotify=null;
	// if(message.trim().startsWith("<")){ //Message is an XML Element
	// XmlElement messageEl = builder.parseFragmentFromReader(new
	// StringReader(message));
	// if(useNotify){
	// messageToNotify=builder.newFragment(WsmgConstants.WSNT_NS, "Message");
	// messageToNotify.addChild(messageEl); //add XmlElement
	// }else{
	// messageToNotify=messageEl;
	// }
	// return messageToNotify;
	// }
	// //Pure String
	// if(useNotify){
	// messageToNotify=builder.newFragment(WsmgConstants.WSNT_NS, "Message");
	// messageToNotify.addChild(message); //add a string
	// }else{
	// messageToNotify = builder.newFragment(EXTREME_NS,
	// "StringNotification");
	// // messageToNotify.declareNamespace(WidgetService.WIDGET_NS);
	// messageToNotify.addChild(message);
	// }
	// return messageToNotify;
	// }
	// public void sendNotification(String rawNotif)
	// // throws SoapFault //FIXME
	// {
	// XmlElement
	// messageToNotify=convertStringMessageToXmlElement(rawNotif,useNotify);
	// curNotif = messageToNotify;
	// if (paused) {
	// return;
	// }
	// /* if(rawNotif.trim().startsWith("<")){ //Message is an XML Element
	// messageToNotify = builder.parseFragmentFromReader(new
	// StringReader(rawNotif));
	// }*/
	//
	// if (useNotify) {
	// XmlElement notificationMessage =
	// builder.newFragment(WsmgConstants.WSNT_NS,
	// "NotificationMessage");
	// notificationMessage.addChild(topic);
	// notificationMessage.addChild(producerRef);
	// notificationMessage.addElement(messageToNotify);
	//               
	// notifProducer.storeNotification(notificationMessage,"wsnt",
	// consumeReference);
	// }
	// else { //useNotify=false
	// //Since xsul invoker needs XmlElement to invoke, convert a pure String to
	// and XmlElement by adding an element tag.
	// notifProducer.storeNotification(messageToNotify,"wsnt",
	// consumeReference);
	// }
	// }
	//
	// public void sendNotificationByBroker(XmlElement fullNotif)
	// // throws SoapFault //FIXME
	// {
	// //Average time for delivery message to an available consumer is 24.18ms
	// //while to an unavailable consumer it takes 1007.46ms to timeout
	// curNotif = fullNotif;
	// long startTime=0;
	// logger.finest("#Sending message: UseNotify="+useNotify );
	// if (paused) {
	// return;
	// }
	// try {
	// startTime=System.currentTimeMillis();
	// if(type.compareTo("wsnt")==0){
	// if (useNotify) {
	// /* XmlElement notificationMessage = builder.newFragment(WSNT_NS,
	// "NotificationMessage");
	// notificationMessage.addChild(topic);
	// notificationMessage.addChild(producerRef);
	// notificationMessage.addElement(WSNT_NS, "Message").addChild(rawNotif);*/
	// notifProducer.storeNotification(fullNotif,type,consumeReference);
	// }
	// else {
	// XmlElement rawNotif = fullNotif.element(WsmgConstants.WSNT_NS,
	// "Message");
	// notifProducer.storeNotification(rawNotif,type, consumeReference);
	// }
	// }else{ //WSE all messages are raw messages
	// logger.info("FullNotif="+builder.serializeToString(fullNotif));
	// XmlElement rawNotif =(XmlElement)
	// fullNotif.element(WsmgConstants.WSNT_NS,
	// "Message").requiredElementContent().iterator().next();
	// logger.info(xsul.util.XsulUtil.safeXmlToString(rawNotif));
	// notifProducer.storeNotification(rawNotif,type, consumeReference);
	// long finishTime=System.currentTimeMillis();
	// // System.out.println((finishTime-startTime)+" sent");
	// }
	// }
	// catch (DynamicInfosetInvokerException ex) {
	// //Catch the RunTime exception. If the broker cannot connect to a client,
	// just ignore it.
	// //TODO: Not reliable!!!!
	//
	// long finishTime=System.currentTimeMillis();
	// // System.out.println((finishTime-startTime)+" failed");
	// // System.out.println("Cannot connect to the
	// client"+getConsumerAddress()+" in "+(finishTime-startTime)+"!!!!");
	//
	// }
	// }
	public String getConsumerIPAddressStr() {
		return consumerURI.toString();
	}

	public URI getConsumerAddressURI() {
		return consumerURI;
	}

	public String getLocalTopic() {
//		QName topicExpressionQName = xsul.util.XsulUtil.toQName(localTopicString, localTopicString
//				.requiredTextContent());
//		String topicLocalString = topicExpressionQName.getLocalPart();
		return localTopicString;
	}

	public String getReferenceProperty() {
		// XmlElement consumerReferencePropertiesEl =
		// notifConsumer.getResourceEpr().element(
		// WidgetService.WSA_NS, "ReferenceProperties");
		// logger.finest(builder.serializeToString("ConsumerReferenceProperties="+consumerReferencePropertiesEl));
		// String consumerReferenceProperties;
		// if (consumerReferencePropertiesEl == null ||
		// !consumerReferencePropertiesEl.hasChildren()) {
		// consumerReferenceProperties = "";
		// }
		// else {
		// Iterator i =
		// consumerReferencePropertiesEl.requiredElementContent().iterator();
		// if(i.hasNext()) {
		// consumerReferenceProperties = ( (XmlElement)
		// (i.next())).requiredTextContent();
		// } else {
		// consumerReferenceProperties = "";
		// }
		WsaEndpointReference epr = consumerReference;
		XmlElement consumerReferencePropertiesEl = epr.element(null,
				"ReferenceProperties");

//		if (logger.isFinestEnabled())
//			logger.finest("notifConsumer.getResourceEpr()="
//					+ builder.serializeToString(epr));
		String consumerReferenceProperties = null;
		if (consumerReferencePropertiesEl != null) {
			// logger.finest("ConsumerReferenceProperties="+builder.serializeToString(consumerReferencePropertiesEl));
			Iterator i = consumerReferencePropertiesEl.requiredElementContent()
					.iterator();
			// XSUL invoker adds an empty referenceproperties tag after invoke
			// (in NotificationConsumer.java) This check if used to filter out
			// it
			if (i.hasNext()) {
				consumerReferenceProperties = ((XmlElement) (i.next()))
						.requiredTextContent();
			}
		}

		// XmlElement consumerReferencePropertyEl =
		// epr.getReferenceProperty(null, null);
		// String consumerReferenceProperties = null;
		// if(consumerReferencePropertyEl != null) {
		// consumerReferenceProperties =
		// consumerReferencePropertyEl.requiredTextContent();
		// }
		return consumerReferenceProperties;

	}

	public WsmgAdapterConnection getWsntAdapterConnection() {
		return wsntAdapterConnection;
	}

	public void setWsntAdapterConnection(
			WsmgAdapterConnection wsntAdapterConnection) {
		this.wsntAdapterConnection = wsntAdapterConnection;
	}

	/**
	 * @return Returns the consumeReference.
	 */
	public WsaEndpointReference getConsumerReference() {
		return consumerReference;
	}

	/**
	 * @return Returns the curNotif.
	 */
	public String getCurNotif() {
		return curNotif;
	}

	/**
	 * @param curNotif
	 *            The curNotif to set.
	 */
	public void setCurNotif(String curNotif) {
		this.curNotif = curNotif;
	}

	/**
	 * @return Returns the outGoingQueue.
	 */
	public OutGoingQueue getOutGoingQueue() {
		return outGoingQueue;
	}

	/**
	 * @param outGoingQueue
	 *            The outGoingQueue to set.
	 */
	public void setOutGoingQueue(OutGoingQueue outGoingQueue) {
		this.outGoingQueue = outGoingQueue;
	}


	/**
	 * @return Returns the consumerInfo.
	 */
	public ConsumerInfo getConsumerInfo() {
		return consumerInfo;
	}
	
	public void resetUnAvailableCounter(){
		unAvailableCounter=0;
	}
	
	public int addUnAvailableCounter(){
		unAvailableCounter++;
		return unAvailableCounter;
	}

	/**
	 * @return Returns the unAvailableCounter.
	 */
	public int getUnAvailableCounter() {
		return unAvailableCounter;
	}

	public String getXpathString() {
		return xpathString;
	}

	public void setXpathString(String xpathString) {
		this.xpathString = xpathString;
	}
	
	

}
