package wsmg;

/**
 * <p>
 * Title: WSNT Project
 * </p>
 * <p>
 * Description:
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * <p>
 * Company:
 * </p>
 * 
 * @author Yi Huang
 * @version 1.0
 */
/*
 * import edu.indiana.extreme.rfx.types.base_types.addressing.
 * EndpointReferenceType; import
 * edu.indiana.extreme.rfx.types.base_types.notification.*;
 */
/*
 * import xsul.types_wsnt.base.*; import xsul.types_wsnt.broker.*; import
 * xsul.types_wsnt.topics.*; import xsul.types_wsrf.properties.*; import
 * xsul.types_addressing.*;
 */

// import java.util.Hashtable;
import java.util.Calendar;
import java.util.Map;
import java.util.Random;
import java.util.TimeZone;

import wsmg.processors.AdditionalMessageContent;

// import org.apache.xmlbeans.XmlException;

public abstract class WsmgAdapter {

	protected Map subscriptionDB;

	protected Map currentMessageCache;

	protected Map publisherRegistrationDB;

	public WsmgAdapter(Map subscriptionDB, Map publisherRegistrationDB) {
		this.subscriptionDB = subscriptionDB;
		this.publisherRegistrationDB = publisherRegistrationDB;
	}

	public abstract void start(String carrierLocation);

	// Message can be either String or XmlElement. Added XMLElement for
	// performance consideration so that if not using queue,
	// we don't need to serialize to String
	// If we already serialized to String becaused of the uing queue, we don't
	// have to change back to XMLElement until the delivery to consumers
	public abstract void handleNotify(String topic, // Needs to change to more
													// generic type
			AdditionalMessageContent soapHeader, // XmlElement or String
			Object message, // XmlElement or String
			String wsntMessageConverterClassName);

	public abstract int handleUnsubscribe(String subscriptionId);

	public abstract WsmgAdapterConnection handleSubscribe(
			SubscriptionState subscribeRequest, String subscriptionId);

	public String handleGetCurrentMessage(String topic) {
		String currentMessage = (String) currentMessageCache.get(topic);
		return currentMessage;
	}

	/*
	 * public int notifySubscriber(XmlElement notificationMessage) throws
	 * Exception { return 0; }
	 */

	public static String generateResourceId() {
		/**
		 * Create a unique resourceID for each resource. Format:
		 * currentTime__randomNumber e.g. resourceID=2004-03-17 16:54:44_4417
		 */
		Calendar cal = Calendar.getInstance(TimeZone.getDefault());
		String DATE_FORMAT = "yyyy-MM-dd HH:mm:ss";
		java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
				DATE_FORMAT);
		// random number between 0 AND 100000
		Random r = new Random();
		int randInt = Math.abs(r.nextInt()) % 100000;
		String subscriptionId = sdf.format(cal.getTime()) + "_" + randInt;
		return subscriptionId;
	}

}
