/*
 * Created on 2005-9-1
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package wsmg;

import java.net.URI;
import java.util.HashMap;
import java.util.Map;

import wsmg.adapter.XPath.YFilterAdapter;
import wsmg.adapter.simpleTopic.Direct_WsntAdapter;
import wsmg.config.WSMGParameter;
import wsmg.jms.JMS_WsntAdapter;

/**
 * @author yihuan
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class WsmgConfig {
	private boolean hasCarrier = false;

	private WsmgAdapter wsntAdapter;

	private Map subscriptions = new HashMap(); // JDK15
												// Map<String,SubscriptionState>

	private Map publisherRegistrationDB = new HashMap();
	
	/**
	 * This is the port that Axis2 or XSUL simple HTTPServers will be running if at all;
	 */
	private int port = 12345;
	
	/**
	 * This will be the Default port for WSRM.
	 */
	private int rmport = 8888;
	
	/**
	 * THis will bring a WSRM endpoint up in the brocker.
	 */
	private boolean wsrmEnabled = false;
	
	/**
	 * What mode is it running. 
	 * XSUL
	 * Axis2
	 * Is it in or out of TOMCAT
	 */
	private static int brokerWebServiceStack = WsmgConstants.BROKER_WEB_SERVICE_STACK_STANDALONE_XSUL;
	
	/**
	 * In which epr is the service running.
	 */
	private URI serviceLocation;

	/**
	 * @return Returns the hasCarrier.
	 */
	public boolean isHasCarrier() {
		return hasCarrier;
	}

	/**
	 * @return Returns the publisherRegistrationDB.
	 */
	public Map getPublisherRegistrationDB() {
		return publisherRegistrationDB;
	}

	/**
	 * @return Returns the subscriptions.
	 */
	public Map getSubscriptions() {
		return subscriptions;
	}

	/**
	 * @return Returns the wsntAdapter.
	 */
	public WsmgAdapter getWsntAdapter() {
		return wsntAdapter;
	}
	public  WsmgConfig(){
		setDirectFilter();		
	}

	public  WsmgConfig(String carrier, String carrierLocation) {
		// subscriptionDB = new Hashtable();
		// publisherRegistrationDB=new Hashtable();
		if (carrier == null) {			
			setDirectFilter();
		} else {
			hasCarrier = true;
			wsntAdapter = new JMS_WsntAdapter(subscriptions,
					publisherRegistrationDB, carrier);

			// wsntAdapter = new JMS_WsntAdapter(null, publisherRegistrationDB,
			// carrier);
			wsntAdapter.start(carrierLocation);
		}
	}
	
	private void setDirectFilter(){
		hasCarrier = false;
		//TODO Check y the Adaptor needs the carrier
		if(WSMGParameter.useYFilter){
			wsntAdapter = new YFilterAdapter(subscriptions,
					publisherRegistrationDB);
		}else{
		wsntAdapter = new Direct_WsntAdapter(subscriptions,
				publisherRegistrationDB, null);
		}		
	}

	public int getPort() {
		return port;
	}

	public void setPort(int port) {
		this.port = port;
	}

	public int getRmport() {
		return rmport;
	}

	public void setRmport(int rmport) {
		this.rmport = rmport;
	}

	public boolean isWsrmEnabled() {
		return wsrmEnabled;
	}

	public void setWsrmEnabled(boolean wsrmEnabled) {
		this.wsrmEnabled = wsrmEnabled;
	}

	public static int getBrokerWebServiceStack() {
		return brokerWebServiceStack;
	}

	public void setBrokerWebServiceStack(int brokerWebServiceStack) {
		this.brokerWebServiceStack = brokerWebServiceStack;
	}

	public URI getServiceLocation() {
		return serviceLocation;
	}

	public void setServiceLocation(URI serverLocation) {
		this.serviceLocation = serverLocation;
	}
	
	

}
