package wsmg.adapter;

import java.util.HashMap;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.xmlpull.v1.builder.XmlElement;
import org.xmlpull.v1.builder.XmlInfosetBuilder;

import wsmg.NotificationProducerForBroker;
import wsmg.OutGoingQueue;
import wsmg.SubscriptionState;
import wsmg.WsmgAdapter;
import wsmg.WsmgAdapterConnection;
import wsmg.config.WSMGParameter;
import wsmg.measure.profile.RunTimeStatistics;
import wsmg.processors.AdditionalMessageContent;
import wsmg.processors.OutGoingMessage;
import wsmg.util.Counter;
import wsmg.util.TimerThread;
import xsul.MLogger;
import xsul.XmlConstants;

public class CommonSubscriptionProcessing extends WsmgAdapter{
	protected final static XmlInfosetBuilder builder = XmlConstants.BUILDER;

//	protected Map token2ConsumerListMap = new HashMap();
//
//	protected Map subId2Token = new HashMap();

	protected final static MLogger logger = MLogger.getLogger();

	protected Counter publisherCounter = new Counter();

	protected long listenerId = 0;

	protected OutGoingQueue outGoingQueue = null;

	protected long messageId = 0;

	private NotificationProducerForBroker notificationProducerForBroker = null;

	public CommonSubscriptionProcessing(Map subscriptionDB, Map publisherRegistrationDB) {
		super(subscriptionDB, publisherRegistrationDB);
		if (WSMGParameter.measureMessageRate) {
			TimerThread timerThread = new TimerThread(publisherCounter,
					" PublisherCounter");
			new Thread(timerThread).start();
		}
	}

	public CommonSubscriptionProcessing(Map subscriptionDB, Map publisherRegistrationDB,
			String carrier) {
		super(subscriptionDB, publisherRegistrationDB);
		if (WSMGParameter.measureMessageRate) {
			TimerThread timerThread = new TimerThread(publisherCounter,
					" PublisherCounter");
			new Thread(timerThread).start();
		}
	}

	public void start(String carrierLocation) {

		currentMessageCache = new Hashtable();
	}

	public WsmgAdapterConnection handleSubscribe(SubscriptionState subscribeRequest,
			String subscriptionId) {

		return null;

	}
//	//token can be a topic or an XPath String
//	protected void addToConsumerList(String token,
//			SubscriptionState subscribeRequest, String subscriptionId) {
//		ConsumerList consumerList = (ConsumerList) token2ConsumerListMap
//				.get(token);
//		if (consumerList == null) { // new topic
//			consumerList = new ConsumerList();
//			token2ConsumerListMap.put(token, consumerList);
//		}
//		consumerList.addConsumer(subscriptionId, subscribeRequest
//				.getConsumerInfo());
//		subId2Token.put(subscriptionId, token);
//		// System.out.println("*************Put
//		// in:"+subscriptionId+"-->"+topicExpression);
//		if (outGoingQueue == null) {
//			outGoingQueue = subscribeRequest.getOutGoingQueue();
//		}
//	}

	public int handleUnsubscribe(String subscriptionId) {
		return 0;
	}
	
//	public int removeFromConsumerList(String subscriptionId){
//		String topicExpression = (String) subId2Token.get(subscriptionId);
//		// System.out.println("*************Topic to delete:"+topicExpression);
//		ConsumerList consumerList = (ConsumerList) token2ConsumerListMap
//				.get(topicExpression);
//		if (consumerList == null) {
//			System.out
//					.println("*****ERROR:Cannot find the subscriptionId to delete: "
//							+ subscriptionId);
//			return -1;
//		}
//		consumerList.removeConsumer(subscriptionId);
//		return 0;
//	}
	
	
	public void handleNotify(String topic, 
AdditionalMessageContent soapHeader, Object message,
String wsntMessageConverterClassName) {	
	}

	/*
	 * passing three different form of message objects in order to avoid unnecessary parsing or serialization.
	 */
	protected void sendNotificationToConsumers(List consumerInfoList,XmlElement messageEl,String messageString,Object message, AdditionalMessageContent additionalMessageContent){
//		XmlElement messageEl;
//		String messageString = null;
		boolean isXmlElement=false;
		//		System.out.println("*****Total Consumer="+consumerInfoList.size());
        if(consumerInfoList.size()==0) //No subscription
        	 return; 
//		if (message instanceof XmlElement) {
//			isXmlElement = true;
//		} else if (message instanceof String) {
//			isXmlElement = false;
//		} 
		long listenerId = 0;
		messageId++;
		boolean showTrace = false;
		if (WSMGParameter.useOutGoingQueue) { // Use outgoing queue
			if (messageString==null) {
				messageEl = (XmlElement) message;
				messageString = builder.serializeToString(messageEl);
			} 
			RunTimeStatistics.addNewNotificationMessageSize(messageString.length());
			OutGoingMessage outGoingMessage = new OutGoingMessage();
			outGoingMessage.setTextMessage(messageString);
			outGoingMessage.setConsumerInfoList(consumerInfoList);
			outGoingMessage.setAdditionalMessageContent(additionalMessageContent);
			outGoingQueue.storeNotification(outGoingMessage, listenerId,
					messageId, showTrace);
			if(WSMGParameter.showTrackId)
			System.out.println(additionalMessageContent.getTrackId()+": putIn Outgoing queue.");
		} else { // Not use outgoing queue
			if (notificationProducerForBroker == null) {
				notificationProducerForBroker = new NotificationProducerForBroker();
			}
			// send the notifications by broker
			if (messageEl!=null) {
				messageEl = (XmlElement) message;
				notificationProducerForBroker.deliverMessage(consumerInfoList,
						messageEl, additionalMessageContent);
			} else {
				messageString = (String) message;
				notificationProducerForBroker.deliverMessage(consumerInfoList,
						messageString, additionalMessageContent);
			}
		}		
	}

}
