package wsmg.adapter;

import java.util.ArrayList;
import java.util.HashMap;

import wsmg.processors.ConsumerInfo;

public class ConsumerList {
	HashMap subId2ConsumerInfo = new HashMap();

	ArrayList consumerInfoList = new ArrayList();

	boolean changed = true;
	int size=0;  //use size instead of consumerInfoList.size() to avoid unnecessary copy of subId2ConsumerInfo in refreshConsumerInfoList() if just need the size

	public void addConsumer(String subId, ConsumerInfo consumerInfo) {
		subId2ConsumerInfo.put(subId, consumerInfo);
		changed = true;
		size++;
	}

	public int removeConsumer(String subId) {
		Object result=subId2ConsumerInfo.remove(subId);
		if(result==null){
			return 0;
		}else{
		changed = true;
		size--;
		return 1;
		}
	}

	public ArrayList getConsumerList() {
		if (changed) {
			refreshConsumerInfoList();
		}
		return consumerInfoList;
	}
	
	public int size(){
		return size;
	}
	
	private void refreshConsumerInfoList(){
		consumerInfoList.clear();
		consumerInfoList.addAll(subId2ConsumerInfo.values());
		changed = false;		
	}

}
