package wsmg.adapter;

import java.util.HashMap;
import java.util.Map;

import wsmg.SubscriptionState;

public class ConsumerListManager {
	protected Map token2ConsumerListMap = new HashMap();

	protected Map subId2Token = new HashMap();
	
	//token can be a topic or an XPath String
	public void addToConsumerList(String token,
			SubscriptionState subscribeRequest, String subscriptionId) {
		ConsumerList consumerList = (ConsumerList) token2ConsumerListMap
				.get(token);
		if (consumerList == null) { // new topic
			consumerList = new ConsumerList();
			token2ConsumerListMap.put(token, consumerList);
		}
		consumerList.addConsumer(subscriptionId, subscribeRequest
				.getConsumerInfo());
		subId2Token.put(subscriptionId, token);
		// System.out.println("*************Put
		// in:"+subscriptionId+"-->"+topicExpression);
//		if (outGoingQueue == null) {
//			outGoingQueue = subscribeRequest.getOutGoingQueue();
//		}
	}
	
	public String getTokenBySubscriptionId(String subscriptionId){
		String token = (String) subId2Token.get(subscriptionId);
		return token;
	}
	
	public int removeFromConsumerList(String subscriptionId, String token){
		String tokenString=null;
		if(token==null){
			tokenString = (String) subId2Token.get(subscriptionId);
		}else{
			tokenString=token;
		}
		// System.out.println("*************Topic to delete:"+topicExpression);
		ConsumerList consumerList = (ConsumerList) token2ConsumerListMap
				.get(tokenString);
		if (consumerList == null) {
			System.out
					.println("*****ERROR:Cannot find the token to delete: "
							+ tokenString);
			return 0;
		}
		int result=consumerList.removeConsumer(subscriptionId);
		subId2Token.remove(subscriptionId);
		return result;
	}
	
	public ConsumerList getConsumerListByToken(String token){
		ConsumerList consumerList = (ConsumerList) token2ConsumerListMap.get(token);	
		return consumerList;
	}
	
}
