/**
 * YFilterAdapter.java
 * @author Yi Huang (yihuan@cs.indiana.edu)
 * Created:Mar 28, 2006 7:34:35 PM
 */

/*
Some code adapted from apache pubscribe project's SubscriptionHome.java
*/

package wsmg.adapter.XPath;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.xmlpull.v1.builder.XmlElement;
import org.xmlpull.v1.builder.XmlInfosetBuilder;

import edu.berkeley.cs.db.yfilter.filter.EXfilterBasic;
import edu.berkeley.cs.db.yfilter.filter.SystemGlobals;
import edu.berkeley.cs.db.yfilterplus.queryparser.Query;
import edu.berkeley.cs.db.yfilterplus.queryparser.XPQuery;
import edu.berkeley.cs.db.yfilterplus.xmltree.XMLTree;

import wsmg.SoapClientFault;
import wsmg.SubscriptionState;
import wsmg.WsmgAdapter;
import wsmg.WsmgAdapterConnection;
import wsmg.WsmgConstants;
import wsmg.adapter.CommonSubscriptionProcessing;
import wsmg.adapter.ConsumerList;
import wsmg.adapter.ConsumerListManager;
import wsmg.config.WSMGParameter;
import wsmg.processors.AdditionalMessageContent;
import xsul.XmlConstants;

public class YFilterAdapter extends CommonSubscriptionProcessing {
	private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;
//	EXfilterBasic yfilter    = new EXfilterBasic();
	public int c = 0;
	
	//   private HashMap subIdToQuery=new HashMap();
	//   private HashMap yFilterIdToXPath=new HashMap();
	   private HashMap topicToYFilterInfo=new HashMap();
	   private HashMap subIdToTopic=new HashMap();
	  // private Map xpath2ConsumerListMap = new HashMap();
	   
//	 used for topic only subscription, so that we don't have to create a YFilter object
	private ConsumerListManager consumerListmanager=new ConsumerListManager();  
	   private String[]          queries= new String[1000000];	
	public YFilterAdapter(Map subscriptionDB, Map publisherRegistrationDB) {
		super(subscriptionDB, publisherRegistrationDB);
		// TODO Auto-generated constructor stub
	}

	public void start(String carrierLocation){
		
	}

	// Message can be either String or XmlElement. Added XMLElement for
	// performance consideration so that if not using queue,
	// we don't need to serialize to String
	// If we already serialized to String becaused of the uing queue, we don't
	// have to change back to XMLElement until the delivery to consumers
	public void handleNotify(String topic, // Needs to change to more
													// generic type
			AdditionalMessageContent soapHeader, // XmlElement or String
			Object message, // XmlElement or String
			String wsntMessageConverterClassName){
		XmlElement messageEl=null;
		String messageString = null;

		if (message instanceof XmlElement) {
			messageEl = (XmlElement) message;
			messageString = builder.serializeToString(messageEl);
		} else if (message instanceof String) {
			messageString = (String) message;
		} else {
			System.out.println("ERROR: Invalid message type, must be be either XmlElement or String.");
			return;
		}
		if(WSMGParameter.debugYFilter)
		System.out.println("Message In YFilterAdapter="+messageString);

		List allConsumerInfoList=new LinkedList();
		//1, Topic only
		ConsumerList topicConsumerList = consumerListmanager.getConsumerListByToken(topic);		
		if (topicConsumerList != null) {// has subscription to this topic
//			System.out.println("ConsumerListSize1="+topicConsumerList.getConsumerList().size());
			allConsumerInfoList.addAll(topicConsumerList.getConsumerList());
		}
		//2, wild card topic only
		ConsumerList wildcardConsumerList = consumerListmanager.getConsumerListByToken(WsmgConstants.WILDCARD_TOPIC);
		if (wildcardConsumerList != null) {// has wildcard subscriptions 		
		    List wildCardConsumerInfoList = wildcardConsumerList.getConsumerList();
		    if(wildCardConsumerInfoList!=null){
//				System.out.println("ConsumerListSize2="+wildCardConsumerInfoList.size());
		    	allConsumerInfoList.addAll(wildCardConsumerInfoList);
		    }
		}
		//3, topic with Xpath
		YFilterInfo yfilterInfo=(YFilterInfo)topicToYFilterInfo.get(topic); 
		if(yfilterInfo!=null){
			List topicAndXPathConsumerInfoList=yfilterInfo.getMatchingConsumerList(messageString);
			if(topicAndXPathConsumerInfoList!=null){
//				System.out.println("ConsumerListSize3="+topicAndXPathConsumerInfoList.size());
				allConsumerInfoList.addAll(topicAndXPathConsumerInfoList);
			}
		}
		//4, wild card topic with Xpath (XPath only)
		yfilterInfo=(YFilterInfo)topicToYFilterInfo.get(WsmgConstants.WILDCARD_TOPIC); 
		if(yfilterInfo!=null){
		List wildcardTopicAndXPathConsumerInfoList=yfilterInfo.getMatchingConsumerList(messageString);
		if(wildcardTopicAndXPathConsumerInfoList!=null){
//			System.out.println("ConsumerListSize4="+wildcardTopicAndXPathConsumerInfoList.size());
			allConsumerInfoList.addAll(wildcardTopicAndXPathConsumerInfoList);
		}
		}

		
//        XMLTree tree = new XMLTree( new java.io.StringReader(messageString) );
//        tree.print();
//        yfilter.setEventSequence( tree.getEvents(  ) );
//        yfilter.startParsing(  );
//
//        // print the matched queries //
//        if ( SystemGlobals.hasQueries )
//        {
//           yfilter.printQueryResults( System.out );
//        }
//        else
//        {
//           System.out.println( "no match" );
//        }
//
//        //get matches
//		
//        java.util.Iterator it = yfilter.getMatchedQueries(  ).iterator(  );
//        while ( it.hasNext(  ) )
//        {
//           Integer      qid = (Integer) it.next(  );
//    //       String       sid = queries[qid.intValue(  )];
//           System.out.println("qid="+qid);
//        //   System.out.println("sid="+sid);
//           //notify matches
////           LOG.info( "notify : " + sid );
////           s.getNotificationConsumer(  ).notify( s,
////                                                 env.getBody(  ) );
//
//		String xpath=(String)yFilterIdToXPath.get(qid);
////		int totalXPath=token2ConsumerListMap.keySet().size();
////		System.out.print("TotalXPath="+totalXPath);
//		ConsumerList consumerList = (ConsumerList) token2ConsumerListMap
//				.get(xpath);
////		ConsumerList wildcardConsumerList = (ConsumerList) xpath2ConsumerListMap
////		.get(">");
//		if (consumerList != null) {// has subscription to this topic
//		  consumerInfoList.addAll(consumerList.getConsumerList());
//		}
//        }
//        yfilter.clear();		
        sendNotificationToConsumers(allConsumerInfoList,messageEl,messageString, message, soapHeader);
	}

	public int handleUnsubscribe(String subscriptionId){
		String topicExpression=(String)subIdToTopic.get(subscriptionId);
		if(subscriptionId.startsWith("T")){  //Topic only
		consumerListmanager.removeFromConsumerList(subscriptionId,topicExpression);
		}else{
		YFilterInfo yfilterInfo=(YFilterInfo)topicToYFilterInfo.get(topicExpression); 
		if(yfilterInfo!=null){
		 yfilterInfo.removeSubscription(subscriptionId);
		 if(yfilterInfo.getCounter()==0){
			 yfilterInfo=null;
			 topicToYFilterInfo.remove(topicExpression); 
		 }
		}else{
			System.out.println("ERROR: Cannot find subscription with the subId="+subscriptionId);
			return 0;
		}
		}
		return 1;
	 }

	public WsmgAdapterConnection handleSubscribe(
			SubscriptionState subscribeRequest, String subscriptionId){
		String topicExpression=subscribeRequest.getLocalTopic();
		subIdToTopic.put(subscriptionId,topicExpression);
		
		String xpathExpression=subscribeRequest.getXpathString();
		if (xpathExpression == null || xpathExpression.length() == 0) { // Topic only
			consumerListmanager.addToConsumerList(topicExpression,
					subscribeRequest, subscriptionId);
		} else {
			YFilterInfo yfilterInfo = (YFilterInfo) topicToYFilterInfo
					.get(topicExpression);
			if (yfilterInfo == null) {
				yfilterInfo = new YFilterInfo();
				topicToYFilterInfo.put(topicExpression, yfilterInfo);
			}
			yfilterInfo.addXPathQuery(xpathExpression, subscriptionId,
					subscribeRequest);
		}
//	     c++;
//       // xpathExpression="/*[@x=\"aaabbb\"]";
//        System.out.println("QueryExp="+ xpathExpression);
//        Query query = XPQuery.parseQuery( xpathExpression, c );
//        System.out.println( "addSubscription " + xpathExpression + " query :" + query );
//        int yFilterId=yfilter.addQuery( query );
//        System.out.println("YFilterId="+yFilterId);
//        subIdToQuery.put(subscriptionId, query);	
//        yFilterIdToXPath.put(yFilterId,xpathExpression);
//        yfilter.printQueryIndex();        
//		addToConsumerList(xpathExpression, subscribeRequest, subscriptionId);	
		if (outGoingQueue == null) {
			outGoingQueue = subscribeRequest.getOutGoingQueue();
		}
		return null;
	}


	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}


/*
 * Indiana University Extreme! Lab Software License, Version 1.2
 *
 * Copyright (c) 2002-2004 The Trustees of Indiana University.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1) All redistributions of source code must retain the above
 *    copyright notice, the list of authors in the original source
 *    code, this list of conditions and the disclaimer listed in this
 *    license;
 *
 * 2) All redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the disclaimer
 *    listed in this license in the documentation and/or other
 *    materials provided with the distribution;
 *
 * 3) Any documentation included with all redistributions must include
 *    the following acknowledgement:
 *
 *      "This product includes software developed by the Indiana
 *      University Extreme! Lab.  For further information please visit
 *      http://www.extreme.indiana.edu/"
 *
 *    Alternatively, this acknowledgment may appear in the software
 *    itself, and wherever such third-party acknowledgments normally
 *    appear.
 *
 * 4) The name "Indiana University" or "Indiana University
 *    Extreme! Lab" shall not be used to endorse or promote
 *    products derived from this software without prior written
 *    permission from Indiana University.  For written permission,
 *    please contact http://www.extreme.indiana.edu/.
 *
 * 5) Products derived from this software may not use "Indiana
 *    University" name nor may "Indiana University" appear in their name,
 *    without prior written permission of the Indiana University.
 *
 * Indiana University provides no reassurances that the source code
 * provided does not infringe the patent or any other intellectual
 * property rights of any other entity.  Indiana University disclaims any
 * liability to any recipient for claims brought by any other entity
 * based on infringement of intellectual property rights or otherwise.
 *
 * LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH
 * NO WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA
 * UNIVERSITY GIVES NO WARRANTIES AND MAKES NO REPRESENTATION THAT
 * SOFTWARE IS FREE OF INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR
 * OTHER PROPRIETARY RIGHTS.  INDIANA UNIVERSITY MAKES NO WARRANTIES THAT
 * SOFTWARE IS FREE FROM "BUGS", "VIRUSES", "TROJAN HORSES", "TRAP
 * DOORS", "WORMS", OR OTHER HARMFUL CODE.  LICENSEE ASSUMES THE ENTIRE
 * RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR ASSOCIATED MATERIALS,
 * AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION GENERATED USING
 * SOFTWARE.
 */
