package wsmg.adapter.XPath;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;

import wsmg.SoapClientFault;
import wsmg.SubscriptionState;
import wsmg.adapter.ConsumerList;
import wsmg.adapter.ConsumerListManager;
import wsmg.config.WSMGParameter;

import edu.berkeley.cs.db.yfilter.filter.EXfilterBasic;
import edu.berkeley.cs.db.yfilter.filter.SystemGlobals;
import edu.berkeley.cs.db.yfilterplus.queryparser.Query;
import edu.berkeley.cs.db.yfilterplus.queryparser.XPQuery;
import edu.berkeley.cs.db.yfilterplus.xmltree.XMLTree;

public class YFilterInfo {
	private EXfilterBasic yfilter=new EXfilterBasic();
	private HashMap yFilterIdToXPath=new HashMap();	
	private HashMap  yFilterIdToQuery=new HashMap();
	private HashMap  xPathToYFilterId=new HashMap();
	private ConsumerListManager consumerListmanager=new ConsumerListManager();
	private int index = 0;
	private int counter=0;

	public EXfilterBasic getYfilter() {
		return yfilter;
	}
	public void setYfilter(EXfilterBasic yfilter) {
		this.yfilter = yfilter;
	}
	public HashMap getYFilterIdToXPath() {
		return yFilterIdToXPath;
	}
	public void setYFilterIdToXPath(HashMap filterIdToXPath) {
		yFilterIdToXPath = filterIdToXPath;
	}
	
	public void addXPathQuery(String xpathExpression, String subscriptionId,
			SubscriptionState subscribeRequest) {
		index++;
		counter++;
		if (WSMGParameter.debugYFilter)
			System.out.println("QueryExp=" + xpathExpression);		
		Integer yFilterIdObj = (Integer) xPathToYFilterId.get(xpathExpression);
		int yFilterId = -1;
		if (yFilterIdObj != null) {
			yFilterId = yFilterIdObj.intValue();
		} else {
			Query query=XPQuery.parseQuery(xpathExpression, index);
            if(query==null){
            	throw new SoapClientFault("Invalid XPath expression:"+xpathExpression);
            }
			if (WSMGParameter.debugYFilter)
				System.out.println("addSubscription " + xpathExpression
						+ " query :" + query);
			yFilterId = yfilter.addQuery(query);
			if (WSMGParameter.debugYFilter)
				yfilter.printQueryIndex();
			xPathToYFilterId.put(xpathExpression, Integer.valueOf(yFilterId));
			yFilterIdToXPath.put(new Integer(yFilterId), xpathExpression);
			yFilterIdToQuery.put(new Integer(yFilterId), 
query);	
		}
		if (WSMGParameter.debugYFilter)
			System.out.println("YFilterId=" + yFilterId);
	
		consumerListmanager.addToConsumerList(xpathExpression,
				subscribeRequest, subscriptionId);
	}
	
	public int removeSubscription(String subscriptionId){		

	      String xPath=consumerListmanager.getTokenBySubscriptionId(subscriptionId);
	      int result=consumerListmanager.removeFromConsumerList(subscriptionId, xPath);
	      if(result==0){
	    	  return 0;
	      }
	      int currentConsumerCount=consumerListmanager.getConsumerListByToken(xPath).size();
	      if(currentConsumerCount==0){
	    	  Integer yFilterId=(Integer)xPathToYFilterId.get(xPath);
		      Query q = (Query) yFilterIdToQuery.get(yFilterId);
	          yfilter.deleteQuery( q,
	                           q.getQueryId(  ) );
		      yFilterIdToQuery.remove(yFilterId);
	      }
	      counter--;
		return result;
	}
	
	public List getMatchingConsumerList(String messageString){
		List matchingConsumerList=new LinkedList();
        XMLTree tree = new XMLTree(new java.io.StringReader(messageString) );
        if(WSMGParameter.debugYFilter)
        tree.print();
        yfilter.setEventSequence( tree.getEvents(  ) );
        yfilter.startParsing(  );

        // print the matched queries //
        if ( SystemGlobals.hasQueries )
        {
        	if(WSMGParameter.debugYFilter)
           yfilter.printQueryResults( System.out );
        }
        else
        {
           System.out.println( "no match" );
           return matchingConsumerList;
        }

		
        java.util.Iterator it = yfilter.getMatchedQueries(  ).iterator(  );
        while ( it.hasNext(  ) )
        {
           Integer      qid = (Integer) it.next(  );
//           System.out.println("qid="+qid);

		String xpath=(String)yFilterIdToXPath.get(qid);
		ConsumerList consumerList = consumerListmanager.getConsumerListByToken(xpath);

		if (consumerList != null) {// has subscription to this topic
		  matchingConsumerList.addAll(consumerList.getConsumerList());
		}
        }
        yfilter.clear();	
    	return matchingConsumerList;
	}
	public int getCounter() {
		return counter;
	}
	

	
}
