/**
 * XppXPath.java
 * @author Yi Huang (yihuan@cs.indiana.edu)
 * Created:Apr 24, 2006 12:06:09 PM
 */

package wsmg.adapter.XPath.performance;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.xml.namespace.QName;
import javax.xml.stream.FactoryConfigurationError;
import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamReader;

import org.apache.axiom.om.OMAbstractFactory;
import org.apache.axiom.om.OMXMLParserWrapper;
import org.apache.axiom.om.impl.llom.factory.OMXMLBuilderFactory;
import org.apache.axiom.soap.SOAPEnvelope;
import org.xmlpull.v1.builder.XmlInfosetBuilder;

import wsmg.util.WsmgUtil;
import xsul.XmlConstants;
import edu.berkeley.cs.db.yfilterplus.queryparser.QueryParser;
import edu.berkeley.cs.db.yfilterplus.queryparser.XPQueryParser;

public class XppXPath {
	private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;
	private Vector xPathExpressions=new Vector();
    protected BufferedReader m_in = null;
    private static final boolean DEBUG=false;
    long total=0;
    
	public int[] getMatchedLinks(String message){
		
		return null;
	}
	
	public Vector checkQueries(String query){		
		Vector result=new Vector();
		Set xPathExpressionsSet=new HashSet(xPathExpressions);

		int size=xPathExpressions.size();

		for(int i=0;i<size;i++){

			boolean match=query.equals(xPathExpressions.get(i));

	//		long start=System.nanoTime();
			if(match){

				result.add(new Integer(i));

			}
	//		long end=System.nanoTime();
	//		total+=(end-start);
		}


	//	System.out.println("Total="+total);
		return result;
	}
	
	public boolean checkQueriesVectorToSet(Set queries){		
		//Vector result=new Vector();
		Set xPathExpressionsSet=new HashSet(xPathExpressions);

		int size=xPathExpressions.size();
		Iterator iter=queries.iterator();
		int counter=0;
		while(iter.hasNext()){	
			Object query=iter.next();
		for(int i=0;i<size;i++){

			boolean match= query.equals(xPathExpressions.get(i));

	//		long start=System.nanoTime();
			if(match){

				return true;

			}
	//		long end=System.nanoTime();
	//		total+=(end-start);
		}
		counter++;
		//System.out.println("counter="+counter);
		}
	//	System.out.println("Total="+total);
		return false;
	}
	
	public boolean checkQueriesBySet(Set queries){			
		Set xPathExpressionsSet=new HashSet(xPathExpressions);
		Iterator iter=queries.iterator();
		int counter=0;
		while(iter.hasNext()){			
			if(xPathExpressionsSet.contains(iter.next())){
		//		System.out.println("counter="+counter);
				return true;
			}
			counter++;
		}
		return false;
	}
	
	
	public void addXPathExpressions(String xPathExpression){
		xPathExpressions.add(xPathExpression);
	}
	
	public void readQueriesFromFile(String queryFile){
		int noQueries = Integer.MAX_VALUE;
        int qNum = 0;
        //QueryParser qp = new XFQueryParser(queryFile);
        QueryParser qp = new XPQueryParser(queryFile);
       // Query query;
        String queryString;
        while (qNum<noQueries && ((queryString = qp.readNextQueryString())!=null)) {
        	if (DEBUG)
        		System.out.println(queryString);
        	addXPathExpressions(queryString);
            qNum++;
        }         		
	}
	
	public String getARandomQuery(){
		int index=(int) (xPathExpressions.size()*(Math.random()));
		return (String)xPathExpressions.get(index);
	}
	
 
	
	
	/**
	 * @param args
	 * @throws IOException 
	 * @throws FactoryConfigurationError 
	 * @throws XMLStreamException 
	 */
	public static void main(String[] args) throws IOException, XMLStreamException, FactoryConfigurationError {
		String queryFile="C:\\YiFile\\yfilter-1.0\\yfilter-1.0\\queries2.txt";
		XppXPath xppXPath=new XppXPath();
		xppXPath.readQueriesFromFile(queryFile);
		long total=0;
		final int round=100;
		String message=WsmgUtil.readFile("c:\\YiFile\\testdata\\soap2.txt");

		int messageStartPoint=message.indexOf('<');
String xpathList=message.substring(0,messageStartPoint);
System.out.println("XpathList="+xpathList);
System.out.println("*****************************************");
long start0=System.nanoTime();
StringTokenizer parser0 = new StringTokenizer(xpathList,";");
Set xpathTokens=new HashSet();
while (parser0.hasMoreTokens()) {
	xpathTokens.add(parser0.nextToken());
}
long end0=System.nanoTime();
long total0=(end0-start0);   
//for(int i=0;i<xpathTokens.size();i++){
//	System.out.println((String)xpathTokens.get(i));
//}
System.out.println("Avg Time to token="+(total0));
System.out.println("Total token="+xpathTokens.size());
boolean result=false;
		for(int i=0;i<round;i++){
		String randomQuery=xppXPath.getARandomQuery();
	//	xpathTokens.add(randomQuery);
	//	Vector result=null;
 
		long start=System.nanoTime();
		 //result=xppXPath.checkQueries(randomQuery);
		 result=xppXPath.checkQueriesBySet(xpathTokens);
		// result=xppXPath.checkQueriesVectorToSet(xpathTokens);
		long end=System.nanoTime();
		total+=(end-start);
		}
		System.out.println("Match result="+result);
		System.out.println("Avg Time for Checking="+(total/round));


		//XSUL
		//		long start=System.nanoTime();
//		XmlElement messageEl = builder.parseFragmentFromReader(new StringReader(
//				message));
//		XmlElement messageIdEl= messageEl.element(null, "Header").element(null,"MessageID");
//        String messageId=messageIdEl.requiredTextContent();
//        System.out.println("MessageId="+messageId);
//		long end=System.nanoTime();
//		total=(end-start);      
//		System.out.println("Avg Time="+(total));
		
		//AXIOM
	//	long start=System.nanoTime();
//		create the parser
		//XMLStreamReader parser = XMLInputFactory.newInstance().createXMLStreamReader(new FileReader("c:\\YiFile\\testdata\\soap_only.txt"));
//		create the builder
		String message1=WsmgUtil.readFile("c:\\YiFile\\testdata\\soap_only.txt");
		long start=System.nanoTime();
		XMLStreamReader parser = XMLInputFactory.newInstance().createXMLStreamReader(new ByteArrayInputStream(message1.getBytes()));

		
		OMXMLParserWrapper builder = OMXMLBuilderFactory.createStAXSOAPModelBuilder(OMAbstractFactory.getSOAP11Factory(), parser); 
//		get the root element (in this case the envelope)

		SOAPEnvelope envelope = (SOAPEnvelope) builder.getDocumentElement();

////		create the parser
//		XMLStreamReader parser = XMLInputFactory.newInstance().createXMLStreamReader(new FileReader("c:\\YiFile\\testdata\\soap.txt"));
////		create the builder
//		OMXMLParserWrapper builder =   OMXMLBuilderFactory.createStAXSOAPModelBuilder(OMAbstractFactory.getOMFactory(),parser);
////		get the root element (in this case the envelope)
//		SOAPEnvelope envelope = (SOAPEnvelope)builder.getDocumentElement();
//
//		
		String messageIDString=envelope.getHeader().getFirstChildWithName(new QName(null, "MessageID")).getText();
		long end=System.nanoTime();
		total=(end-start);
		System.out.println("Avg Time for Axiom="+(total));
		//	OMElement headerEl=envelope.getHeader().getFirstChildWithName(new QName("http://schemas.xmlsoap.org/soap/envelope/", "Header"));
		envelope.getHeader().getFirstChildWithName(new QName(null, "MessageID")).serialize(System.out);
		System.out.println();
		//
	//	headerEl.getFirstChildWithName(new QName(null, "MessageID"));

		
		
           
	}

}


/*
 * Indiana University Extreme! Lab Software License, Version 1.2
 *
 * Copyright (c) 2002-2004 The Trustees of Indiana University.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1) All redistributions of source code must retain the above
 *    copyright notice, the list of authors in the original source
 *    code, this list of conditions and the disclaimer listed in this
 *    license;
 *
 * 2) All redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the disclaimer
 *    listed in this license in the documentation and/or other
 *    materials provided with the distribution;
 *
 * 3) Any documentation included with all redistributions must include
 *    the following acknowledgement:
 *
 *      "This product includes software developed by the Indiana
 *      University Extreme! Lab.  For further information please visit
 *      http://www.extreme.indiana.edu/"
 *
 *    Alternatively, this acknowledgment may appear in the software
 *    itself, and wherever such third-party acknowledgments normally
 *    appear.
 *
 * 4) The name "Indiana University" or "Indiana University
 *    Extreme! Lab" shall not be used to endorse or promote
 *    products derived from this software without prior written
 *    permission from Indiana University.  For written permission,
 *    please contact http://www.extreme.indiana.edu/.
 *
 * 5) Products derived from this software may not use "Indiana
 *    University" name nor may "Indiana University" appear in their name,
 *    without prior written permission of the Indiana University.
 *
 * Indiana University provides no reassurances that the source code
 * provided does not infringe the patent or any other intellectual
 * property rights of any other entity.  Indiana University disclaims any
 * liability to any recipient for claims brought by any other entity
 * based on infringement of intellectual property rights or otherwise.
 *
 * LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH
 * NO WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA
 * UNIVERSITY GIVES NO WARRANTIES AND MAKES NO REPRESENTATION THAT
 * SOFTWARE IS FREE OF INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR
 * OTHER PROPRIETARY RIGHTS.  INDIANA UNIVERSITY MAKES NO WARRANTIES THAT
 * SOFTWARE IS FREE FROM "BUGS", "VIRUSES", "TROJAN HORSES", "TRAP
 * DOORS", "WORMS", OR OTHER HARMFUL CODE.  LICENSEE ASSUMES THE ENTIRE
 * RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR ASSOCIATED MATERIALS,
 * AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION GENERATED USING
 * SOFTWARE.
 */
