package wsmg.axis2;

import java.io.StringReader;
import java.net.URI;

import javax.xml.stream.XMLStreamException;

import org.apache.axiom.om.OMException;
import org.apache.axis2.AxisFault;
import org.apache.axis2.context.MessageContext;
import org.apache.axis2.receivers.AbstractMessageReceiver;
import org.xmlpull.v1.builder.XmlBuilderException;
import org.xmlpull.v1.builder.XmlElement;
import org.xmlpull.v1.builder.XmlInfosetBuilder;

import wsmg.ProcessingContext;
import wsmg.SoapClientFault;
import wsmg.WSMGService;
import wsmg.WsmgConstants;
import xsul.XmlConstants;
import xsul.ws_addressing.WsAddressing;
import xsul.ws_addressing.WsaMessageInformationHeaders;


/**
 * @author Chathura Herath (cherath@cs.indiana.edu)
 */

public class BrockerMessageReceiver extends AbstractMessageReceiver {

	private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;
	public void receive(MessageContext messageCtx) throws AxisFault {
		invokeBusinessLogic(messageCtx);
		
		 
		
		

	}
	
	
	public void invokeBusinessLogic(MessageContext msgContext){
		
		String body= null;
		try {
			body = msgContext.getEnvelope().getBody().toStringWithConsume();
		} catch (OMException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		} catch (XMLStreamException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}
		String message = null;
		try {
			message = msgContext.getEnvelope().toStringWithConsume();
		} catch (XMLStreamException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		XmlElement envelope = builder.parseFragmentFromReader(new StringReader(message));
		

		WsaMessageInformationHeaders headers = new WsaMessageInformationHeaders(
				envelope);
		// extract operation
		ProcessingContext ctx = new ProcessingContext();
		ctx.setSoapBody(builder.parseFragmentFromReader(new StringReader(body)));
		ctx.setEnvelope(envelope);
		
		WSMGService broker = (WSMGService)msgContext.getConfigurationContext().getProperty(WsmgConstants.BROKER_KEY_FOR_AXIS2);
		(broker).processHeaders(ctx);

		URI respAction = WsAddressing.URI_ROLE_ANONYMOUS;
		try {
			try {
				broker.executeSoapEnvelope(ctx);
			} catch (XmlBuilderException ex) {
				throw new SoapClientFault("problem with parsing XML: " + ex, ex);
			}
			if (ctx.getRespMessage() != null) {
				respAction = URI.create(ctx.getRespMessage().getNamespace()
						.getNamespaceName()
						+ "/" + ctx.getRespMessage().getName());
			}
		} catch (Exception e){
			e.printStackTrace();
		}
		
	}

}


/*
 * Indiana University Extreme! Lab Software License, Version 1.2
 * 
 * Copyright (C) 2004 The Trustees of Indiana University. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 * 
 * 2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 * 
 * 3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 * 
 * "This product includes software developed by the Indiana University Extreme!
 * Lab. For further information please visit http://www.extreme.indiana.edu/"
 * 
 * Alternatively, this acknowledgment may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 * 
 * 4) The name "Indiana University" or "Indiana University Extreme! Lab" shall
 * not be used to endorse or promote products derived from this software without
 * prior written permission from Indiana University. For written permission,
 * please contact http://www.extreme.indiana.edu/.
 * 
 * 5) Products derived from this software may not use "Indiana University" name
 * nor may "Indiana University" appear in their name, without prior written
 * permission of the Indiana University.
 * 
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of any
 * other entity. Indiana University disclaims any liability to any recipient for
 * claims brought by any other entity based on infringement of intellectual
 * property rights or otherwise.
 * 
 * LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 * NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 * INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 * "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 * LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 * GENERATED USING SOFTWARE.
 */

