package wsmg.db;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import org.xmlpull.v1.builder.XmlElement;
import org.xmlpull.v1.builder.XmlInfosetBuilder;

import wsmg.SubscriptionEntry;
import wsmg.config.WSMGParameter;
import wsmg.util.Counter;
import wsmg.util.TimerThread;
import xsul.MLogger;
import xsul.XmlConstants;
import xsul.ws_addressing.WsaEndpointReference;

//import wsmg.ws_addressing.*;

public class SubscriptionDB {
	private final static MLogger logger = MLogger.getLogger();

	JdbcStorage db = new JdbcStorage(WSMGParameter.DB_CONFIG_NAME);

	Connection conn = null;

	private Counter storeToDBCounter = new Counter();

	private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;

	// private ConnectionPool connectionPool;
	public SubscriptionDB() {
		/*
		 * try { conn = db.connect(); } catch (SQLException ex) {
		 * ex.printStackTrace(); }
		 */

		if (WSMGParameter.measureMessageRate) {
			TimerThread timerThread = new TimerThread(storeToDBCounter,
					" StoreSubScriptionToDBCounter");
			new Thread(timerThread).start();
		}
	}

	public SubscriptionEntry[] getAllSubscription() {
		int totalRecord = 0;
		String query = "SELECT * FROM subscription";
		ResultSet rs = null;
		try {
			rs = db.query(query);
			if (rs != null) {
				// Get total number of rows

				// Point to the last row in resultset.
				rs.last();
				// Get the row position which is also the number of rows in the
				// ResultSet.
				totalRecord = rs.getRow();
				System.out.println("TotalRecord=" + totalRecord);
				// Create String array to return

				// Reposition at the beginning of the ResultSet to take up
				// rs.next() call.
				rs.beforeFirst();
				SubscriptionEntry[] subscriptionEntry = new SubscriptionEntry[totalRecord];
				int i = 0;
				while (rs.next()) {
					subscriptionEntry[i] = new SubscriptionEntry();
					subscriptionEntry[i].setSubscriptionId(rs
							.getString("SubscriptionId"));
					subscriptionEntry[i].setSubscribeXml(rs.getString("xml"));
                    int policyValue = rs.getInt("wsrm");
                    subscriptionEntry[i].setWsrmPolicy(policyValue == SubscriptionEntry.WSRM_POLICY_TRUE); 
					i++;
				}
				rs.close();
				return subscriptionEntry;
			}
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
		return null;
	}

	public int insert(String key, String subscribeXml,boolean wsrmPolicy, String topic, String xpath,
			WsaEndpointReference consumerReference) {
		// XmlElement newsubscribeXmlElement=builder.parseFragmentFromReader(new
		// StringReader(subscribeXml));

		// String topic=
		String query = null;
		PreparedStatement stmt = null;
		String consumerAddress = null;
		consumerAddress = consumerReference.getAddress().toASCIIString();
		XmlElement consumerReferencePropertiesEl = consumerReference.element(
				null, "ReferenceProperties");
		String consumerReferenceProperties;
		if (consumerReferencePropertiesEl == null) {
			consumerReferenceProperties = "";
		} else {
			consumerReferenceProperties = ((XmlElement) (consumerReferencePropertiesEl
					.requiredElementContent().iterator().next()))
					.requiredTextContent();
		}
        int policyValue=SubscriptionEntry.WSRM_POLICY_FALSE;
        if(wsrmPolicy){
            policyValue = SubscriptionEntry.WSRM_POLICY_TRUE;
        }
		query = "INSERT INTO subscription (SubscriptionId, xml, wsrm, Topics, XPath, ConsumerAddress, ReferenceProperties, CreationTime) VALUES ";
		query += "('" + key + "','" + subscribeXml + "','" +policyValue+"','"+ topic + "','"+ xpath + "','"
				+ consumerAddress + "','" + consumerReferenceProperties + "','";
		// query+="','"+subEntry.getTopics_Dialect()+"','"+subEntry.isUseNotify()+"','";
		java.util.Date today = new java.util.Date();
		java.sql.Timestamp now = new java.sql.Timestamp(today.getTime());
		query += now + "')";

		try {

			int result = 0;
			conn = db.connect();
			stmt = conn.prepareStatement(query);

//			logger.finest("Query=" + query);

			result = db.executeUpdate(stmt);
			storeToDBCounter.addCounter();
			db.closeConnection(conn);
			// }
			// conn.close();
			return result;
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

		return 0;
	}

	public int delete(String subscriptionId) {
		String query;
		query = "DELETE FROM subscription WHERE SubscriptionId='"
				+ subscriptionId + "'";
		try {
			db.update(query);
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
		return 0;
	}
}
