package wsmg.demo;

import org.exolab.jms.util.CommandLine;
import org.xmlpull.v1.builder.XmlElement;
import org.xmlpull.v1.builder.XmlInfosetBuilder;

import wsmg.NotificationHandler;
import wsmg.WseClientAPI;
import wsmg.WsmgConstants;
import wsmg.pull.MessagePuller;
import xsul.XmlConstants;
import xsul.ws_addressing.WsaEndpointReference;

/**
 * <p>
 * Title: Ws-Notification
 * </p>
 * <p>
 * Description:
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * <p>
 * Company: Indiana University
 * </p>
 *
 * @author yi Huang
 * @version 1.0
 */

public class TestPullNotificationConsumer {

  public static void main(String[] args) throws InterruptedException {
    final XmlInfosetBuilder builder = XmlConstants.BUILDER;
    CommandLine cmdline = new CommandLine(args);
    //default port 19999
    String msgBoxServerLoc = cmdline.value("mbServer", "http://rainier.extreme.indiana.edu:13333/MsgBox");
    if(!msgBoxServerLoc.startsWith("http")){
      msgBoxServerLoc="http://"+msgBoxServerLoc;
    }
    WseClientAPI client = new WseClientAPI();
    //Create a handler to handle the notifications arrived
    NotificationHandler handler = new DefaultNotificationHandler();
    WsaEndpointReference msgBoxAddr=client.createPullMsgBox(msgBoxServerLoc);
    //String msgBoxAddrString= ((XmlElement)msgBoxAddr).requiredElement(WsmgConstants.WSA_NS, "Address").requiredTextContent();
    String msgBoxAddrString= ((XmlElement)msgBoxAddr).requiredElement(null, "Address").requiredTextContent();
    System.out.println("Created MsgBox: "+ msgBoxAddrString);
   MessagePuller messagePuller=client.startPullingEventsFromMsgBox(msgBoxAddr, handler, 100L);
 //You can stop pulling using the following command.
   //  Thread.sleep(10000L);
   //  messagePuller.stopPulling();
  }


}
