package wsmg.demo.concurrent;

/*import java.util.concurrent.ExecutorService;
 import java.util.concurrent.Callable;
 import java.util.concurrent.Executors;
 import java.util.concurrent.TimeUnit;
 import java.util.concurrent.ExecutionException;
 import java.util.concurrent.TimeoutException;
 import java.util.concurrent.FutureTask;
 import java.util.concurrent.Semaphore;*///For JDK5
import wsmg.XmlConsumer;
import edu.emory.mathcs.util.concurrent.Callable;
import edu.emory.mathcs.util.concurrent.ExecutionException;
import edu.emory.mathcs.util.concurrent.ExecutorService;
import edu.emory.mathcs.util.concurrent.Executors;
import edu.emory.mathcs.util.concurrent.FutureTask;
import edu.emory.mathcs.util.concurrent.Semaphore;
import edu.emory.mathcs.util.concurrent.TimeUnit;
import edu.emory.mathcs.util.concurrent.TimeoutException;

/**
 * <p>
 * Title: Ws-Notification
 * </p>
 * 
 * <p>
 * Description:
 * </p>
 * 
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * 
 * <p>
 * Company: Indiana University
 * </p>
 * 
 * @author yi Huang
 * @version 1.0
 */
public class StopableNotificationConsumer {
	private static Semaphore waiting = new Semaphore(1, true);

	FutureTask future1 = null;

	ExecutorService executor = Executors.newFixedThreadPool(2);

	StopableNotificationHandler handler = new StopableNotificationHandler();

	XmlConsumer xc = null;

	public StopableNotificationConsumer() {
	}

	public void startNotificationConsumer(int port) {
		xc = new XmlConsumer(port, handler);
		try {
			waiting.acquire();
		} catch (InterruptedException ex) {
			ex.printStackTrace();
		}

		handler.setSemaphore(waiting);
		xc.start();

		future1 = new FutureTask(new Callable() {
			public Object call() {
				System.out.println("running future1");
				System.out.println("Trying to get lock in future1");
				try {
					waiting.acquire();
				} catch (InterruptedException ex) {
					ex.printStackTrace();
				}
				System.out.println("Got lock in Future1");
				xc.shutdown();
				System.out.println("Finished shuting down XC");
				return null;
			}
		});
		executor.execute(future1);
	}

	public void waitAllMessages() {
		try {
			future1.get(100000L, TimeUnit.SECONDS);
			// future1.get();
			executor.shutdown();
			System.out.println("Finished");
		} catch (TimeoutException ex1) {
			future1.cancel(true);
			System.out.println("Canceled");
			xc.shutdown();
			System.out.println("Shut down XC in timeout");
			executor.shutdown();
			ex1.printStackTrace();
		} catch (ExecutionException ex) {
			ex.printStackTrace();
		} catch (InterruptedException ex) {
			ex.printStackTrace();
		}
	}

	public static void main(String[] args) {
		StopableNotificationConsumer nc = new StopableNotificationConsumer();
		// listening to port 19999, non-blocking
		nc.startNotificationConsumer(19999);
		// launch other components
		System.out.println("Doing other stuff");
		// Wait for all messages after launching all the components, blocks here
		nc.waitAllMessages();
		// shut down other components after all "Done" messages arrive
	}

}
