package wsmg.demo.leadCallBack;

import java.util.Vector;

import xsul.MLogger;

/**
 * <p>
 * Title: Ws-Notification
 * </p> *
 * <p>
 * Description:
 * </p> *
 * <p>
 * Copyright: Copyright (c) 2004
 * </p> *
 * <p>
 * Company: Indiana University
 * </p> *
 * 
 * @author yi Huang
 * @version 1.0
 */
public class LeadEventCallBack implements EventCallback {
	private final static MLogger logger = MLogger.getLogger();

	private Vector expectedMessageList = new Vector();

	public LeadEventCallBack() {
	}

	public boolean deliverEvent(String eventString) {
		logger.finest("*****Delivered String:" + eventString);

		boolean found = markAsReceived(eventString);
		if (found) { // this check prevent unwanted messages
			if (receivedAllMessages()) {
				return true;
			}
		}
		return false;
	}

	/**
	 * addExpectedMessage Add expected messages. These messages are used to
	 * indicate that all messages are received.
	 * 
	 * @param messageConetent
	 *            String
	 */
	public void addExpectedMessage(String messageConetent) {
		ExpectedMessageRegistrationEntry expectedMessage = new ExpectedMessageRegistrationEntry(
				messageConetent);
		expectedMessageList.add(expectedMessage);
		return;
	}

	// Return true if found the message, else return false
	private boolean markAsReceived(String messageContent) {
		ExpectedMessageRegistrationEntry expectedMessage = null;
		boolean found = false;
		for (int i = 0; i < expectedMessageList.size(); i++) {
			expectedMessage = (ExpectedMessageRegistrationEntry) expectedMessageList
					.get(i);
			// if(messageContent.compareTo(expectedMessage.getMessageContent())==0
			// ){
			if (messageContent.indexOf(expectedMessage.getMessageContent()) >= 0) {
				expectedMessage.setReceived(true);
				found = true;
				break;
			}
		}
		if (!found) {
			logger.finest("Received message: " + messageContent
					+ ". This is not expected.");
			showExpectedMessages();
			return false;
		} else {
			return true;
		}
	}

	/**
	 * receivedAllMessages
	 * 
	 * @return boolean
	 */
	private boolean receivedAllMessages() {
		ExpectedMessageRegistrationEntry expectedMessage = null;
		boolean getAll = true;
		for (int i = 0; i < expectedMessageList.size(); i++) {
			expectedMessage = (ExpectedMessageRegistrationEntry) expectedMessageList
					.get(i);
			if (expectedMessage.isReceived() == false) {
				getAll = false;
				logger.finest("At least the following message is not received:"
						+ expectedMessage.getMessageContent());
				break;
			}
		}
		return getAll;
	}

	// Used for debugging
	public void showExpectedMessages() {
		ExpectedMessageRegistrationEntry expectedMessage = null;
		for (int i = 0; i < expectedMessageList.size(); i++) {
			expectedMessage = (ExpectedMessageRegistrationEntry) expectedMessageList
					.get(i);
			if (expectedMessage.isReceived() == false) {
				System.out.println("Expecting:"
						+ expectedMessage.getMessageContent());
			}
		}
	}

}
