package wsmg.demo.leadCallBack;

import java.net.InetAddress;
import java.net.URISyntaxException;

import wsmg.WseClientAPI;
import wsmg.demo.lead.LeadEvent;

public class Notifier {
	WseClientAPI publisher;

	InetAddress localAddress;

	String producer;

	String consumer = "rainier.extreme.indiana.edu:12346";

	String me;

	// in this constructor "me" is the source of the message, i.e. Decoder, etc.
	// consumer is defailted to rainier at 12345 but you can change it here.

	public Notifier(String me_, String foo) {
		publisher = null;
		localAddress = null;
		producer = null;
		me = me_;
	}

	public void publishNotification(String topic, String message)
			throws URISyntaxException {
		if (producer == null) {
			try {
				localAddress = InetAddress.getLocalHost();
				producer = localAddress.getHostAddress();
			} catch (Exception ex) {
				System.out.println("Error - unable to resolve localhost");
			}
		}

		if (producer != null && topic != null && consumer != null) {
			if (publisher == null)
				publisher = new WseClientAPI();

			System.out.println("***********Sending Event...");
			System.out.println("message is: " + message);
			publisher.publish(consumer, producer, topic, message);
		}
		return;
	}

	// status can be
	// FINISHED_FAILED, FINISHED_SUCCESS, INFORMATION
	public void sendLeadEvent(String context, String status, String message)
			throws URISyntaxException {
		if (message.length() > 255)
			message = message.substring(0, 255);
		LeadEvent leadEvent = new LeadEvent();
		String messageString = leadEvent.createMessage(status, message, me,
				context);

		// send the notification as an xml string
		publishNotification(context, messageString);
	}

}
