package wsmg.demo.leadCallBack;

/*import java.util.concurrent.ExecutorService;
 import java.util.concurrent.Callable;
 import java.util.concurrent.Executors;
 import java.util.concurrent.TimeUnit;
 import java.util.concurrent.ExecutionException;
 import java.util.concurrent.TimeoutException;
 import java.util.concurrent.FutureTask;
 import java.util.concurrent.Semaphore;*///For JDK5
import java.net.InetAddress;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.UnknownHostException;

import wsmg.WseClientAPI;
import wsmg.XmlConsumer;
import edu.emory.mathcs.util.concurrent.Callable;
import edu.emory.mathcs.util.concurrent.ExecutionException;
import edu.emory.mathcs.util.concurrent.ExecutorService;
import edu.emory.mathcs.util.concurrent.Executors;
import edu.emory.mathcs.util.concurrent.FutureTask;
import edu.emory.mathcs.util.concurrent.Semaphore;
import edu.emory.mathcs.util.concurrent.TimeUnit;
import edu.emory.mathcs.util.concurrent.TimeoutException;

/**
 * <p>
 * Title: Ws-Notification
 * </p>
 * 
 * <p>
 * Description:
 * </p>
 * 
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * 
 * <p>
 * Company: Indiana University
 * </p>
 * 
 * @author yi Huang
 * @version 1.0
 */
public class StopableNotificationConsumer {
	private static Semaphore waiting = new Semaphore(1, true);

	FutureTask future = null;

	ExecutorService executor = Executors.newFixedThreadPool(2);

	WSE_StopableNotificationHandler handler = new WSE_StopableNotificationHandler();

	XmlConsumer xc = null;

	WseClientAPI client = new WseClientAPI();

	String brokerURL = null;

	String subscriptionId = null;

	public StopableNotificationConsumer() {
	}

	public void startNotificationConsumer(String brokerURL, String topic,String xpath,
			int ListeningPort) throws URISyntaxException {
		this.brokerURL = brokerURL;
		xc = new XmlConsumer(ListeningPort, handler);
		try {
			waiting.acquire();
		} catch (InterruptedException ex) {
			ex.printStackTrace();
		}
		handler.setSemaphore(waiting);
		xc.start();
		//listenPort = getServer().getServerPort();
		String consumerURL = xc.getServer().getLocation();
//		InetAddress localAddress = null;
//		try {
//			localAddress = InetAddress.getLocalHost();
//		} catch (UnknownHostException ex) {
//			System.out.println("Error - unable to resolve localhost");
//		}
//		// Use IP address since DNS entry cannot update the laptop's entry
//		// promptly
//		String hostIP = localAddress.getHostAddress();
//		/* String hostName = localAddress.getCanonicalHostName(); */
//		String consumerURL = hostIP + ":" + ListeningPort;
		subscriptionId = client.subscribe(brokerURL, consumerURL, topic,xpath);
		System.out.println("Created subscription: topic=" + topic);
		future = new FutureTask(new Callable() {
			public Object call() {
				System.out.println("Waiting to get lock.");
				try {
					waiting.acquire();
				} catch (InterruptedException ex) {
					ex.printStackTrace();
				}
				System.out.println("Got lock");
				xc.shutdown();
				System.out.println("Finished shuting down XC");
				return null;
			}
		});
		executor.execute(future);
	}

	/**
	 * subscribe This is used to subscribe other listeners. e.g. MyLeadAgent
	 * 
	 * @param consumerURL
	 *            String
	 * @param topic
	 *            String
	 * @return String
	 * @throws URISyntaxException
	 */
	public String subscribe(String consumerURL, String topic)
			throws URISyntaxException {
		String subId = client.subscribe(brokerURL, consumerURL, topic);
		return subId;
	}

	/**
	 * This is used to subscribe other listeners. e.g. MyLeadAgent
	 * 
	 * @param subId
	 *            String Used to specify the subscriptionID to delete
	 * @throws URISyntaxException
	 */
	public void unSubscribe(String subId) throws URISyntaxException {
		client.unSubscribe(brokerURL, subId);
		return;
	}

	public void waitAllMessages() throws URISyntaxException {
		try {
			future.get(100000L, TimeUnit.SECONDS);
			executor.shutdown();
			client.unSubscribe(brokerURL, subscriptionId);
			System.out.println("Deleted Subscription.");
			System.out.println("Finished");
		} catch (TimeoutException ex1) {
			future.cancel(true);
			System.out.println("Canceled");
			xc.shutdown();
			System.out.println("Shut down XC in timeout");
			executor.shutdown();
			client.unSubscribe(brokerURL, subscriptionId);
			ex1.printStackTrace();
		} catch (ExecutionException ex) {
			ex.printStackTrace();
		} catch (InterruptedException ex) {
			ex.printStackTrace();
		}
	}

	public void setEventCallback(EventCallback cb) {
		handler.setEventCallback(cb);
	}

	public static void main(String[] args) throws URISyntaxException {
		StopableNotificationConsumer nc = new StopableNotificationConsumer();
		LeadEventCallBack cb = new LeadEventCallBack();
		nc.setEventCallback(cb);
		// listening to port 19999, non-blocking
		nc.startNotificationConsumer("rainier.extreme.indiana.edu:12345",
				"AAA", null, 19999);
		cb.addExpectedMessage("Decode done.");
		cb.addExpectedMessage("Thredd done.");
		// launch other components
		System.out.println("Doing other stuff");
		// Wait for all messages after launching all the components, blocks here
		nc.waitAllMessages();
		// shut down other components after all "Done" messages arrive
	}

}
