package wsmg.demo.leadCallBack;

//import wsnt.demo.TestPublisher;
//import wsnt.demo.myLeadAgent.TestXmlbeanPublisher;
import org.exolab.jms.util.CommandLine;

import wsmg.demo.TestWSE_Publisher;
import wsmg.demo.myLeadAgent.TestNCSAEventPublisher;

//import wsnt.demo.myLeadAgent.TestXmlbeanPublisher;

/**
 * <p>
 * Title: Ws-Notification
 * </p>
 * 
 * <p>
 * Description:
 * </p>
 * 
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * 
 * <p>
 * Company: Indiana University
 * </p>
 * 
 * @author yi Huang
 * @version 1.0
 */
public class TestController {
	public TestController() {
	}

	public static void main(String[] args) throws Exception {
		CommandLine cmdline = new CommandLine(args);
		String brokerUrl = cmdline.value("broker",
				"rainier.extreme.indiana.edu:12346");
		String topic = cmdline.value("topic",
				"");
		String xpath= cmdline.value("xpath",null);
		int listenPort = Integer.parseInt(cmdline.value("listenPort", "19999"));
		StopableNotificationConsumer nc = new StopableNotificationConsumer();
		LeadEventCallBack myEventCallback = new LeadEventCallBack();
		nc.setEventCallback(myEventCallback);
		// String brokerUrl="rainier.extreme.indiana.edu:12346";
		// e.g. Set brokerURL=localhost:12346
		// Set Topic=AAA
		// listening to port 19999, non-blocking
		nc.startNotificationConsumer(brokerUrl, topic,xpath, listenPort);

		// Create subscription for MyLeadAgent
		// String subId=nc.subscribe("bitternut.cs.indiana.edu:19999",topic);
		// String subId=nc.subscribe("bitternut.cs.indiana.edu:19999",topic);

		/**
		 * addExpectedMessage()is a method in myEventCallback Implementation,
		 * This method is not required in EventCallback Interface. We used this
		 * method in SC demo to detect the end of workflow by checking the
		 * substring "FINISHED_" in the notification message
		 */

		// Add expected messages
		// myEventCallback.addExpectedMessage("Decode done.");
		// myEventCallback.addExpectedMessage("Thredd done.");
		myEventCallback.addExpectedMessage("FINISHED_");

		// launch other components here
		System.out.println("#####Doing other stuff######");


		/**
		 * **Following part is used to publish test messages. If you want to
		 * test your publisher, you can comment out the following part and let
		 * the controller to wait for your messages.
		 */

		// Call test publisher to publish a simple String messages
		TestWSE_Publisher publisher = null;
		publisher.main(new String[] { "-consumer", brokerUrl, "-topic", topic,
				"-message", "Thredd done." });
		// Use this line to publish messages used in SC2004 demo. which are
		// based on xmlbean.
		// TestXmlbeanPublisher xmlPublisher=new TestXmlbeanPublisher();
		// Use following line to publish a message using NCSATools (OGRE) events
		TestNCSAEventPublisher xmlPublisher = new TestNCSAEventPublisher();
		xmlPublisher.main(new String[] { "-consumer", brokerUrl, "-topic",
				topic });
		/**
		 * End of test publisher
		 */

		// Wait for all messages after launching all the components, blocks here
		nc.waitAllMessages();
		// Unscubscribe MyLeadAgent,sleep for some time to wait for the messages
		// to arrive at myLeadAgent before unsubscribing
		Thread.currentThread().sleep(100L);
		// nc.unSubscribe(subId);
		// shut down other components after all "Done" messages arrive
	}
}
