package wsmg.demo.leadCallBack;

import org.xmlpull.v1.builder.XmlInfosetBuilder;
import org.xmlpull.v1.builder.XmlNamespace;

import wsmg.NotificationHandler;
import wsmg.XmlConsumer;
import wsmg.util.WsmgUtil;
import xsul.MLogger;
import xsul.XmlConstants;
import xsul.soap.SoapUtil;
import xsul.soap11_util.Soap11Util;
import xsul.soap12_util.Soap12Util;
import edu.emory.mathcs.util.concurrent.Semaphore;

public class WSE_StopableNotificationHandler implements NotificationHandler {
	private final static MLogger logger = MLogger.getLogger();

	private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;

	private XmlConsumer xc = null;
	private int counter=0;

	public final static XmlNamespace LEAD_NS = builder.newNamespace("lead",
			"http://lead.extreme.indiana.edu/namespaces/2004/10/lead");

	private SoapUtil[] soapFragrances = new SoapUtil[] {
			Soap12Util.getInstance(), Soap11Util.getInstance() };

	private Semaphore waiting = new Semaphore(1, true);

	private EventCallback cb = null;

	public WSE_StopableNotificationHandler() {
	}

	public void setEventCallback(EventCallback cb) {
		this.cb = cb;
	}

	public synchronized void handleNotification(String message) {
		// String messageContent=null;
		counter++;
		System.out.println("*******handler Received message #"+counter+". Time="
				+ System.currentTimeMillis());
		logger.finest("*******lead message handler Received message********");
		logger.finest(message);

		String messageContentAsXml = WsmgUtil.getSoapBodyContent(message);

		boolean gotAllMessages = cb.deliverEvent(messageContentAsXml);
		if (gotAllMessages) {
			if (waiting != null) {
				waiting.release();
			}
		}
	}

	public void setSemaphore(Semaphore sem) {
		this.waiting = sem;
	}

}
