package wsmg.demo.myLeadAgent;

import org.xmlpull.v1.builder.XmlInfosetBuilder;
import org.xmlpull.v1.builder.XmlNamespace;

import wsmg.NotificationHandler;
import wsmg.demo.lead.LeadEvent;
import wsmg.util.WsmgUtil;
import xsul.MLogger;
import xsul.XmlConstants;

public class MyLeadAgentNotificationHandler implements NotificationHandler {
	private final static MLogger logger = MLogger.getLogger();

	private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;

	public final static XmlNamespace LEAD_NS = builder.newNamespace("lead",
			"http://lead.extreme.indiana.edu/namespaces/2004/10/lead");

	private EventCallback cb = null;

	public MyLeadAgentNotificationHandler() {
	}

	public void setEventCallback(EventCallback cb) {
		this.cb = cb;
	}

	public synchronized void handleNotification(String soapMessage) {
		String messageContent = null;
		logger.finest("*******lead message handler Received message********");
		logger.finest(soapMessage);
		// Get the real message content
		messageContent = WsmgUtil.getSoapBodyContent(soapMessage);
		LeadEvent leadEvent = new LeadEvent(messageContent);
		String status = leadEvent.getStatus();
		String messageString = leadEvent.getMessage();
		String source = leadEvent.getSource();
		String timeStamp = leadEvent.getTimeStamp();
		String topic = leadEvent.getTopic();
		logger.finest("status=" + status);
		logger.finest("message=" + messageString);
		logger.finest("source=" + source);
		logger.finest("timeStamp=" + timeStamp);
		logger.finest("topic=" + topic);
		if (topic != null) {
			cb.deliverEvent(messageContent, topic);
		} else {
			logger
					.finest("######Received an mal-formated message (not LEAD message)");
		}
		/*
		 * XmlElement messageEl=builder.parseFragmentFromReader(new
		 * StringReader( messageContent));
		 * 
		 * XmlElement topicEl=messageEl.element(LEAD_NS,"topic");
		 * if(topicEl!=null){ String topicLocalString =
		 * topicEl.requiredTextContent(); cb.deliverEvent(messageContent,
		 * topicLocalString); }else{ logger.finest("######Received an
		 * mal-formated message (not LEAD message)"); }
		 */
	}

}
