package wsmg.demo.myLeadAgent;

/**
 * <p>Title: Ws-Notification</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: Indiana University</p>
 *
 * @author yi Huang
 * @version 1.0
 */
import java.net.InetAddress;
import java.net.URISyntaxException;
import java.net.UnknownHostException;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import org.exolab.jms.util.CommandLine;

import wsmg.WseClientAPI;
import xsul.MLogger;
import edu.indiana.extreme.lead.types.NotificationStatusType;
import edu.indiana.extreme.lead.types.WorkflowNotificationDocument;

public class TestXmlbeanPublisher {
	private final static MLogger logger = MLogger.getLogger();

	public TestXmlbeanPublisher() {
	}

	public static void main(String[] args) throws URISyntaxException {
		// create a notification xmlbean object

		CommandLine cmdline = new CommandLine(args);
		// default consumer location: "localhost:12345"
		String consumer = cmdline.value("consumer", "localhost:12345");
		// default topic: TestTopic
		String topic = cmdline.value("topic", "TestTopic");
		// set the content of message

		// Find the Ip address of the producer. Use it as the producer's URI.
		// This is just for test purpose.
		InetAddress localAddress = null;
		try {
			localAddress = InetAddress.getLocalHost();
		} catch (UnknownHostException ex) {
			System.out.println("Error - unable to resolve localhost");
		}
		String producer = localAddress.getHostAddress();
		System.out.println("IP address: " + producer);
		WseClientAPI client = new WseClientAPI();

		NotificationStatusType.Enum status = NotificationStatusType.INFORMATION;
		String messageContent = "";
		String source = "decoder";
		TestXmlbeanPublisher publisher = new TestXmlbeanPublisher();
		for (int i = 0; i < 15; i++) {
			messageContent = "<a href=\"http://test.com/\">text</a>Decoder Done! No."
					+ i;
			String message = publisher.createMessage(status, messageContent,
					source, topic);
			logger.info("Message=" + message);
			client.publish(consumer, producer, topic, message);
			/*
			 * try { Thread.sleep(2500); } catch (InterruptedException ex1) {
			 * ex1.printStackTrace(); }
			 */
		}
		status = NotificationStatusType.FINISHED_SUCCESS;
		messageContent = "done!<a href=\"http://test.com/\">text</a>";
		source = "decoder";
		String message = publisher.createMessage(status, messageContent,
				source, topic);
		logger.info("Message=" + message);
		client.publish(consumer, producer, topic, message);
	}

	private String createMessage(NotificationStatusType.Enum status,
			String message, String source, String topic) {
		WorkflowNotificationDocument notifDoc = WorkflowNotificationDocument.Factory
				.newInstance();
		WorkflowNotificationDocument.WorkflowNotification notification = notifDoc
				.addNewWorkflowNotification();

		// set the values in the notification object
		notification.setStatus(status);
		notification.setMessage(message);
		notification.setSource(source);
		Calendar timestamp = new GregorianCalendar();
		timestamp.setTime(new Date());
		notification.setTimestamp(timestamp);
		notification.setTopic(topic);

		// send the notification as an xml string
		// messageBroker.sendNotification(notification.xmlText());
		String notificationMessage = notifDoc.xmlText();
		System.out.println(notificationMessage);
		return notificationMessage;
	}
}
