/*
 This file is licensed under the terms of the Globus Toolkit Public
 License, found at http://www.globus.org/toolkit/download/license.html.
 */
package wsmg.jms;

import java.io.PrintStream;
import java.io.PrintWriter;

public class JMSAdapterException extends Exception {
	Throwable base;

	public JMSAdapterException(String message, Throwable _base) {
		super(message + " Caused by: " + _base.getMessage());
		base = _base;
	}

	public JMSAdapterException(String message) {
		super(message);
	}

	public void printStackTrace(PrintStream s) {
		super.printStackTrace(s);

		if (base != null) {
			s.println("Caused by:");
			base.printStackTrace(s);
		}
	}

	public void printStackTrace(PrintWriter s) {
		super.printStackTrace(s);

		if (base != null) {
			s.println("Caused by:");
			base.printStackTrace(s);
		}
	}
}
