package wsmg.jms;

/**
 * <p>Title: WSNT Project</p>

 * <p>Description: </p>

 * <p>Copyright: Copyright (c) 2004</p>

 * <p>Company: </p>

 * @author Yi Huang

 * @version 1.0

 */

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;

import org.xmlpull.v1.builder.XmlInfosetBuilder;

import wsmg.OutGoingQueue;
import wsmg.SubscriptionState;
import wsmg.config.WSMGParameter;
import wsmg.processors.OutGoingMessage;
import wsmg.util.Counter;
import wsmg.util.TimerThread;
import xsul.MLogger;
import xsul.XmlConstants;

// import org.apache.xmlbeans.XmlObject;

// import wsnt.util.wsntUtility;

public class JMSListener implements MessageListener {
	private final static MLogger logger = MLogger.getLogger();

	private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;

	// String wsntTopicName;
	JMSToWsntConverter converter;

	// JMS_WsntAdapter jms_WsntAdapter;
	// TopicConnection jmsTopicConnection;
	SubscriptionState subscribeState;

	private Counter listenerCounter = new Counter();

	boolean blocked = true;

	private OutGoingMessage outGoingMessage = null;

	private String messageContent = null;

	long listenerId;

	long messageId = 0;

	boolean showTrace = false;

	public JMSListener(
	// JMS_WsntAdapter _jms_WsntAdapter,
			// TopicConnection _jmsTopicConnection,
			SubscriptionState _subscribeRequest, JMSToWsntConverter _converter,
			long listenerId) {
		converter = _converter;
		// jms_WsntAdapter = _jms_WsntAdapter;
		// jmsTopicConnection = _jmsTopicConnection;
		subscribeState = _subscribeRequest;
		this.listenerId = listenerId;
		if (listenerId < 5)
			showTrace = true;

		outGoingMessage = new OutGoingMessage();
		outGoingMessage.addConsumerInfo(subscribeState.getConsumerInfo());
		// outGoingMessage.getConsumerInfo().setConsumerEprStr(subscribeState.getConsumerEprStr());
		// outGoingMessage.getConsumerInfo().setType(subscribeState.getType());
		// outGoingMessage.getConsumerInfo().setUseNotify(subscribeState.isUseNotify());
		if (WSMGParameter.measureMessageRate) {
			TimerThread timerThread = new TimerThread(listenerCounter,
					" ListenerCounter");
			new Thread(timerThread).start();
		}

	}

	public int notifySubscriber(Message message) {
		// String topic =
		// wsntUtility.getElementValue(notificationMessage.getTopic()); //FIXME

		// for(Iterator i = subscriptions.values().iterator(); i.hasNext(); ) {

		// SubscriptionState ss = (SubscriptionState) i.next();

		if (message instanceof TextMessage) {
			TextMessage textMessage = (TextMessage) message;
			try {
				// long startTime=System.currentTimeMillis();
				messageContent = textMessage.getText();
				// long endTime=System.currentTimeMillis();
				// System.out.println("**********"+listenerId+"Time to Get
				// Text="+(endTime-startTime));
			} catch (JMSException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		} else {
			System.out.println("Received message is not a TEXT message.");
			return 0;
		}

		logger.info("sending notification message to:"
				+ subscribeState.getConsumerIPAddressStr());
		long startTime = System.currentTimeMillis();
		subscribeState.setCurNotif(messageContent);
		// outGoingMessage.getConsumerInfo().setPaused(subscribeState.isPaused());
		outGoingMessage.setTextMessage(messageContent);

		OutGoingQueue outGoingQueue = subscribeState.getOutGoingQueue();
		// long endTime=System.currentTimeMillis();
		// System.out.println("**********"+listenerId+" Time to Create
		// OutGoing="+(endTime-startTime));
		long startTime1 = System.currentTimeMillis();

		outGoingQueue.storeNotification(outGoingMessage, listenerId, messageId,
				showTrace);
		long endTime1 = System.currentTimeMillis();
		if (showTrace)
			System.out
					.println("**********" + listenerId + "_" + messageId
							+ " Time to Store From Listener="
							+ (endTime1 - startTime1));
		// }

		/***********************************************************************
		 * Create notify message
		 * 
		 */

		/*
		 * NotifyDocument notifyDoc = NotifyDocument.Factory.newInstance();
		 * NotifyDocument.Notify notify = notifyDoc.addNewNotify();
		 * 
		 * notify.addNewNotificationMessage();
		 * 
		 * notify.setNotificationMessageArray(0, notificationMessage);
		 * 
		 * System.out.println("Notify Message:" + notifyDoc);
		 */

		/*
		 * NotifyDocument notifyDocUseNotify =
		 * NotifyDocument.Factory.newInstance();
		 * 
		 * NotifyDocument.Notify notify = notifyDocUseNotify.addNewNotify();
		 * 
		 * notify.addNewNotificationMessage();
		 * 
		 * notify.setNotificationMessageArray(0, notificationMessage);
		 * 
		 * System.out.println("Notify Message Use Notify:" +
		 * notifyDocUseNotify);
		 * 
		 * XmlObject message = notificationMessage.getMessage();
		 * 
		 * NotifyDocument notifyDocNotUseNotify =
		 * NotifyDocument.Factory.newInstance();
		 */

		/* notifyDocUseNotify.Factory.parse(message.xmlText()); */

		// System.out.println("*******Notify Message Without Notify:" +
		// notifyDocNotUseNotify);

		/** Check Subscription DataBase and send the message to subscriber */

		/*
		 * String subscriptionTopic
		 * =wsntUtility.getElementValue(subscribeRequest.getTopicExpression());
		 * String serviceUrl =
		 * subscribeRequest.getConsumerReference().getAddress().
		 * 
		 * getStringValue();
		 * 
		 * System.out.println("SubscriberUrl=" + serviceUrl);
		 * 
		 * boolean useNotify=subscribeRequest.getUseNotify();
		 * 
		 * //Start rpc services for invocation of notify() in
		 * NotificationConsumer
		 *  // create proxy for remote interface that can be used for RPC
		 * invocation
		 * 
		 * WsntConsumerInterface rpcService =
		 * 
		 * (WsntConsumerInterface) ServiceInvoker.createXBeansRpcProxy(
		 * 
		 * serviceUrl, // location of service
		 * 
		 * WsntConsumerInterface.class // interface of service
		 *  );
		 *  // rpcService.notify(notifyDoc);
		 * 
		 * if(useNotify){
		 * 
		 * rpcService.notify(notifyDocUseNotify);
		 * 
		 * }else{
		 * 
		 * rpcService.notify(notifyDocNotUseNotify);
		 *  }
		 */
		return 0;

	}

	public void onMessage(Message jmsMessage) {
		try {

			// use the foolowing code to test blocking message delivery.
			// It show that if JMS listener doesn't ack, activeMQ will not send
			// another message to the listener.
			// System.out.println("Got a message");
			// int i=0;
			// while(i<100){
			// //// if(blocked){
			// Thread.sleep(180000);
			// //// blocked=false;
			// //// System.out.println("Unblocked!");
			// }
			// System.out.println("Got a messageOk");

			// Test for Return immediately
			// if(listenerCounter.getCounterValue()<1000000000){
			// Thread.sleep(10);
			// listenerCounter.addCounter();
			// return;
			// }

			logger.info("**********EndTime=" + System.currentTimeMillis());
			logger.info("********Got JMS message:" + jmsMessage.toString());

			// XmlElement notifyMessage = (
			// XmlElement) converter.convertToWsnt(jmsMessage);
			// if(notifyMessage == null) {
			// logger.info("IGNORED");
			// return;
			// }
			// needs to be synched because multiple topics use the name
			// ogsaSource

			// and they could receive messages at the same time

			// new-core synchronized (ogsaSource) {

			// synchronized (jms_WsntAdapter) {
			// System.out.println("########Message="+builder.serializeToString(notifyMessage));
			// String
			// msqN=notifyMessage.requiredElement(WidgetService.WSNT_NS,"Message").requiredElement(null,"NCSAEvent").attribute("MessageSequenceNumber").getValue();
			// logger.finest("SequenceNumber="+msqN);

			// Test for delivery messages
			// while(listenerCounter.getCounterValue()<100000){
			messageId++;
			long startTime = System.currentTimeMillis();
			notifySubscriber(jmsMessage);
			long endTime = System.currentTimeMillis();
			if (showTrace)
				System.out.println("**********" + listenerId + "_" + messageId
						+ " Time to handle=" + (endTime - startTime));
			// listenerCounter.addCounter();
			listenerCounter.addCounter(" " + (endTime - startTime));
			// }
			// jmsMessage.acknowledge();
			// }
		} catch (Exception e) {
			// this comes in asynchronously, so there is no point in throwing an
			// exception
			e.printStackTrace();
		}

	}

}
