package wsmg.jms;

/*
 import edu.indiana.extreme.rfx.types.base_types.addressing.*;
 import edu.indiana.extreme.rfx.types.base_types.notification.*;
 import edu.indiana.extreme.rfx.types.base_types.resource_properties.*; */
/*import xsul.types_addressing.*;
 import xsul.types_wsnt.base.*;
 import xsul.types_wsnt.broker.*;
 import xsul.types_wsnt.topics.*;
 import xsul.types_wsrf.properties.*;*/
//import org.apache.xmlbeans.XmlObject;
//import org.apache.xmlbeans.XmlException;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Map;
import java.util.StringTokenizer;

import javax.jms.ExceptionListener;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.Session;
import javax.jms.Topic;
import javax.jms.TopicConnection;
import javax.jms.TopicConnectionFactory;
import javax.jms.TopicPublisher;
import javax.jms.TopicSession;
import javax.jms.TopicSubscriber;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.activemq.ActiveMQConnectionFactory;
import org.xmlpull.v1.builder.XmlElement;
import org.xmlpull.v1.builder.XmlInfosetBuilder;

import wsmg.SubscriptionState;
import wsmg.WsmgAdapter;
import wsmg.WsmgAdapterConnection;
import wsmg.WsmgRuntimeException;
import wsmg.config.WSMGParameter;
import wsmg.processors.AdditionalMessageContent;
import wsmg.util.Counter;
import wsmg.util.TimerThread;
import xsul.MLogger;
import xsul.XmlConstants;
import cgl.narada.jms.GesJmsInitializer;

//import wsnt.*;
//import wsnt.util.wsntUtility;

public class JMS_WsntAdapter extends WsmgAdapter implements ExceptionListener {
	private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;

	private static Hashtable initContextParams = new Hashtable();

	private HashMap subId2Session = null;

	private Map consumerMap = new HashMap();

	private Map producerMap = new HashMap();

	// add static trying to prevent RMI garbage collection (DGC)
	private static TopicConnectionFactory jmsTopicConnectionFactory;

	private static InitialContext jndiContext;

	private String messageCarrier; // specify NaradaBrokering or others, e.g.
									// openJMS

	private final static MLogger logger = MLogger.getLogger();

	// private boolean useJMSTextMessage=false;
	private String jmsTopicFactoryName = null;

	// private String jmsTopicFactoryName = "NaradaBrokering";
	// private String jmsTopicFactoryName = "JmsTopicConnectionFactory";
	// private TopicConnection jmsTopicConnection;
	// private TopicSession jmsTopicSession;
	private String jmsToWsntConverterClassName = null;

	private WsmgAdapter wsntAdapter;

	TopicConnection topicConnection = null;

	TopicSession topicSession = null;

	TopicPublisher jmsTopicPublisher = null;

	WsntToJMSConverter converter = null;

	private Counter publisherCounter = new Counter();

	// private int seqId=0;
	private long listenerId = 0;

	public JMS_WsntAdapter(Map subscriptionDB, Map publisherRegistrationDB) {
		super(subscriptionDB, publisherRegistrationDB);
		subId2Session = new HashMap();
		setCarrier(System.getProperty("wsnt.carrier"));
		if (WSMGParameter.measureMessageRate) {
			TimerThread timerThread = new TimerThread(publisherCounter,
					" PublisherCounter");
			new Thread(timerThread).start();
		}
	}

	public JMS_WsntAdapter(Map subscriptionDB, Map publisherRegistrationDB,
			String carrier) {
		super(subscriptionDB, publisherRegistrationDB);
		subId2Session = new HashMap();
		setCarrier(carrier);
		if (WSMGParameter.measureMessageRate) {
			TimerThread timerThread = new TimerThread(publisherCounter,
					" PublisherCounter");
			new Thread(timerThread).start();
		}
	}

	public void setCarrier(String carrier) {
		messageCarrier = carrier;
		if (messageCarrier.equalsIgnoreCase("narada")) {
			jmsTopicFactoryName = "NaradaBrokering";// not needed
		} else if (messageCarrier.equalsIgnoreCase("openjms")) {
			jmsTopicFactoryName = "JmsTopicConnectionFactory";
		} else if (messageCarrier.equalsIgnoreCase("activeMQ")) { // not
																	// needed
			jmsTopicFactoryName = "ActiveMQConnectionFactory"; // Yi created
																// name for this
																// activeMQ
		} else {
			System.out
					.println("ERROR: carrier specified :"
							+ carrier
							+ " is not supported. Please specify narada or openjms as underlying message carrier.");
			System.exit(0);
		}

	}

	public void initOpenJMS(String providerUrl) {

		// ServiceProperties factoryProp =
		// (ServiceProperties) getProperty(ServiceProperties.FACTORY);
		setInitialJndiProperty("java.naming.factory.initial",
				"org.exolab.jms.jndi.InitialContextFactory");
		setInitialJndiProperty("java.naming.provider.url",
		// "rmi://156.56.104.183:1099");
				providerUrl);
		// "rmi://localhost:1099");
		setInitialJndiProperty("java.naming.factory.url.pkgs",
				"org.jboss.naming:org.jnp.interfaces");
	}

	/**
	 * Sets a parameter to the JNDI InitialContext that is created when you call
	 * start(). All calls to this method should be made before calling start().
	 */
	public void setInitialJndiProperty(String key, String value) {
		if (value != null) {
			initContextParams.put(key, value);
		} else if (initContextParams.containsKey(key)) {
			initContextParams.remove(key);
		}
	}

	/**
	 * Starts the JMS_WsntAdapter. carrierLocation: Example for NaradaBrokering:
	 * "156.56.104.183:3045" Example for openJMS: "rmi://156.56.104.183:1099"
	 * 
	 * @throws WsmgAdapterException
	 */
	public void start(String carrierLocation) {

		currentMessageCache = new Hashtable();
		if (messageCarrier.equalsIgnoreCase("NaradaBrokering")) {
			GesJmsInitializer ini;
			String host = "localhost";
			int port = 3045;
			// ini = new GesJmsInitializer("156.56.104.183", 3045, "niotcp");
			StringTokenizer st = new StringTokenizer(carrierLocation, ":");
			if (st.countTokens() >= 2) {
				host = st.nextToken();
				port = Integer.parseInt(st.nextToken());
			} else if (st.countTokens() == 1) {
				host = st.nextToken();
			}
			ini = new GesJmsInitializer(host, port, "niotcp");
			// messageCarrier = "NaradaBrokering";
			// Lookup a JMS connection factory
			jmsTopicConnectionFactory = (TopicConnectionFactory) ini.lookup();
		} else if (messageCarrier.equalsIgnoreCase("openJMS")) {
			if (carrierLocation == null) {
				carrierLocation = "rmi://localhost:1099";
			}
			initOpenJMS(carrierLocation);
			try {
				jndiContext = new InitialContext(initContextParams);

				jmsTopicConnectionFactory = (TopicConnectionFactory) jndiContext
						.lookup(jmsTopicFactoryName);
			} catch (NamingException e) {
				throw new WsmgRuntimeException("startJMSAdapterError", e);
			}
			// messageCarrier = "openJMS";
		} else if (messageCarrier.equalsIgnoreCase("activeMQ")) {
			// messageCarrier = "activeMQ";
			// ActiveMQConnectionFactory factory = new
			// ActiveMQConnectionFactory("vm://localhost");
			ActiveMQConnectionFactory factory = new ActiveMQConnectionFactory(
					WSMGParameter.TOPIC_BROKER);
			// factory.setUseEmbeddedBroker(true);
			// configure the embedded broker using an XML config file
			// which is either a URL or a resource on the classpath
			// factory.setBrokerXmlConfig("file:../config/activemq.xml");
			jmsTopicConnectionFactory = factory;
			/*
			 * if (carrierLocation == null) { carrierLocation =
			 * "rmi://localhost:1099"; } initOpenJMS(carrierLocation); try {
			 * jndiContext = new InitialContext(initContextParams);
			 * 
			 * jmsTopicConnectionFactory = (TopicConnectionFactory)
			 * jndiContext.lookup( jmsTopicFactoryName ); } catch
			 * (NamingException e) { throw new
			 * WsmgAdapterException("startJMSAdapterError", e ); }
			 */
		}

		/*
		 * jmsTopicConnection =
		 * jmsTopicConnectionFactory.createTopicConnection(); jmsTopicSession =
		 * jmsTopicConnection.createTopicSession( false,
		 * Session.AUTO_ACKNOWLEDGE );
		 */

		logger.finest("JMSAdapter started with jmsTopicFactoryName = "
				+ jmsTopicFactoryName);

	}

	public WsmgAdapterConnection handleSubscribe( SubscriptionState subscribeRequest,
			String subscriptionId) {
		String topicExpression=subscribeRequest.getLocalTopic();
		if(topicExpression==null || topicExpression.length()==0){
			System.out.println("ERROR:WsntAdapterConnection creation failed.");
			return null;
		}
		try {
			JMSToWsntConverter converter;
			if ((jmsToWsntConverterClassName != null)
					&& (jmsToWsntConverterClassName.length() > 0)) {
				converter = (JMSToWsntConverter) Class.forName(
						jmsToWsntConverterClassName).newInstance();
			} else {
				converter = new DefaultJMSToWsntConverter();
			}
			TopicConnection connection = null;
			if (messageCarrier.equals("activeMQ")) {
				// ActiveMQConnectionFactory factory = new
				// ActiveMQConnectionFactory("vm://localhost");
				// jmsTopicConnectionFactory=factory;
				// factory.setUseEmbeddedBroker(true);
				// // configure the embedded broker using an XML config file
				// // which is either a URL or a resource on the classpath
				// factory.setBrokerXmlConfig("file:../config/activemq.xml");

				connection = jmsTopicConnectionFactory.createTopicConnection();
				connection.setExceptionListener(this);
			} else {
				connection = jmsTopicConnectionFactory.createTopicConnection();
			}

			TopicSession session = connection.createTopicSession(false,
					Session.AUTO_ACKNOWLEDGE);
			// TopicSession session = connection.createTopicSession(false,
			// Session.CLIENT_ACKNOWLEDGE);

			Topic topic;
			// if (messageCarrier.equalsIgnoreCase("NaradaBrokering")) {
			// topic = session.createTopic(topicExpression);
			// }
			// else {
			// topic = (Topic) jndiContext.lookup(topicExpression);
			topic = session.createTopic(topicExpression);
			// }
			TopicSubscriber topicSubscriber = session.createSubscriber(topic);

			// TopicSubscriber topicSubscriber =
			// session.createDurableSubscriber(topic,"MySub"+seqId);
			// seqId++;

			JMSListener listener = new JMSListener(subscribeRequest, converter,
					listenerId);
			listenerId++;
			topicSubscriber.setMessageListener(listener);
			connection.start();
			JMS_WsntAdapterConnection wsntAdapterConnection = new JMS_WsntAdapterConnection(
					connection);
			subId2Session.put(subscriptionId, session);
			// topic=null;
			// Cannot close session here, otherwise cannot receive notification
			// message.
			// session.close();
			return wsntAdapterConnection;

		} catch (Exception e) {
			throw new WsmgRuntimeException("jmsToWsntListenerStartError", e);
		}
	}

	public int handleUnsubscribe(String subscriptionId) {
		Session session = (Session) subId2Session.get(subscriptionId);
		if (session != null) {
			try {
				// session.unsubscribe("MySub");
				session.close();
				subId2Session.remove(subscriptionId);
			} catch (JMSException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return 0;
	}

	/*
	 * public int notifySubscriber(XmlElement notificationMessage) throws
	 * Exception {
	 */

	/*
	 * String topic =
	 * wsntUtility.getElementValue(notificationMessage.getTopic());
	 * System.out.println("&&&&&&&&&Topic:" + topic); NotifyDocument
	 * notifyDocUseNotify = NotifyDocument.Factory.newInstance();
	 * NotifyDocument.Notify notify = notifyDocUseNotify.addNewNotify();
	 * notify.addNewNotificationMessage(); notify.setNotificationMessageArray(0,
	 * notificationMessage); System.out.println("Notify Message Use Notify:" +
	 * notifyDocUseNotify); XmlObject message =
	 * notificationMessage.getMessage(); NotifyDocument notifyDocNotUseNotify =
	 * NotifyDocument.Factory.newInstance(); //
	 * notifyDocNotUseNotify.Factory.parse(message.xmlText());
	 * System.out.println("*******Notify Message Without Notify:" +
	 * notifyDocNotUseNotify); for (Enumeration e = subscriptionDB.keys();
	 * e.hasMoreElements(); ) { Object key = e.nextElement();
	 * SubscribeDocument.Subscribe subscribeRequest =
	 * ((SubscriptionEntry)subscriptionDB.get(key)).getSubscribeRequest();
	 * String subscriptionTopic =
	 * wsntUtility.getElementValue(subscribeRequest.getTopicExpression()); if
	 * (subscriptionTopic.compareTo(topic) == 0) { EndpointReferenceType ept=
	 * subscribeRequest.getConsumerReference(); String serviceUrl =
	 * ept.getAddress().getStringValue(); System.out.println("SubscriberUrl=" +
	 * serviceUrl); boolean useNotify=subscribeRequest.getUseNotify(); //Start
	 * rpc services for invocation of notify() in NotificationConsumer // create
	 * proxy for remote interface that can be used for RPC invocation
	 * WsntConsumerInterface rpcService = (WsntConsumerInterface)
	 * ServiceInvoker.createXBeansRpcProxy( serviceUrl, // location of service
	 * WsntConsumerInterface.class // interface of service ); if(useNotify){
	 * rpcService.notify(notifyDocUseNotify); }else{
	 * rpcService.notify(notifyDocNotUseNotify); } } }
	 */
	/*
	 * return 0; }
	 */

	public void handleNotify(String topic, // TODO: Needs to change to more
											// generic type
			AdditionalMessageContent soapHeader, Object message,
			String wsntMessageConverterClassName) {
		XmlElement messageEl;
		String messageStr = null;
		if (message instanceof XmlElement) {
			messageEl = (XmlElement) message;
			messageStr = builder.serializeToString(messageEl);
		} else if (message instanceof String) {
			messageStr = (String) message;
		} else {
			System.out
					.println("ERROR: Invalid message type, must be be either XmlElement or String.");
			return;
		}
		try {
			// String
			// msqN=message.requiredElement(WidgetService.WSNT_NS,"Message").requiredElement(null,"NCSAEvent").attribute("MessageSequenceNumber").getValue();
			// System.out.println("SequenceNumberInHandleNotify="+msqN);

			if (converter == null) {
				if ((wsntMessageConverterClassName != null)
						&& (wsntMessageConverterClassName.length() > 0)) {
					converter = (WsntToJMSConverter) Class.forName(
							wsntMessageConverterClassName).newInstance();
				} else {
					converter = new DefaultWsntToJMSConverter();
				}
			}
			logger.fine("Handling Notification: Topic:" + topic);
			currentMessageCache.put(topic, messageStr);
			if (topicConnection == null) {
				topicConnection = jmsTopicConnectionFactory
						.createTopicConnection();
			}
			if (topicSession == null) {
				topicSession = topicConnection.createTopicSession(false,
						Session.AUTO_ACKNOWLEDGE);
			}
			if (jmsTopicPublisher == null) {
				jmsTopicPublisher = topicSession.createPublisher(null);
			}
			Topic jmsTopic;
			if (messageCarrier.equalsIgnoreCase("NaradaBrokering")) {
				jmsTopic = topicSession.createTopic(topic);
			} else {
				// jmsTopic = (Topic) jndiContext.lookup(topic);
				// TODO: use JNDI to lookup topic object instead of creating one
				// for each topic
				jmsTopic = topicSession.createTopic(topic);
			}

			Message jmsMessage = null;
			jmsMessage = converter.convertToJMS(messageStr, topicSession);
			logger.finest("Publishing message" + jmsMessage.toString());
			// jmsTopicPublisher.setTimeToLive(3600000);

			// while(publisherCounter.getCounterValue()<400000){
			jmsTopicPublisher.publish(jmsTopic, jmsMessage);
			// System.out.println(publisherCounter.getCounterValue());
			publisherCounter.addCounter();
			// Thread.sleep(50);
			// }
			logger.info("**********startTime=" + System.currentTimeMillis());
			// jmsTopicPublisher.close();
			// topicConnection.close();
			jmsMessage = null;
			jmsTopic = null;
			// topicSession.close();
		}

		catch (Exception e) {
			// this comes in asynchronously, so there is no point in throwing an
			// exception
			e.printStackTrace();
		}

	}

	public synchronized void onException(JMSException ex) {
		System.out.println("JMS Exception occured.  Shutting down client.");
	}

}
