package wsmg.measure;

import java.net.URISyntaxException;

import org.exolab.jms.util.CommandLine;

import wsmg.WseClientAPI;
import wsmg.demo.leadCallBack.LeadEventCallBack;
import wsmg.demo.leadCallBack.StopableNotificationConsumer;

/**
 * <p>
 * Title: Ws-Notification
 * </p>
 * 
 * <p>
 * Description:
 * </p>
 * 
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * 
 * <p>
 * Company: Indiana University
 * </p>
 * 
 * @author yi Huang
 * @version 1.0
 */
public class SimpleClient implements Runnable {
	public SimpleClient() {
	}

	public void run() {

	}

	public static void main(String[] args) throws URISyntaxException {
		CommandLine cmdline = new CommandLine(args);
		String brokerUrl = cmdline.value("broker", "localhost:12346");
		String topic = cmdline.value("topic",
				"dn=gannon/myInvestigation/experiment23");
		int listenPort = Integer.parseInt(cmdline.value("listenPort", "19999"));
		StopableNotificationConsumer nc = new StopableNotificationConsumer();
		LeadEventCallBack myEventCallback = new LeadEventCallBack();
		nc.setEventCallback(myEventCallback);
		// String brokerUrl="rainier.extreme.indiana.edu:12346";
		// Set brokerURL=localhost:12345
		// Set Topic=AAA
		// listening to port 19999, non-blocking
		nc.startNotificationConsumer(brokerUrl, topic, null, listenPort);
		// Create subscription for MyLeadAgent
		// String subId=nc.subscribe("bitternut.cs.indiana.edu:19999",topic);
		// method in myEventCallback Implementation, not required in Callback
		// Interface.
		// Add expected messages
		// myEventCallback.addExpectedMessage("Decode done.");
		myEventCallback.addExpectedMessage("Thredd done.");
		// myEventCallback.addExpectedMessage("FINISHED_");
		// launch other components
		System.out.println("Doing other stuff");
		// TestWSE_Publisher publisher=null;
		long start = 0;
		try {
			/*
			 * publisher.main(new String[] {"-consumer", brokerUrl, "-topic",
			 * topic, "-message", "Thredd done."});
			 */
			WseClientAPI client = new WseClientAPI();
			start = System.currentTimeMillis();
			client.publish(brokerUrl, topic, "Thredd done.");

		} catch (Exception ex) {
			ex.printStackTrace();
		}
		/*
		 * TestXmlbeanPublisher xmlPublisher=new TestXmlbeanPublisher();
		 * xmlPublisher.main(new String[]{"-consumer", brokerUrl,
		 * "-topic",topic});
		 */
		// Wait for all messages after launching all the components, blocks here
		nc.waitAllMessages();
		long stop = System.currentTimeMillis();
		long diff = stop - start;
		System.out.println("Start=" + start + "    stop=" + stop);
		System.out.println("Diff=" + diff + "ms");
		// Unscubscribe MyLeadAgent
		// nc.unSubscribe(subId);
		// shut down other components after all "Done" messages arrive
	}
}
