package wsmg.measure;

import java.net.URISyntaxException;

import org.exolab.jms.util.CommandLine;

import wsmg.WseClientAPI;
import wsmg.WsmgClientAPI;
import wsmg.WsntClientAPI;
import wsmg.config.WSMGParameter;
import wsmg.util.WsmgUtil;

/**
 * <p>
 * Title: Ws-Notification
 * </p>
 * 
 * <p>
 * Description:
 * </p>
 * 
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * 
 * <p>
 * Company: Indiana University
 * </p>
 * 
 * @author yi Huang
 * @version 1.0
 */
public class StressTest {
	public StressTest() {
	}

	public static void main(String[] args) throws URISyntaxException,
			InterruptedException {
		CommandLine cmdline = new CommandLine(args);
		String brokerUrl = cmdline.value("broker",
				"rainier.extreme.indiana.edu:12346");
		String topic = cmdline.value("topic",
				null);
		String xpath = cmdline.value("xpath",
				null);
		int num = Integer.parseInt(cmdline.value("threadNum", "1"));
		int totalConsumer = Integer.parseInt(cmdline.value("consumerNum", "1"));
		int listenPort = Integer.parseInt(cmdline.value("listenPort", "18888"));

		// totalConsumer=1;
		for (int i = 0; i < totalConsumer; i++) {
			NotificationConsumerThread notificationConsumerThread = new NotificationConsumerThread(
					listenPort + i);
			new Thread(notificationConsumerThread).start();
		}
		WsmgClientAPI client = null;
		if (WSMGParameter.stressTestSubscriberUseWSE) {
			client = new WseClientAPI();
		} else {
			client = new WsntClientAPI();
		}
		String hostIP = WsmgUtil.getHostIP();
		for (int i = 0; i < totalConsumer; i++) {
			int port = listenPort + i;
			String subscriptionId = client.subscribe(brokerUrl, "http://"
					+ hostIP + ":" + port, topic,xpath);
		}
		num = 0;
		// Create multiple thread to publish messages
		for (int i = 0; i < num; i++) {
			XmlPublisherThread xmlPublisherThread = new XmlPublisherThread(
					brokerUrl, topic);
			new Thread(xmlPublisherThread).start();
		}
		// Thread.sleep(2000);
		// client.unSubscribe(brokerUrl,subscriptionId);

	}
}
