package wsmg.measure;

import java.io.StringReader;

import org.xmlpull.v1.builder.XmlElement;
import org.xmlpull.v1.builder.XmlInfosetBuilder;
import org.xmlpull.v1.builder.XmlNamespace;

import wsmg.NotificationHandler;
import wsmg.WsmgConstants;
import wsmg.config.WSMGParameter;
import wsmg.util.Counter;
import wsmg.util.TimerThread;
import wsmg.util.WsmgUtil;
import xsul.MLogger;
import xsul.XmlConstants;


public class TestEventNotificationHandler
    implements NotificationHandler {
  private final static MLogger logger = MLogger.getLogger();
 private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;
 public final static XmlNamespace LEAD_NS = builder.newNamespace(
     "lead",
      "http://lead.extreme.indiana.edu/namespaces/2004/10/lead");
private Counter counter=new Counter(); 
public int totalDuration=0;
long lastTimeStamp=0;
long lastSendingTimeStamp=0;

  public TestEventNotificationHandler() {
		if(WSMGParameter.measureMessageRate){		  
	  TimerThread timerThread = new TimerThread(counter, " NotificationHandler");
        new Thread(timerThread).start();	
	  }
  }


 public synchronized void handleNotification(String soapMessage) {
 long receivingTimeStamp=System.nanoTime();	
 /*if(counter>=642){
 	System.out.println("got #"+counter);
 }*/
 counter.addCounter();
//System.out.println("Received= "+soapMessage);
 
 String messageContent=null;
//   logger.finest("*******lead message handler Received message********");
//   logger.finest(soapMessage);
//   //Get the real message content
   messageContent=WsmgUtil.getSoapBodyContent(soapMessage);
   XmlElement bodyContentEl = builder.parseFragmentFromReader(new StringReader(
		   messageContent));
   if (WsmgConstants.WSNT_NS.equals(bodyContentEl.getNamespace())) {
	   //assume only one NotificationMessage here for our test
	   XmlElement messageEl=bodyContentEl.element(WsmgConstants.WSNT_NS, "NotificationMessage").element(WsmgConstants.WSNT_NS, "Message");
	   messageContent=WsmgUtil.getContentInsideAnXmlElementAsString(messageEl);
   }
   Event testEvent=new Event(messageContent);
long sendingTimeStamp=testEvent.getTimeStampInMillisecond();
String seqID=testEvent.getSeqID();
long receiveInterval=receivingTimeStamp-lastTimeStamp;
long sendInterval=sendingTimeStamp-lastSendingTimeStamp;
long travelTime=receivingTimeStamp-sendingTimeStamp;
long send_receive_Interval_Diff=sendInterval-receiveInterval;
//System.out.println(counter.getCounterValue()+" "+seqID+" "+receiveInterval+ " " +sendInterval+" "+travelTime+" "+send_receive_Interval_Diff);
lastTimeStamp=receivingTimeStamp;
lastSendingTimeStamp=sendingTimeStamp;
 //  if(topic!=null){
    // cb.deliverEvent(messageContent, topic);
//   	long duration=receivingTimeStamp-sendingTimeStamp;
//   	if(counter>=0) totalDuration+=duration;

   //	System.out.println("###############Got event #"+seqID+" duration="+duration);
// 	System.out.println(seqID+" "+sendingTimeStamp+" "+receivingTimeStamp);
//  	if(counter%100==0) System.out.println("Average duration of "+counter+" messages="+(double)totalDuration/(double)counter); 
 /*  }else{
     logger.finest("######Received an mal-formated message (not LEAD message)");
   }*/
/*   XmlElement messageEl=builder.parseFragmentFromReader(new StringReader(
      messageContent));

   XmlElement topicEl=messageEl.element(LEAD_NS,"topic");
   if(topicEl!=null){
     String topicLocalString = topicEl.requiredTextContent();
     cb.deliverEvent(messageContent, topicLocalString);
   }else{
     logger.finest("######Received an mal-formated message (not LEAD message)");
   }*/
     }
// class TimerThread implements Runnable{	 
//	  public void run(){
//	       long currentTime=0; 
//	       long interval=1000;
//	       long lastCounter=0;
//	       int idleCount=0;
//			//wait for about 5 sec and start from 000 time so that other thread can start together		
//			currentTime=System.currentTimeMillis();
//			long launchTime=((currentTime+2000)/1000)*1000;
//			long sleepTime=launchTime-currentTime;
//			System.out.println("launchTime="+launchTime+" SleepTime="+sleepTime);
//			try {
//				Thread.sleep(sleepTime);
//			} catch (InterruptedException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}
//	       while(true){
//			currentTime=System.currentTimeMillis();
//			long receivedCount=counter-lastCounter;
//			lastCounter=counter;
//			if(receivedCount==0){
//				idleCount++;
//			}else{
//				idleCount=0;
//			}
//			if(receivedCount>0 ||(receivedCount==0 && idleCount<3)){
//	    	System.out.println("time="+currentTime+" counter="+ counter+" received="+receivedCount);   
//			}
//			launchTime=launchTime+interval;
//			sleepTime=launchTime-currentTime;
//		//	System.out.println("launchTime="+launchTime+" SleepTime="+sleepTime);
//            if(sleepTime<0) sleepTime=0;
//			try {
//				Thread.sleep(sleepTime);
//			} catch (InterruptedException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}
//	       }
//	  }
// }


}
