/*
 * Copyright (c) 2005 Extreme! Lab, Indiana University. All rights reserved.
 *
 * This software is open source. See the bottom of this file for the licence.
 *
 * $Id: Timer.java,v 1.2 2006/01/04 17:47:21 cherath Exp $
 */

package wsmg.measure;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Satoshi Shirasuna
 */
public class Timer {

	private static boolean enabled = false;

	private static List iterations = new ArrayList();

	private static List times;

	private static int iteration = -1;

	private static int column = 0;

	private static long start;

	public static void enable() {
		enabled = true;
	}

	public static void disable() {
		enabled = false;
	}

	public static void newIteration() {
		if (enabled) {
			iteration++;
			times = new ArrayList();
			iterations.add(times);
			System.out.println();
		}
	}

	public static void start() {
		if (enabled) {
			start = System.currentTimeMillis();
		}
	}

	public static void stop() {
		if (enabled) {
			long end = System.currentTimeMillis();
			long time = end - start;
			addTime(time);
		}
	}

	public static void addTime(long time) {
		if (enabled) {
			System.out.print(time + "\t");
			times.add(new Long(time));
		}
	}

	public static void print() {
		int numIteration = iterations.size();
		int numColumn = ((List) iterations.get(0)).size();
		double[] aveTimes = new double[numColumn];

		for (int i = 0; i < numIteration; i++) {
			List times = (List) iterations.get(i);
			for (int j = 0; j < numColumn; j++) {
				aveTimes[j] += ((Long) times.get(j)).doubleValue()
						/ numIteration;
			}
		}

		System.out.println();
		System.out.println("Average:");
		for (int i = 0; i < numColumn; i++) {
			System.out.print(aveTimes[i] + "\t");
		}
		System.out.println();
	}
}

/*
 * Indiana University Extreme! Lab Software License, Version 1.2
 * 
 * Copyright (c) 2005 The Trustees of Indiana University. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 * 
 * 2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 * 
 * 3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 * 
 * "This product includes software developed by the Indiana University Extreme!
 * Lab. For further information please visit http://www.extreme.indiana.edu/"
 * 
 * Alternatively, this acknowledgment may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 * 
 * 4) The name "Indiana University" or "Indiana University Extreme! Lab" shall
 * not be used to endorse or promote products derived from this software without
 * prior written permission from Indiana University. For written permission,
 * please contact http://www.extreme.indiana.edu/.
 * 
 * 5) Products derived from this software may not use "Indiana University" name
 * nor may "Indiana University" appear in their name, without prior written
 * permission of the Indiana University.
 * 
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of any
 * other entity. Indiana University disclaims any liability to any recipient for
 * claims brought by any other entity based on infringement of intellectual
 * property rights or otherwise.
 * 
 * LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 * NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 * INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 * "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 * LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 * GENERATED USING SOFTWARE.
 */
