/*
 * Created on 2005-9-1
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package wsmg.processors;

import java.net.URI;
import java.util.Iterator;

import javax.jms.Connection;
import javax.jms.DeliveryMode;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.ObjectMessage;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.xml.namespace.QName;

import org.activemq.ActiveMQConnectionFactory;
import org.xmlpull.v1.builder.XmlElement;
import org.xmlpull.v1.builder.XmlInfosetBuilder;

import wsmg.NotificationProducer;
import wsmg.ProcessingContext;
import wsmg.SoapClientFault;
import wsmg.SubscriptionState;
import wsmg.WsmgAdapter;
import wsmg.WsmgConfig;
import wsmg.WsmgConstants;
import xsul.MLogger;
import xsul.XmlConstants;
import xsul.util.XsulUtil;
import wsmg.config.WSMGParameter;
import wsmg.measure.Event;
import wsmg.util.WsmgUtil;
import xsul.ws_addressing.WsaEndpointReference;

/**
 * @author yihuan
 *
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class NotificationConsumer {
    
    private final static MLogger logger = MLogger.getLogger();
    private final static boolean IS_FINEST = logger.isFinestEnabled();
    
    private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;
    
    WsmgConfig wsmgConfig = null;
    
    SubscriptionManager subscriptionManager = null;
    
    int counter = 1;
    long messageCounter=0;
    
    int lastId = 0;
    
    MessageProducer producer = null;
    
    Session session = null;
    
    WsmgAdapter wsmgAdapter = null;
    
    XmlElement soapHeader = null;
    
    public NotificationConsumer(WsmgConfig wsmgConfig,
                                SubscriptionManager subscriptionManager) {
        this.wsmgConfig = wsmgConfig;
        this.subscriptionManager = subscriptionManager;
        wsmgAdapter = wsmgConfig.getWsntAdapter();
        if (WSMGParameter.useIncomingQueue) {
            try {
                // Create a ConnectionFactory
                // ActiveMQConnectionFactory connectionFactory = new
                // ActiveMQConnectionFactory("tcp://localhost:61616");
                ActiveMQConnectionFactory connectionFactory = new ActiveMQConnectionFactory(
                    WSMGParameter.INCOMING_QUEUE_BROKER);
                // connectionFactory.setBrokerXmlConfig("file:../config/activemq.xml");
                // Create a Connection
                Connection connection = connectionFactory.createConnection();
                connection.start();
                
                // Create a Session
                session = connection.createSession(false,
                                                   Session.AUTO_ACKNOWLEDGE);
                
                // Create the destination (Topic or Queue)
                Destination destination = session.createQueue("INCOMING");
                
                // Create a MessageProducer from the Session to the Topic or
                // Queue
                producer = session.createProducer(destination);
                producer.setDeliveryMode(DeliveryMode.NON_PERSISTENT);
                // producer.setDeliveryMode(DeliveryMode.PERSISTENT);
            } catch (Exception e) {
                System.out.println("Caught: " + e);
                e.printStackTrace();
            }
            PublisherThread publisherThread = new PublisherThread(wsmgConfig);
            new Thread(publisherThread).start();
        }
    }
    
    public void notify(ProcessingContext ctx) {
        XmlElement soapBody = ctx.soapBody;
        String topicLocalString = null;
        XmlElement notificationMessageEl = null;
        //        WsaEndpointReference producerReference = null;
        //        String soapHeaderString = null;
        boolean noElements = true;
        String topicElString=null;
        String producerReferenceElString=null;
        String trackId="trackId_A_"+messageCounter;
        XmlElement envelope = ctx.envelope;
        if(WSMGParameter.showTrackId){
            System.out.println(trackId+": received." );
            //             System.out.println(trackId+" Content="+builder.serializeToString(envelope));
        }
        // Test for receive messageID
        
        String seqID = soapBody.getAttributeValue(null, "wsmgCounter");
        if (seqID != null) {
            int currentId = Integer.parseInt(seqID);
            
            // System.out.print(
            // " "+seqID
            // );
            // if(currentId-lastId!=1 && currentId-lastId!=0){
            // System.out.print("***jump"+lastId+"-->"+currentId);
            // }
            lastId = currentId;
            // System.out.print("\n");
        }
        soapHeader = envelope.element(null, "Header");
        if (soapHeader == null) {
            throw new SoapClientFault("Missing soap header.");
        }
        
        String actionString = requiredHeaderElementContent(WsmgConstants.WSA_ACTION_HEADER_NAME);
        String messageIdString = requiredHeaderElementContent(WsmgConstants.WSA_MESSAGE_ID_HEADER_NAME);
        
        AdditionalMessageContent additionalMessageContent = new AdditionalMessageContent(
            actionString, messageIdString);
        additionalMessageContent.setTrackId(trackId);
        
        long startTime = IS_FINEST ? System.nanoTime() : 0;
        if (WsmgConstants.WSNT_NS.equals(ctx.soapBody.getNamespace())) {
            for (Iterator iter = ctx.soapBody.elements(WsmgConstants.WSNT_NS,
                                                       "NotificationMessage").iterator(); iter.hasNext();) {
                noElements = false;
                XmlElement wrappedMessageEl = (XmlElement) iter.next();
                
                XmlElement topicEl = wrappedMessageEl.requiredElement(
                    WsmgConstants.WSNT_NS, "Topic");
                if(topicEl!=null){
                    //  String topicExpression = topicEl.requiredTextContent();
                    //                String dialectString = topicEl.attribute("Dialect").getValue();
                    //                if (dialectString
                    //                    .equals(WsmgConstants.TOPIC_EXPRESSION_SIMPLE_DIALECT)) {
                    topicLocalString = WsmgUtil.getTopicLocalString(topicEl);
                    //                } else {
                    //                    throw new SoapClientFault("Unkown dialect: "
                    //                                              + dialectString);
                    //                }
                    
                    topicElString=builder.serializeToString(topicEl);
                    additionalMessageContent.setTopicElement(topicElString);
                }
                XmlElement producerReferenceEl = wrappedMessageEl.element(WsmgConstants.WSNT_NS, "ProducerReference");
                if(producerReferenceEl!=null){
                    producerReferenceElString=builder.serializeToString(producerReferenceEl);
                    additionalMessageContent.setProducerReference(producerReferenceElString);
                }
                
                notificationMessageEl=(XmlElement) wrappedMessageEl.element(WsmgConstants.WSNT_NS, "Message").requiredElementContent().iterator().next();
                
                sendMessage(notificationMessageEl, topicLocalString, additionalMessageContent);
                // XmlElement producerReferenceEl =
                // notificationMessageEl.element(WsmgConstants.WSNT_NS,
                // "ProducerReference");
                // if (producerReferenceEl != null) {
                // producerReference = new
                // WsaEndpointReference(producerReferenceEl);
                // producerReference.validateData();
                // }
            }
            if (noElements) {
                throw new SoapClientFault("at least one element is required");
            }
        } else { // WSE Notifications No specific namespace
            
            XmlElement topicEl = soapHeader.element(WsmgConstants.WSNT_NS,
                                                    "Topic");
            
            
            if (topicEl == null) {
                if(ctx.getTopicFromUrl() != null) {
                    topicLocalString = ctx.getTopicFromUrl();
                    topicElString="<wsnt:Topic " +
                        "Dialect=\"http://www.ibm.com/xmlns/stdwip/web-services/WS-Topics/TopicExpression/simple\" " +
                        "xmlns:ns2=\"http://tutorial.globus.org/auction\" " +
                        "xmlns:wsnt=\"http://www.ibm.com/xmlns/stdwip/web-services/WS-BaseNotification\">" +
                        "ns2:"+ctx.getTopicFromUrl()+"</wsnt:Topic>";
                    /// }
                    additionalMessageContent.setTopicElement(topicElString);
                } else {
                    //                topicLocalString =null;
                    //                Iterator iterator = ctx.getEnvelope().element(WsmgConstants.SOAP_NS, "Header").element(WsmgConstants.WSA_NS, "To").children();
                    //                if(iterator.hasNext()){
                    //                    topicLocalString = iterator.next().toString();
                    //                }
                    
                    //if(topicLocalString == null){
                    
                    topicLocalString = "wseTopic";
                    topicElString="<wsnt:Topic " +
                        "Dialect=\"http://www.ibm.com/xmlns/stdwip/web-services/WS-Topics/TopicExpression/simple\" " +
                        "xmlns:ns2=\"http://tutorial.globus.org/auction\" " +
                        "xmlns:wsnt=\"http://www.ibm.com/xmlns/stdwip/web-services/WS-BaseNotification\">" +
                        "ns2:wseTopic</wsnt:Topic>";
                    /// }
                    additionalMessageContent.setTopicElement(topicElString);
                }
            } else {
                //                String topicExpression = topicEl.requiredTextContent();
                //                QName topicExpressionQName = Util.toQName(topicEl,
                //                                                          topicExpression);
                topicLocalString = WsmgUtil.getTopicLocalString(topicEl);
                topicElString=builder.serializeToString(topicEl);
                additionalMessageContent.setTopicElement(topicElString);
            }
            /*
             * try { //I created the address http://anonymousSender since WSE
             * messages don't have sender's address, while WSNT has
             * ProducerReference producerReference = new
             * WsaEndpointReference(new URI( "http://anonymousSender")); } catch
             * (URISyntaxException ex) { ex.printStackTrace(); }
             */
            
            //            notificationMessageEl = WsmgConstants.builder.newFragment(
            //                WsmgConstants.WSNT_NS, "NotificationMessage");
            //            notificationMessageEl.addElement(WsmgConstants.WSNT_NS, "Message")
            //                .addChild(message);
            
            sendMessage(soapBody, topicLocalString, additionalMessageContent);
            
        }
        
        ctx.respMessage.addAttribute("trackId",trackId);
        messageCounter++;
        //        if (IS_FINEST) {
        //            long endTime = System.nanoTime();
        //            logger.finest("" + (endTime - startTime));
        //        }
        
        // if (wsmgConfig.isHasCarrier()) {
        // try {
        // wsmgConfig.getWsntAdapter().handleNotify(topicLocalString,
        // producerReference,
        // notificationMessageEl, null);
        // }
        // catch (Exception e) {
        // e.printStackTrace();
        // }
        //        String producerReferenceString = null;
        //        if (producerReference != null) {
        //            // producerReferenceString=builder.serializeToString(producerReference);
        //            soapHeaderString = builder.serializeToString(soapHeader);
        //        }
        //        if (WSMGParameter.useIncomingQueue) { // use incoming queue
        //            String notificationMessage = builder
        //                .serializeToString(notificationMessageEl);
        //            // String
        //            // producerReferenceString=builder.serializeToString(producerReference);
        //            ReceivedMessage receivedMessage = new ReceivedMessage(
        //                topicLocalString, unChangedHeaderContent,
        //                notificationMessage, null);
        //
        //            try {
        //                ObjectMessage messageOdj = session
        //                    .createObjectMessage(receivedMessage);
        //                producer.send(messageOdj);
        //            } catch (JMSException e1) {
        //                // TODO Auto-generated catch block
        //                System.out
        //                    .println("Error in putting incoming messages in queue.");
        //                e1.printStackTrace();
        //            }
        //        } else { // not use incoming queue
        //            wsmgAdapter.handleNotify(topicLocalString, unChangedHeaderContent,
        //                                     notificationMessageEl, null);
        //        }
        
        // }
        // else { //No carrier
        // //TODO BUG!!! doesn't check the topic match. Need to add topic match.
        // Currently send to all subscribers.
        // generateNotificationAsBroker(notificationMessageEl);
        // }
    }
    
    
    private void sendMessage(XmlElement notificationMessageEl, String topicLocalString, AdditionalMessageContent additionalMessageContent){
        
        if (WSMGParameter.useIncomingQueue) { // use incoming queue
            String notificationMessage = builder
                .serializeToString(notificationMessageEl);
            // String
            // producerReferenceString=builder.serializeToString(producerReference);
            ReceivedMessage receivedMessage = new ReceivedMessage(
                topicLocalString, additionalMessageContent,
                notificationMessage, null);
            
            try {
                ObjectMessage messageOdj = session
                    .createObjectMessage(receivedMessage);
                producer.send(messageOdj);
            } catch (JMSException e1) {
                // TODO Auto-generated catch block
                System.out
                    .println("Error in putting incoming messages in queue.");
                e1.printStackTrace();
            }
            if(WSMGParameter.showTrackId)
                System.out.println(additionalMessageContent.getTrackId()+": putIn Incoming queue.");
        } else { // not use incoming queue
            wsmgAdapter.handleNotify(topicLocalString, additionalMessageContent,
                                     notificationMessageEl, null);
        }
        
    }
    
    private String requiredHeaderElementContent(String elementName) {
        XmlElement headerEl = soapHeader.element(null, elementName);
        String contentString;
        if (headerEl != null) {
            contentString = headerEl.requiredTextContent();
            return contentString;
        } else {
            throw new SoapClientFault("No header element '"+elementName+"' in SOAP header.");
        }
    }
    
    private void generateNotificationAsBroker(XmlElement notificationMessage) {
        // get lis tof all subscribers and notify them
        final XmlElement messageToNotify = notificationMessage;
        Runnable r = new Runnable() {
            public void run() {
                try {
                    for (Iterator i = subscriptionManager.getSubscriptions()
                             .values().iterator(); i.hasNext();) {
                        SubscriptionState ss = (SubscriptionState) i.next();
                        // ss.sendNotificationByBroker(messageToNotify);
                        NotificationProducer notifProducer = new NotificationProducer();
                        notifProducer.sendNotification(messageToNotify, "wsnt",
                                                       ss.getConsumerReference());
                    }
                } catch (Exception e) {
                    logger.severe(
                        "real problem with notificaiton thread: " + e, e);
                }
            }
        };
        Thread notifcationThread = new Thread(r, "notifcation thread "
                                                  + (counter++));
        notifcationThread.start();
    }
    
    
}
