/*
 * Created on 2005-9-1
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package wsmg.processors;

import java.io.IOException;
import java.io.StringReader;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;
import java.net.SocketTimeoutException;
import java.net.URI;
import java.net.UnknownHostException;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import javax.xml.namespace.QName;

import org.xmlpull.v1.builder.XmlAttribute;
import org.xmlpull.v1.builder.XmlBuilderException;
import org.xmlpull.v1.builder.XmlElement;

import edu.berkeley.cs.db.yfilterplus.queryparser.Query;
import edu.berkeley.cs.db.yfilterplus.queryparser.XPQuery;

import wsmg.ElementLiteralConstants;
import wsmg.OutGoingQueue;
import wsmg.ProcessingContext;
import wsmg.SoapClientFault;
import wsmg.SubscriptionEntry;
import wsmg.SubscriptionState;
import wsmg.WsmgAdapterConnection;
import wsmg.WsmgConfig;
import wsmg.WsmgConstants;
import wsmg.config.WSMGParameter;
import wsmg.db.SubscriptionDB;
import wsmg.measure.XmlPublisherThread;
import wsmg.measure.profile.RunTimeStatistics;
import wsmg.util.WseUtil;
import wsmg.util.WsmgUtil;
import wsmg.xsul.XSULDedicatedBrockerService;
import xsul.DataValidationException;
import xsul.MLogger;
import xsul.util.XsulUtil;
import xsul.ws_addressing.WsAddressing;
import xsul.ws_addressing.WsaEndpointReference;

/**
 * Manages subscribers.
 *
 */
public class SubscriptionManager {
    private final static MLogger logger = MLogger.getLogger();

    private Map subscriptions = new HashMap(); // JDK15
    // Map<String,SubscriptionState>

    private SubscriptionDB subscriptionDB = new SubscriptionDB();

    private static int counter = 1;

    private URI serviceLocation;

    private WsmgConfig wsmgConfig;

    private OutGoingQueue outGoingQueue;

    public SubscriptionManager(WsmgConfig wsmgConfig) {
        this.serviceLocation = wsmgConfig.getServiceLocation();
        this.wsmgConfig = wsmgConfig;
        outGoingQueue = new OutGoingQueue();
        if(WSMGParameter.enableAutoCleanSubscriptions){
            CleanUpThread cleanUpThread = new CleanUpThread();
            //       logger.info("starting cleanup thread cleanUpThread="+cleanUpThread);
            Thread t = new Thread(cleanUpThread);
            t.start();
            //     logger.info("started thread t="+t);

        }
    }

    /**
     * @return Returns the subscriptions.
     */
    public Map getSubscriptions() {
        return subscriptions;
    }

    public void subscribe(ProcessingContext ctx) throws XmlBuilderException {
        XmlElement subscribeEl = ctx.soapBody;

        //        // add Filter@Dialect Topic in case of topic being in URL
        //        if(ctx.getTopicFromUrl() != null) {
        //            String topicFromUrl = ctx.getTopicFromUrl();
        //            //<wse:Filter xmlns:wse="http://schemas.xmlsoap.org/ws/2004/08/eventing"
        //            // Dialect="http://www.ibm.com/xmlns/stdwip/web-services/WS-Topics/TopicExpression/simple"
        //            // xmlns:widget="http://widgets.com">widget:TestTopic</wse:Filter>
        //            XmlElement filterEl = subscribeEl.addElement(WsmgConstants.WSE_NS, WsmgConstants.WSE_FILTER);
        //            filterEl.addAttribute(WsmgConstants.WSE_DIALECT_ATTR,
        //                                  WsmgConstants.TOPIC_EXPRESSION_SIMPLE_DIALECT);
        //            filterEl.declareNamespace(WsmgConstants.WIDGET_NS);
        //            filterEl.addChild(WsmgConstants.WIDGET_NS.getPrefix()+":"+topicFromUrl);
        //            if(logger.isFinestEnabled()) {
        //                String filterElStr = WsmgConstants.builder.serializeToString(filterEl);
        //                logger.finest("added for "+topicFromUrl+" "+filterElStr);
        //            }
        //        }


        String subId = createSubscription(null, subscribeEl, ctx.getTopicFromUrl());
        if(subId==null){
            System.out.println("ERROR: No subscription created.");
            return;
        }
        if (WsmgConstants.WSE_NS.equals(ctx.soapBody.getNamespace())) {
            WsaEndpointReference subscriptionManagerEl = new WsaEndpointReference(
                WsAddressing.NS_2004_08,serviceLocation);
            subscriptionManagerEl.setNamespace(WsmgConstants.WSE_NS);
            subscriptionManagerEl.setName("SubscriptionManager");
            // TODO_WSE: change referenceProperties to ReferenceParameter
            subscriptionManagerEl.getReferenceProperties().addElement(
                WsmgConstants.WSE_NS, WsmgConstants.SUBSCRIPTION_ID)
                .addChild(subId);
            XmlElement expiresEl = WsmgConstants.builder.newFragment(
                WsmgConstants.WSE_NS, "Expires");

            // Get a Calendar for current locale and time zone
            Calendar cal = Calendar.getInstance();
            // currentDate.setDate(currentDate.getDate()+1);
            // Get a Date object that represents 30 days from now
            Date currentDate = new Date(); // Current date
            cal.setTime(currentDate); // Set it in the Calendar object
            cal.add(Calendar.DATE, 30); // Add 30 days
            Date expiration = cal.getTime(); // Retrieve the resulting date
            String dateString = WseUtil.getXsdDateTime(expiration);

            expiresEl.addChild(dateString);
            // expiresEl.addChild(timestamp.toString());
            ctx.respMessage.addElement(subscriptionManagerEl);
            ctx.respMessage.addElement(expiresEl);
        } else { // WSNT
            WsaEndpointReference subscriptionRef = new WsaEndpointReference(
                serviceLocation);
            subscriptionRef.setNamespace(WsmgConstants.WSNT_NS);
            subscriptionRef.setName("SubscriptionReference");
            subscriptionRef.getReferenceProperties().addElement(
                WsmgConstants.WSE_NS, WsmgConstants.SUBSCRIPTION_ID)
                .addChild(subId);
            ctx.respMessage.addElement(subscriptionRef);
        }
        RunTimeStatistics.totalSubscriptions++;
    }

    private String createSubscription(String subscriptionId,
                                      XmlElement subscribeEl,
                                      String topicFromUrl) {
        String topicExpression = null; // Get topic String.
        String dialectString = null; // Get dialect String
        WsaEndpointReference cr = null;
        boolean useNotify = true;
        String topicLocalString = "";
        String xpathString = "";
        SubscriptionState state = null;

        boolean wsrmEnabled = false;
        String key = null;

        // Create producerRef to be used in the messages to send out
        WsaEndpointReference producerRef = new WsaEndpointReference(
            serviceLocation);
        producerRef.setNamespace(WsmgConstants.WSNT_NS);
        producerRef.setName("ProducerReference");
        String type=null;
        // Handle WSE
        if (WsmgConstants.WSE_NS.equals(subscribeEl.getNamespace())) {
            type="wse";
            // Get Consumer Reference
            cr = new WsaEndpointReference(subscribeEl.requiredElement(
                                              WsmgConstants.WSE_NS, WsmgConstants.WSE_DELIVERY_TO).element(
                                              WsmgConstants.WSE_NS, WsmgConstants.WSE_NOTIFY_TO));
            if (cr == null) {
                throw new SoapClientFault(
                    "Only Push delivery Mode (NotifyTo) is supported in WSE");
            }

            // Set useNotify=false since this is WSE
            useNotify = false;

            // Get topic
            XmlElement filterEl = null;
            filterEl = subscribeEl.element(WsmgConstants.WSE_NS, WsmgConstants.WSE_FILTER);
            if (filterEl == null) {
                if(topicFromUrl != null) { // use topicFromUrl if was provided
                    topicLocalString = topicFromUrl;
                    logger.finest("got topicLocalString="+topicLocalString);
                } else { // otherwise it is subscribe to ALL topics
                    topicLocalString = WsmgConstants.WILDCARD_TOPIC;
                }
                //                topicLocalString = "wseTopic";
                //                // a special topic, used in WSNT and JMS. Do not use a wildcard topic here since wildcard string varies by system
            } else {
                String filterDialect = filterEl.attribute(WsmgConstants.WSE_DIALECT_ATTR).getValue();
                //Attribute doesn't have default neamespace
                //   String filterDialect =
                //       filterEl.attribute(WSE_NS,"Dialect").getValue();
                if (filterDialect.compareTo(WsmgConstants.
                                                TOPIC_EXPRESSION_SIMPLE_DIALECT) == 0) {
                    //                        topicExpression = filterEl.requiredTextContent();
                    //                        try{
                    //                        QName topicExpressionQName = XsulUtil.toQName(filterEl,
                    //                            topicExpression);
                    topicLocalString = WsmgUtil.getTopicLocalString(filterEl);

                    if(topicLocalString==null){
                        System.out.println("Topic string is null!");
                        return null;
                    }
                    //                        }catch (DataValidationException e){
                    //                              e.printStackTrace();
                    //                        }
                }else if(filterDialect.compareTo(WsmgConstants.XPATH_DIALECT) == 0){

                    if(topicFromUrl != null) { // use topicFromUrl if was provided
                        topicLocalString = topicFromUrl;
                    }

                    xpathString=WsmgUtil.getXPathString(filterEl);

                    logger.finest("got topicLocalString="+topicLocalString+" xpathString="+xpathString);

                    // TODO: Add XPath canonicalization here in the parsing. To generate a
                    // canonicalized XPath string
                    //Possibly use Query query = XPQuery.parseQuery(xpathExpression, index);
                    if(xpathString==null){
                        System.out.println("XPath string is null!");
                        return null;
                    }
                }else if(filterDialect.compareTo(WsmgConstants.TOPIC_AND_XPATH_DIALECT) == 0){
                    XmlElement topicEl=filterEl.element(WsmgConstants.WSNT_NS, "TopicExpression");
                    if(topicEl!=null){
                        topicLocalString=WsmgUtil.getTopicLocalString(topicEl);
                    }
                    XmlElement xpathEl=filterEl.element(WsmgConstants.WSNT_NS, "MessageContent");
                    if(xpathEl!=null){
                        xpathString=WsmgUtil.getXPathString(xpathEl);
                        if(xpathString==null && topicLocalString==null){
                            System.out.println("Both topic string and XPath String are null!");
                            return null;
                        }
                    }
                }
                    //                      else if (filterDialect.indexOf("topic") >= 0) { //filter contains "topic", but it is other topic dialects
                    //                        throw new SoapClientFault("dialect is not supported.");
                    //                      }
                else {
                    throw new SoapClientFault("Unkown dialect: " + filterDialect);
                    //                        topicLocalString = "wseTopic"; //a special topic, used in WSNT and JMS
                }
                //                String filterDialect = filterEl.attribute("Dialect").getValue();
                //                // Attribute doesn't have default neamespace
                //                // String filterDialect =
                //                // filterEl.attribute(WSE_NS,"Dialect").getValue();
                //                if (filterDialect
                //                        .compareTo(WsmgConstants.TOPIC_EXPRESSION_SIMPLE_DIALECT) == 0) {
                //                    topicExpression = filterEl.requiredTextContent();
                //                    try {
                //                        QName topicExpressionQName = XsulUtil.toQName(filterEl,
                //                                topicExpression);
                //                        topicLocalString = topicExpressionQName.getLocalPart();
                //                    } catch (DataValidationException e) {
                //                        e.printStackTrace();
                //                    }
                //                } else if (filterDialect.indexOf("topic") >= 0) { // filter
                //                                                                    // contains
                //                                                                    // "topic",
                //                                                                    // but it is
                //                                                                    // other
                //                                                                    // topic
                //                                                                    // dialects
                //                    throw new SoapClientFault("dialect is not supported.");
                //                } else {
                //                    topicLocalString = "wseTopic"; // a special topic, used in
                //                                                    // WSNT and JMS
                //                }
            }
            // wrap topicstring to WSNT topic

            //            XmlElement topicExpEl = WsmgConstants.builder.newFragment(
            //                    WsmgConstants.WSNT_NS, "Topic");
            //            topicExpEl.addAttribute("Dialect",
            //                    WsmgConstants.TOPIC_EXPRESSION_SIMPLE_DIALECT);
            //            topicExpEl.declareNamespace(WsmgConstants.WIDGET_NS);
            //            topicExpEl.addChild(WsmgConstants.WIDGET_NS.getPrefix() + ":"
            //                    + topicLocalString);
            //            if (topicLocalString.compareTo("wseTopic") != 0) {
            //                // add topic to the consumer reference properties, so that it
            //                // will be shown in the WSE message header.
            //                cr.getReferenceProperties().addChild(topicExpEl);
            //            }
            //            state = new SubscriptionState(cr, false, wsrmEnabled, topicLocalString,xpathString, producerRef,
            //                    "wse", outGoingQueue);

        } else { // Handle WSNT
            type="wsnt";
            // Get Consumer Reference
            cr = new WsaEndpointReference(subscribeEl.requiredElement(
                                              WsmgConstants.WSNT_NS, "ConsumerReference"));

            // Get UseNotify
            XmlElement useNotifyEl = subscribeEl.element(WsmgConstants.WSNT_NS,
                                                         "UseNotify");
            if (useNotifyEl != null) {
                String s = useNotifyEl.requiredTextContent();
                useNotify = Boolean.valueOf(s).booleanValue();
            }

            //get policy if exist

            XmlElement element = subscribeEl.element(WsmgConstants.WSNT_NS, ElementLiteralConstants.SUBSCRIPTION_POLICY);
            if(element != null){
                wsrmEnabled = true;
            }


            // get Topic
            XmlElement topicExpressionEl = subscribeEl.element(WsmgConstants.WSNT_NS,
                                                               "TopicExpression");
            //     topicExpression = topicExpressionEl.requiredTextContent();
            //            XmlAttribute dialectAtt = topicExpressionEl.attribute("Dialect");
            //            if (dialectAtt == null) {
            //                throw new SoapClientFault("dialect is required for subscribe");
            //            } else {
            //                dialectString = dialectAtt.getValue();
            //            }
            //            if (dialectString
            //                    .equals(WsmgConstants.TOPIC_EXPRESSION_SIMPLE_DIALECT)) {
            //                QName topicExpressionQName = XsulUtil.toQName(topicExpressionEl,
            //                        topicExpression);
            //                topicLocalString = topicExpressionQName.getLocalPart();
            if(topicExpressionEl!=null){
            topicLocalString =WsmgUtil.getTopicLocalString(topicExpressionEl);
            }

            XmlElement xpathEl = subscribeEl.element(WsmgConstants.WSNT_NS,
                                                    "Selector");
            if(xpathEl!=null){
            xpathString=WsmgUtil.getXPathString(xpathEl);
            }
            if(xpathString==null && topicLocalString==null){
                System.out.println("ERROR: Both topic string and XPath String are null!");
                return null;
            }

            //            } else {
            //                throw new SoapClientFault("Unkown dialect: " + dialectString);
            //            }

            // Create SubscriptionState Object
            //            state = new SubscriptionState(cr, useNotify, wsrmEnabled, topicLocalString,xpathString,
            //                    producerRef, "wsnt", outGoingQueue);
        }
        if(topicLocalString==null || topicLocalString.length()==0){
            topicLocalString=WsmgConstants.WILDCARD_TOPIC;
        }
        // Create SubscriptionState Object
        state = new SubscriptionState(cr, useNotify, wsrmEnabled, topicLocalString,xpathString,
                                      producerRef, type, outGoingQueue);
        state.setCreationTime(System.currentTimeMillis());

        if (subscriptionId == null) { // New subscription entry
            key = checkSubscriptionExist(state);
            if (key != null) {
                return key;
            }
            String subIdPrefix=null; //Used to indicate wether a subscription has an XPath subscription Or Topic only.
            if(xpathString.length()==0 ||xpathString==null){
                subIdPrefix="T";
            }else{
                subIdPrefix="X";
            }
            key = subIdPrefix+"sub" + (counter++) + "@" + WsmgConstants.PREFIX;
            String subscribeXml = WsmgConstants.builder.serializeToString(subscribeEl);
            subscriptionDB.insert(key, subscribeXml,wsrmEnabled, topicLocalString,xpathString, cr);
        } else { // Startup from previous subscription database
            key = subscriptionId;
        }
        // showAllSubscription();
        // if (wsmgConfig.isHasCarrier()) { //Use underlying message carrier,
        // narada or openjms
        // try {
        WsmgAdapterConnection wsntAdapterConnection = wsmgConfig
            .getWsntAdapter().handleSubscribe(state, key);
        //        if(wsntAdapterConnection==null){
        //              System.out.println("ERROR:WsntAdapterConnection creation failed.");
        //              return null;
        //        }
        state.setWsntAdapterConnection(wsntAdapterConnection);
        // }
        // catch (Exception e) {
        // e.printStackTrace();
        // }
        // }
        // state=null;
        subscriptions.put(key, state);
        return key;
    }

    /**
     * if find the subscription already exists, return the current
     * subscriptionId else return null;
     */
    public String checkSubscriptionExist(SubscriptionState state) {
        String key = null;
        SubscriptionState value = null;

        String topicLocalString = state.getLocalTopic();
        String consumerAddress = state.getConsumerIPAddressStr();
        String xPath=state.getXpathString();
        String epr = state.getReferenceProperty();
        Set keySet = subscriptions.keySet();
        for (Iterator i = keySet.iterator(); i.hasNext();) {
            key = (String) i.next();
            value = (SubscriptionState) subscriptions.get(key);
            if (consumerAddress.compareTo(value.getConsumerIPAddressStr()) == 0
                    && WsmgUtil.sameStringValue(topicLocalString,value.getLocalTopic())
                    && WsmgUtil.sameStringValue(xPath,value.getXpathString())
                    && WsmgUtil.sameStringValue(epr,value.getReferenceProperty())
               ) {
                logger
                    .finest("###########################Subscription Already exists. Using the current subscriptionId");
                return key;
                //                if (epr != null && value.getReferenceProperty() != null) {
                //                    if (epr.compareTo(value.getReferenceProperty()) == 0) {
                //                        logger
                //                                .finest("###########################Subscription Already exists. Using the current subscriptionId");
                //                        return key;
                //                    }
                //                } else {
                //                    if (value.getReferenceProperty() == null) {
                //                        logger
                //                                .finest("###########################Subscription Already exists. Using the current subscriptionId");
                //                        return key;
                //                    }
                //                }
                //                logger
                //                        .finest("###########################Subscription Already exists. Using the current subscriptionId");
                //                return key;
            }
        }
        return null;
    }

    public void getAllSubscriptions(ProcessingContext ctx) {
        // showAllSubscription();
        String key = null;
        SubscriptionState value = null;
        Set keySet = subscriptions.keySet();
        for (Iterator i = keySet.iterator(); i.hasNext();) {
            key = (String) i.next();
            value = (SubscriptionState) subscriptions.get(key);
            logger.info("******" + key + "-->"
                            + value.getConsumerIPAddressStr() + "##"
                            + value.getLocalTopic());
            XmlElement subscriptionEl = WsmgConstants.builder.newFragment(
                WsmgConstants.WIDGET_NS, "Subscription");
            subscriptionEl
                .addElement(WsmgConstants.WIDGET_NS, "SubscriptionId")
                .addChild(key);
            subscriptionEl.addElement(WsmgConstants.WIDGET_NS,
                                      "ConsumerAddress")
                .addChild(value.getConsumerIPAddressStr());
            // if(value.getReferenceProperty()!=null &&
            // value.getReferenceProperty().length()>0){
            if (value.getReferenceProperty() != null) {
                subscriptionEl.addElement(WsmgConstants.WIDGET_NS,
                                          "ReferenceProperty").addChild(
                    value.getReferenceProperty());
            }
            subscriptionEl.addElement(WsmgConstants.WIDGET_NS, "Topic")
                .addChild(value.getLocalTopic());
            ctx.respMessage.addElement(subscriptionEl);
        }
        logger.finest("ctx.respMessage="
                          + WsmgConstants.builder.serializeToString(ctx.respMessage));
    }

    public void checkSubscriptionDB() {
        XmlElement subscribeXmlElement;
        String subscriptionId;
        boolean useNotify;
        XmlElement topic;
        WsaEndpointReference producerRef;
        SubscriptionState state = null;
//        SubscriptionDB subscriptionDB = new SubscriptionDB();
        // Read subscription Info from Subscription DB
        SubscriptionEntry[] subscriptionEntry = subscriptionDB
            .getAllSubscription();
        if (subscriptionEntry == null) {
            return;
        }
        // Create subscription for these entries from DB
        for (int i = 0; i < subscriptionEntry.length; i++) {
            logger.info("************Subscription No. " + i + " is "
                            + subscriptionEntry[i].getSubscriptionId());
            subscribeXmlElement = WsmgConstants.builder
                .parseFragmentFromReader(new StringReader(
                                             subscriptionEntry[i].getSubscribeXml()));
            subscriptionId = subscriptionEntry[i].getSubscriptionId();
            createSubscription(subscriptionId, subscribeXmlElement, null);
        }
        RunTimeStatistics.totalSubscriptionsAtStartUp=subscriptionEntry.length;
    }

    // This is used for debug
    public void showAllSubscription() {
        String key = null;
        SubscriptionState value = null;
        Set keySet = subscriptions.keySet();
        logger.info("List of all subscriptions:");
        for (Iterator i = keySet.iterator(); i.hasNext();) {
            key = (String) i.next();
            value = (SubscriptionState) subscriptions.get(key);
            logger.info("******" + key + "-->"
                            + value.getConsumerIPAddressStr() + "##"
                            + value.getLocalTopic());
        }
    }

    public int unsubscribe(ProcessingContext ctx) {
        removeSubscription(ctx.subId);
        subscriptions.remove(ctx.subId);
        RunTimeStatistics.totalUnSubscriptions++;
        return 0;
    }

    private int removeSubscription(String subId) {
        SubscriptionState subscription = (SubscriptionState) subscriptions
            .get(subId);
        WsmgAdapterConnection wsntAdapterConnection = subscription
            .getWsntAdapterConnection();
        if (wsntAdapterConnection != null) {
            wsntAdapterConnection.stop();
        }

        subscriptionDB.delete(subId);
        wsmgConfig.getWsntAdapter().handleUnsubscribe(subId);
        return 0;
    }

    public void resumeSubscription(ProcessingContext ctx) {
        if (ctx.subscription == null) {
            throw new SoapClientFault(
                "missing resource id to identify suscription");
        }
        ctx.subscription.resume();
    }

    public void pauseSubscription(ProcessingContext ctx)
        throws DataValidationException, XmlBuilderException {
        if (ctx.subscription == null) {
            throw new SoapClientFault(
                "missing resource id to identify suscription");
        }
        ctx.subscription.pause();
    }

    private boolean isAvailable(URI address) {
        // Create a socket with a timeout
        try {
            // How to parse the address to port
            InetAddress addr = InetAddress.getByName(address.getHost());
            int port = address.getPort();
            SocketAddress sockaddr = new InetSocketAddress(addr, port);

            // Create an unbound socket
            Socket sock = new Socket();

            // This method will block no more than timeoutMs.
            // If the timeout occurs, SocketTimeoutException is thrown.
            int timeoutMs = 1000; // 2 seconds
            sock.connect(sockaddr, timeoutMs);
            sock.close();
            // System.out.println("Still
            // availabe:"+address.getHost()+":"+address.getPort());
        } catch (UnknownHostException e) {
            // e.printStackTrace();
            return false;
        } catch (SocketTimeoutException e) {
            // e.printStackTrace();
            return false;
        } catch (IOException e) {
            // e.printStackTrace();
            return false;
        }

        return true;
    }

    class CleanUpThread implements Runnable {
        //private final static MLogger logger = MLogger.getLogger();
        public void run() {
            //      logger.info("CleanUpThread started");
            String key = null;
            SubscriptionState subscription = null;
            Set keySet = null;
            // long expirationTime=300000*12*24; //5 min*12*24=1 day
            final long expirationTime = WSMGParameter.expirationTime;
            final long skipCheckInterval = 1000*60*10; //10 minutes
            final long checkupInterval = 1000*60*5; //5 minutes
            int MAX_TRY=3;
            System.out.println("Starting Subscription Cleaning up Thread.");
            while (true) {
                long currentTime = System.currentTimeMillis();
                long expiredStartTime = 0;
                if(WSMGParameter.requireSubscriptionRenew){
                    expiredStartTime = currentTime - expirationTime; //expired
                }else{
                    expiredStartTime = currentTime - skipCheckInterval; //It's time to check again
                }
                //   logger.finest("CleanUpThread loop");
                keySet = subscriptions.keySet();
                // Go through all the subscriptions and delete expired ones
                for (Iterator i = keySet.iterator(); i.hasNext();) {
                    key = (String) i.next();
                    subscription = (SubscriptionState) subscriptions.get(key);
                    if (subscription.getCreationTime() < expiredStartTime) {  //expired or need to check again
                        if(WSMGParameter.requireSubscriptionRenew){  //expired
                            removeSubscription(key);
                            i.remove();
                            logger.info("*****Deleted (expiration)" + key + "-->"
                                            + subscription.getConsumerIPAddressStr() + "##"
                                            + subscription.getLocalTopic());
                            System.out.println("*****Deleted (expiration)" + key + "-->"
                                                   + subscription.getConsumerIPAddressStr() + "##"
                                                   + subscription.getLocalTopic());
                            continue;
                        }
                        //It's time to check again
                        if (isAvailable(subscription.getConsumerAddressURI())) {
                            //It's time to check but still available and do not require subscriptio renew
                            if(!WSMGParameter.requireSubscriptionRenew){  //set a mark saying it has been check at this time
                                subscription.setCreationTime(currentTime);
                            }
                            if(subscription.getUnAvailableCounter()>0){  //failed in previous try
                                subscription.resetUnAvailableCounter();
                            }
                        } else {
                            int counter=subscription.addUnAvailableCounter();
                            //       System.out.println("UnavailableCounter="+counter);
                            //        logger.finest("UnavailableCounter="+counter);
                            if(counter>MAX_TRY){
                                removeSubscription(key);

                                // Remove from hashtable seperately to avoid
                                // conccurent access problem to the hashtable with
                                // i.next()
                                i.remove();
                                logger.info("*****Deleted (unavailable)" + key + "-->"
                                                + subscription.getConsumerIPAddressStr() + "##"
                                                + subscription.getLocalTopic());
                                System.out.println("*****Deleted (unavailable)" + key + "-->"
                                                       + subscription.getConsumerIPAddressStr() + "##"
                                                       + subscription.getLocalTopic());
                            }
                        }
                    }
                }
                try {
                    Thread.sleep(checkupInterval);
                } catch (InterruptedException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
            }

        }
    }

}
