/*
 * Created on 2005-9-1
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package wsmg.processors;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.xml.namespace.QName;

import org.xmlpull.v1.builder.XmlBuilderException;
import org.xmlpull.v1.builder.XmlElement;

import wsmg.ProcessingContext;
import wsmg.SoapClientFault;
import wsmg.SoapServerFault;
import wsmg.WsmgConstants;
import wsmg.widgetTest.Client;
import xsul.DataValidationException;
import xsul.util.XsulUtil;

/**
 * @author yihuan
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class WSRP_Processor {
	public void queryResourceProperties(ProcessingContext ctx)
			throws SoapClientFault, XmlBuilderException {
		XmlElement queryExpressionEl = ctx.soapBody.requiredElement(
				WsmgConstants.WSRP_NS, "QueryExpression");
		String dialect = queryExpressionEl.getAttributeValue(null, "Dialect");
		if (!WsmgConstants.XPATH_DIALECT.equals(dialect)) {
			throw new SoapClientFault("UnknownQueryExpressionDialect "
					+ dialect);
		}
		String query = queryExpressionEl.requiredTextContent().trim();
		// TODO plugin real XPATH engine
		ctx.respMessage.declareNamespace(WsmgConstants.WIDGET_NS); // needed
																	// for IBM
																	// WSI WSRF
																	// client
		if (Client.WELL_KNOWN_QUERY.equals(query)) {
			ctx.respMessage.addChild("true");
		} else if ("/*".equals(query)) {
			try {
				XmlElement resultEl = ctx.respMessage
						.addElement((XmlElement) ctx.resourceState.getTarget()
								.clone());
				resultEl.declareNamespace(WsmgConstants.WIDGET_NS); // needed
																	// for IBM
																	// WSI WSRF
																	// client
				resultEl.declareNamespace(WsmgConstants.WSRL_NS); // needed
																	// for IBM
																	// WSI WSRF
																	// client
				resultEl.declareNamespace(WsmgConstants.WSRP_NS); // needed
																	// for IBM
																	// WSI WSRF
																	// client
				// do fixing for all children ...
				for (Iterator i = resultEl.children(); i.hasNext();) {
					Object child = i.next();
					if (child instanceof XmlElement) {
						XmlElement childEl = (XmlElement) child;
						childEl.declareNamespace(WsmgConstants.WIDGET_NS); // needed
																			// for
																			// IBM
																			// WSI
																			// WSRF
																			// client
						childEl.declareNamespace(WsmgConstants.WSRL_NS); // needed
																			// for
																			// IBM
																			// WSI
																			// WSRF
																			// client
					}
				}
			} catch (CloneNotSupportedException cns) {
				throw new SoapServerFault(
						"internal errror when processing XPATH expression '"
								+ query + "'", cns);
			}
		} else if ("/*/*".equals(query)) {
			for (Iterator i = ctx.resourceState.children(); i.hasNext();) {
				Object child = i.next();
				if (child instanceof XmlElement) {
					XmlElement e = (XmlElement) child;
					try {
						// ctx.respMessage.addChild(e.clone());
						XmlElement resultEl = ctx.respMessage
								.addElement((XmlElement) e.clone());
						resultEl.declareNamespace(WsmgConstants.WIDGET_NS); // needed
																			// for
																			// IBM
																			// WSI
																			// WSRF
																			// client
						resultEl.declareNamespace(WsmgConstants.WSRL_NS); // needed
																			// for
																			// IBM
																			// WSI
																			// WSRF
																			// client
					} catch (CloneNotSupportedException cns) {
						throw new SoapServerFault(
								"internal errror when processing XPATH expression '"
										+ query + "'", cns);
					}
				}
			}
		} else {
			throw new SoapClientFault("unsupported XPATH expression '" + query
					+ "'");
		}
	}

	public void setResourceProperties(ProcessingContext ctx)
			throws DataValidationException, SoapClientFault {
		for (Iterator requests = ctx.soapBody.requiredElementContent()
				.iterator(); requests.hasNext();) {
			XmlElement req = (XmlElement) requests.next();
			if (WsmgConstants.WSRP_NS.equals(req.getNamespace())) {
				String changeType = req.getName();
				if (WsmgConstants.DELETE.equals(changeType)) {
					String property = req.getAttributeValue(null,
							WsmgConstants.RESOURCE_PROPERTY_ATTNAME);
					QName propertyQName = XsulUtil.toQName(req, property);
					ctx.resourceState.deleteElements(propertyQName);
				} else if (WsmgConstants.INSERT.equals(changeType)
						|| WsmgConstants.UPDATE.equals(changeType)) {
					// retrieve list of children to be inserted or updated
					// verify all children has the same Qname and put them in
					// List...
					List elements = new ArrayList();
					QName elementsQName = null;
					for (Iterator it = req.requiredElementContent().iterator(); it
							.hasNext();) {
						XmlElement child = (XmlElement) it.next();
						QName childQName = new QName(child.getNamespace()
								.getNamespaceName(), child.getName());
						if (elementsQName == null) {
							elementsQName = childQName;
						} else {
							if (!elementsQName.equals(childQName)) {
								throw new SoapClientFault(
										"all children qnames must be the same not "
												+ XsulUtil.safeXmlToString(req));
							}
						}
						elements.add(child);
						// detach children from message
						child.setParent(null);
					}
					if (WsmgConstants.UPDATE.equals(changeType)) {
						ctx.resourceState.deleteElements(elementsQName);
					}
					ctx.resourceState.insertChildren(elements);
				}
			} else {
				throw new SoapClientFault("unknwon SRP request namespace ");
			}
		}
	}

	public void getMultipleResourceProperties(ProcessingContext ctx)
			throws DataValidationException {
		for (Iterator it = ctx.soapBody.requiredElementContent().iterator(); it
				.hasNext();) {
			XmlElement child = (XmlElement) it.next();
			String property = child.requiredTextContent();
			QName propertyQName = XsulUtil.toQName(child, property);
			List elements = ctx.resourceState.getProperties(propertyQName);
			for (int i = 0; i < elements.size(); i++) {
				XmlElement el = (XmlElement) elements.get(i);
				ctx.respMessage.addElement(el);
			}
		}
	}

	public void getResourceProperty(ProcessingContext ctx)
			throws DataValidationException, XmlBuilderException {
		String property = ctx.soapBody.requiredTextContent();
		QName propertyQName = XsulUtil.toQName(ctx.soapBody, property);
		List elements = ctx.resourceState.getProperties(propertyQName);
		for (int i = 0; i < elements.size(); i++) {
			XmlElement el = (XmlElement) elements.get(i);
			ctx.respMessage.addElement(el);
		}
	}
}
