/*
 * Created on 2005-9-15
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package wsmg.stub;

import java.net.URI;

import org.xmlpull.v1.builder.XmlElement;
import org.xmlpull.v1.builder.XmlInfosetBuilder;
import org.xmlpull.v1.builder.XmlNamespace;

import wsmg.ElementLiteralConstants;
import wsmg.WsmgConstants;
import xsul.MLogger;
import xsul.XmlConstants;
import xsul.XsulException;
import xsul.util.XsulUtil;
import xsul.ws_addressing.WsaEndpointReference;

/**
 * @author yihuan
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
/**
 * This stub is NOT multi-thread safe!
 */
public class NotificationProducerStub extends WidgetStub {
    private static final String RMASSERTION = "RMAssertion";

    private static final String WSRM_NAMWSPACE = "http://schemas.xmlsoap.org/ws/2005/02/rm";

    private static final String WSRM = "wsrm";

    private final static MLogger logger = MLogger.getLogger();

    private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;
    
    

    public NotificationProducerStub(WsaEndpointReference widgetEpr) {
        super(widgetEpr);
    }

    public XmlElement getCurrentMessage(XmlElement topicExp) {
        invoker.setMessageId(null);
        XmlElement message = builder.newFragment(WsmgConstants.WSNT_NS,
                "GetCurrentMessage");
        message.addChild(topicExp);
        invoker.setDefaultAction(URI.create(message.getNamespace()
                .getNamespaceName()
                + "/" + message.getName()));
        XmlElement responseMessage = invoker.invokeMessage(message);
        verbose("\n\nRESPONSE="
                + XsulUtil.safeXmlToString(responseMessage.getRoot()) + "\n\n\n");
        if (responseMessage.hasChildren() == false) { // INTEROP can it be
            // empoty?
            return null;
        } else {
            return (XmlElement) responseMessage.requiredElementContent()
                    .iterator().next();
        }
    }
  
    public SubscriptionStub subscribe(WsaEndpointReference consumerReference,
            XmlElement topicExpression, boolean useNotfy) {
        return this.subscribe(consumerReference, topicExpression, null, useNotfy, false);
        
    }
    
    public SubscriptionStub subscribe(WsaEndpointReference consumerReference,
            XmlElement topicExpression, XmlElement xpathExpression, boolean useNotfy) {
        return this.subscribe(consumerReference, topicExpression, xpathExpression, useNotfy, false);
        
    }

    public SubscriptionStub subscribe(WsaEndpointReference consumerReference,
            XmlElement topicExpression, boolean useNotfy, boolean wsrm){
    	return subscribe(consumerReference, topicExpression, null,  useNotfy,  wsrm);
    }
    
    public SubscriptionStub subscribe(WsaEndpointReference consumerReference,
            XmlElement topicExpression,XmlElement xpathExpression, boolean useNotfy, boolean wsrm) {
        
        invoker.setMessageId(null);
        XmlElement message = builder.newFragment(WsmgConstants.WSNT_NS,
                "Subscribe");

        WsaEndpointReference cr;
        try {
            cr = (WsaEndpointReference) consumerReference.clone();
        } catch (CloneNotSupportedException e) {
            throw new XsulException("internal error: could not clone EPR");
        }
        cr.setNamespace(WsmgConstants.WSNT_NS);
        cr.setName("ConsumerReference");
        message.addElement(cr);
        // <wsnt:TopicExpression
        // dialect="http://www.ibm.com/xmlns/stdwip/web-services/WS-Topics/TopicExpressiom/simple">widget:TestTopic</wsnt:TopicExpression>
        if(topicExpression!=null){
        message.addElement(topicExpression);
        }
        if(xpathExpression!=null){
        message.addElement(xpathExpression);
        }
        message.addElement(WsmgConstants.WSNT_NS, "UseNotify").addChild(
                useNotfy ? "true" : "false");
        if(wsrm){
            message.addElement(this.getPolicyAttachment());
        }
        invoker.setDefaultAction(URI.create(message.getNamespace()
                .getNamespaceName()
                + "/" + message.getName()));
        XmlElement responseMessage = invoker.invokeMessage(message);
        verbose("\n\nRESPONSE=" + XsulUtil.safeXmlToString(responseMessage)
                + "\n\n\n");
        XmlElement sr = responseMessage.requiredElement(WsmgConstants.WSNT_NS,
                "SubscriptionReference");
        return new SubscriptionStub(new WsaEndpointReference(sr));
    }

    public static void verbose(String msg) {
        if (true) {
            System.err.println(msg);
        }
    }
    
    protected XmlElement getPolicyAttachment(){
        
        XmlElement policy = builder.newFragment(WsmgConstants.WSNT_NS, ElementLiteralConstants.SUBSCRIPTION_POLICY);
        XmlNamespace wsrmNamespace = builder.newNamespace(WSRM, WSRM_NAMWSPACE);
        policy.addChild(builder.newFragment(wsrmNamespace, RMASSERTION));
        
        return policy;
        
    }

}
