package wsmg.stub;

import java.net.URI;

import org.xmlpull.v1.builder.XmlElement;
import org.xmlpull.v1.builder.XmlInfosetBuilder;

import wsmg.WsmgConstants;
import xsul.MLogger;
import xsul.XmlConstants;
import xsul.XsulException;
import xsul.soap11_util.Soap11Util;
import xsul.util.XsulUtil;
import xsul.ws_addressing.WsaEndpointReference;
import xsul.ws_addressing.WsaInvoker;

/**
 *
 * @author yi Huang
 * @version 1.0
 */

public class WseEventSourceStub {
        private final static MLogger logger = MLogger.getLogger();

        private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;

        //private WsaEndpointReference resourceEpr;

        protected WsaInvoker invoker;

        //public WseEventSourceStub() {
        //}

        public WseEventSourceStub(WsaEndpointReference resourceEpr) {
                //this.resourceEpr = resourceEpr;
                invoker = new WsaInvoker();
                invoker.setTargetEPR(resourceEpr);
                invoker.setSoapFragrance(Soap11Util.getInstance());
                invoker.setIndent("  ");
                // to improve interop do not use KA
                invoker.setUseHttpKeepAlive(false);
        }

        public XmlElement subscribe(WsaEndpointReference eventSinkReference,
                        XmlElement filterEl, boolean useNotfy) {
                XmlElement subscriptionManager = null;
                invoker.setMessageId(null);
                XmlElement message = builder.newFragment(WsmgConstants.WSE_NS,
                                "Subscribe");
                XmlElement delivery = builder.newFragment(WsmgConstants.WSE_NS,
                                "Delivery");

                WsaEndpointReference notifyTo;
                try {
                        notifyTo = (WsaEndpointReference) eventSinkReference.clone();
                } catch (CloneNotSupportedException e) {
                        throw new XsulException("internal error: could not clone EPR");
                }
                notifyTo.setNamespace(WsmgConstants.WSE_NS);
                notifyTo.setName("NotifyTo");
                delivery.addElement(notifyTo);
                message.addElement(delivery);
                // <wsnt:TopicExpression
                // dialect="http://www.ibm.com/xmlns/stdwip/web-services/WS-Topics/TopicExpressiom/simple">widget:TestTopic</wsnt:TopicExpression>
                if (filterEl != null) {
                        message.addElement(filterEl);
                }
                // message.addElement(WidgetService.WSNT_NS, "UseNotify").addChild(
                // useNotfy ? "true" : "false");
                invoker.setDefaultAction(URI.create(message.getNamespace()
                                .getNamespaceName()
                                + "/" + message.getName()));
                logger.finest(XsulUtil.safeXmlToString(message));
                XmlElement responseMessage = invoker.invokeMessage(message);
                if(logger.isFinestEnabled()) {
                    logger.finest("\n\nRESPONSE=" + XsulUtil.safeXmlToString(responseMessage)+ "\n\n\n");
                }
                if(responseMessage==null){
                	throw new XsulException("Response message is null");
                }
                subscriptionManager = responseMessage.requiredElement(
                                WsmgConstants.WSE_NS, "SubscriptionManager");
                // return new SubscriptionStub(new
                // WsaEndpointReference(subscriptionManager));
                return subscriptionManager;
        }

}


