/*
 * Created on 2005-9-15
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package wsmg.stub;

import java.net.URI;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;
import java.util.List;

import javax.xml.namespace.QName;

import org.xmlpull.v1.builder.XmlElement;
import org.xmlpull.v1.builder.XmlInfosetBuilder;
import org.xmlpull.v1.builder.XmlNamespace;

import wsmg.WsmgConstants;
import wsmg.util.DcDate;
import xsul.MLogger;
import xsul.XmlConstants;
import xsul.soap11_util.Soap11Util;
import xsul.util.QNameElText;
import xsul.util.XsulUtil;
import xsul.ws_addressing.WsaEndpointReference;
import xsul.ws_addressing.WsaInvoker;

/**
 * @author yihuan
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class WsrfResourceStub {
	private final static MLogger logger = MLogger.getLogger();

	private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;

	protected WsaInvoker invoker; // = new WsaInvoker();

	private WsaEndpointReference resourceEpr;

	protected WsrfResourceStub(WsaEndpointReference resourceEpr) {
		this.resourceEpr = resourceEpr;
		logger.finest("resourceEprInWsrfResourceStub Constructor"
				+ builder.serializeToString(resourceEpr));
		invoker = new WsaInvoker();
		invoker.setTargetEPR(resourceEpr);
		invoker.setSoapFragrance(Soap11Util.getInstance());
		invoker.setIndent("  ");
		// to improve interop do not use KA
		invoker.setUseHttpKeepAlive(false);

	}

	public WsaEndpointReference getResourceEpr() {
		return resourceEpr;
	}

	public void destroy() {
		invoker.setMessageId(null);
		XmlElement message = builder.newFragment(WsmgConstants.WSRL_NS,
				"Destroy");
		invoker.setDefaultAction(URI.create(message.getNamespace()
				.getNamespaceName()
				+ "/" + message.getName()));
		XmlElement responseMessage = invoker.invokeMessage(message);
		verbose("\n\nRESPONSE="
				+ XsulUtil.safeXmlToString(responseMessage.getRoot()) + "\n\n\n");
	}

	public void setTerminationTime(Calendar cal) {
		invoker.setMessageId(null);
		XmlElement message = builder.newFragment(WsmgConstants.WSRL_NS,
				"SetTerminationTime");
		invoker.setDefaultAction(URI.create(message.getNamespace()
				.getNamespaceName()
				+ "/" + message.getName()));

		XmlElement child = message.addElement(WsmgConstants.WSRL_NS,
				"RequestedTerminationTime");
		if (cal == null) {
			child.addAttribute(XmlConstants.XSI_NS, "nil", "true");
		} else {
			child.addChild(new DcDate(cal));
		}
		XmlElement responseMessage = invoker.invokeMessage(message);
		verbose("\n\nRESPONSE="
				+ XsulUtil.safeXmlToString(responseMessage.getRoot()) + "\n\n\n");
	}

	public List getResourceProperty(QName qn) { // List<XmlElement>
		XmlNamespace ns = builder.newNamespace(qn.getPrefix(), qn
				.getNamespaceURI());
		String name = qn.getLocalPart();
		invoker.setMessageId(null);

		XmlElement message = builder.newFragment(WsmgConstants.WSRP_NS,
				"GetResourceProperty");
		invoker.setDefaultAction(URI.create(message.getNamespaceName() + "/"
				+ message.getName()));

		// message.addChild(new QNameElText(message, WidgetService.WIDGET_NS,
		// "TerminationTime"));
		// message.declareNamespace(WidgetService.WIDGET_NS);
		message.addChild(new QNameElText(message, ns, name));
		// message.declareNamespace(WidgetService.WSRL_NS);
		if (ns.getPrefix() != null) {
			message.declareNamespace(ns);
		}
		// child.addChild(new DcDate(TimeZone.getDefault()));
		XmlElement responseMessage = invoker.invokeMessage(message);

		verbose("\n\nRESPONSE="
				+ XsulUtil.safeXmlToString(responseMessage.getRoot()) + "\n\n\n");
		List list = elementsAsList(responseMessage);
		return list;
	}

	public List getMultipleResourceProperties(QName[] qnamez) { // TODO JDK15
																// List<XmlElement>
		invoker.setMessageId(null);
		XmlElement message = builder.newFragment(WsmgConstants.WSRP_NS,
				"GetMultipleResourceProperties");
		invoker.setDefaultAction(URI.create(message.getNamespace()
				.getNamespaceName()
				+ "/" + message.getName()));

		// message.addChild(new QNameElText(message, WidgetService.WIDGET_NS,
		// "TerminationTime"));
		// message.declareNamespace(WidgetService.WIDGET_NS);
		// wsrp:ResourceProperty

		for (int i = 0; i < qnamez.length; i++) {
			QName qn = qnamez[i];
			XmlNamespace ns = builder.newNamespace(qn.getPrefix(), qn
					.getNamespaceURI());
			XmlElement child = message.addElement(WsmgConstants.WSRP_NS,
					"ResourceProperty");
			child.addChild(new QNameElText(message, ns, qn.getLocalPart()));
			if (qn.getPrefix() != null) {
				child.declareNamespace(ns);
			}
		}

		XmlElement responseMessage = invoker.invokeMessage(message);

		verbose("\n\nRESPONSE="
				+ XsulUtil.safeXmlToString(responseMessage.getRoot()) + "\n\n\n");

		List list = elementsAsList(responseMessage);
		return list;
	}

	public List queryResourcePropertiesByXpath(String query) {
		if (query == null) {
			throw new IllegalArgumentException();
		}
		invoker.setMessageId(null);
		XmlElement message = builder.newFragment(WsmgConstants.WSRP_NS,
				"QueryResourceProperties");
		invoker.setDefaultAction(URI.create(message.getNamespaceName() + "/"
				+ message.getName()));

		XmlElement queryExpressionEl = message.addElement(
				WsmgConstants.WSRP_NS, "QueryExpression");
		queryExpressionEl.addAttribute("dialect", WsmgConstants.XPATH_DIALECT);
		queryExpressionEl.addChild(query);

		XmlElement responseMessage = invoker.invokeMessage(message);

		verbose("\n\nRESPONSE="
				+ XsulUtil.safeXmlToString(responseMessage.getRoot()) + "\n\n\n");

		List list = childrenAsList(responseMessage);
		return list;
	}

	public void setResourceProperties(XmlElement[] requests) {
		if (requests.length == 0) {
			throw new IllegalArgumentException(
					"at least one request is required");
		}

		invoker.setMessageId(null);
		XmlElement message = builder.newFragment(WsmgConstants.WSRP_NS,
				"SetResourceProperties");
		invoker.setDefaultAction(URI.create(message.getNamespace()
				.getNamespaceName()
				+ "/" + message.getName()));
		for (int i = 0; i < requests.length; i++) {
			message.addElement(requests[i]);
		}
		// message.addChild(new QNameElText(message, WidgetService.WIDGET_NS,
		// "TerminationTime"));
		// message.declareNamespace(WidgetService.WIDGET_NS);
		// wsrp:ResourceProperty
		// message.declareNamespace(WidgetService.WSRL_NS);

		XmlElement responseMessage = invoker.invokeMessage(message);

		verbose("\n\nRESPONSE="
				+ XsulUtil.safeXmlToString(responseMessage.getRoot()) + "\n\n\n");
	}

	private List elementsAsList(XmlElement responseMessage) {
		List list = new ArrayList();
		for (Iterator it = responseMessage.requiredElementContent().iterator(); it
				.hasNext();) {
			XmlElement el = (XmlElement) it.next();
			list.add(el);
		}
		return list;
	}

	private List childrenAsList(XmlElement responseMessage) {
		List list = new ArrayList();
		for (Iterator it = responseMessage.children(); it.hasNext();) {
			Object child = it.next();
			list.add(child);
		}
		return list;
	}

	public static void verbose(String msg) {
		if (true) {
			System.err.println(msg);
		}
	}
}
