package wsmg.util;

import java.text.DateFormat;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;

import org.xmlpull.v1.builder.XmlInfosetBuilder;

import xsul.MLogger;
import xsul.XmlConstants;
import xsul.soap.SoapUtil;
import xsul.soap11_util.Soap11Util;
import xsul.soap12_util.Soap12Util;

/**
 * <p>
 * Title: Ws-Notification
 * </p>
 * 
 * <p>
 * Description:
 * </p>
 * 
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * 
 * <p>
 * Company: Indiana University
 * </p>
 * 
 * @author yi Huang
 * @version 1.0
 */
public class WseUtil {
	private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;

	private static SoapUtil[] soapFragrances = new SoapUtil[] {
			Soap12Util.getInstance(), Soap11Util.getInstance() };

	private final static MLogger logger = MLogger.getLogger();

	public WseUtil() {
	}

	// Format date to string like "2004-06-26T21:07:00.000-08:00"
	public static String getXsdDateTime(Date time) {
		Date now = time;
		DateFormat ISO8601Local = new SimpleDateFormat(
				"yyyy-MM-dd'T'HH:mm:ss.SSS");
		TimeZone timeZone = TimeZone.getDefault();
		ISO8601Local.setTimeZone(timeZone);
		int offset = timeZone.getOffset(now.getTime());
		String sign = "+";
		if (offset < 0) {
			offset = -offset;
			sign = "-";
		}
		int hours = offset / 3600000;
		int minutes = (offset - hours * 3600000) / 60000;
		if (offset != hours * 3600000 + minutes * 60000) {
			// E.g. TZ=Asia/Riyadh87
			throw new RuntimeException("TimeZone offset (" + sign + offset
					+ " ms) is not an exact number of minutes");
		}
		DecimalFormat twoDigits = new DecimalFormat("00");
		String ISO8601Now = ISO8601Local.format(now) + sign
				+ twoDigits.format(hours) + ":" + twoDigits.format(minutes);
		return ISO8601Now;
	}

}
