package wsmg.widgetTest;

import java.util.TimeZone;

import org.xmlpull.v1.builder.XmlCharacters;
import org.xmlpull.v1.builder.XmlContainer;
import org.xmlpull.v1.builder.XmlElement;

import wsmg.util.DcDate;

/**
 * <p>
 * Title: Ws-Notification
 * </p>
 *
 * <p>
 * Description:
 * </p>
 *
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 *
 * <p>
 * Company: Indiana University
 * </p>
 *
 * @author yi Huang
 * @version 1.0
 */
public class CurrentDate implements XmlCharacters, Cloneable {
    private XmlElement parent;

    public CurrentDate(XmlElement parent) {
        this.parent = parent;
    }

    public Object clone() throws CloneNotSupportedException {
        // NOTE: parent will call setPrent() to correct value if CurrentDate is
        // contained in XmlContainer
        // otherwise it is easy as object has no state
        CurrentDate dd = (CurrentDate) super.clone();
        return dd;
    }

    public String getText() {
        // active entity: value computed on demand
        // TODO use static method that would format System.currentTimeMillis +
        // TZ
        DcDate now = new DcDate(TimeZone.getDefault());
        return now.toString();
    }

    public Boolean isWhitespaceContent() {
        return null;
    }

    public XmlContainer getParent() {
        return parent;
    }

    public void setParent(XmlContainer currentDateParent) {
        if(currentDateParent instanceof XmlElement) {
            this.parent = (XmlElement) currentDateParent;
        } else {
            throw new RuntimeException("parent must be XmlElement not "+currentDateParent);
        }

    }
}
