package wsmg.wsntviewapp;

import java.io.StringReader;
import java.io.StringWriter;
import java.util.Iterator;

import org.apache.xmlbeans.XmlException;
import org.xmlpull.v1.XmlSerializer;
import org.xmlpull.v1.builder.XmlElement;
import org.xmlpull.v1.builder.XmlInfosetBuilder;
import org.xmlpull.v1.builder.XmlNamespace;

import wsmg.NotificationHandler;
import wsmg.WsmgConstants;
import xsul.MLogger;
import xsul.XmlConstants;
import xsul.XsulException;
import xsul.soap.SoapUtil;
import xsul.soap11_util.Soap11Util;
import xsul.soap12_util.Soap12Util;
import edu.indiana.extreme.lead.types.WorkflowNotificationDocument;

public class WsntViewerNotificationHandler implements NotificationHandler {
	private final static MLogger logger = MLogger.getLogger();

	private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;

	public final static XmlNamespace LEAD_NS = builder.newNamespace("lead",
			"http://lead.extreme.indiana.edu/namespaces/2004/10/lead");

	public NotificationViewerFrame frame = null;

	private SoapUtil[] soapFragrances = new SoapUtil[] {
			Soap12Util.getInstance(), Soap11Util.getInstance() };

	public WsntViewerNotificationHandler() {
	}

	public WsntViewerNotificationHandler(NotificationViewerFrame frame) {
		this.frame = frame;
	}

	public synchronized void handleNotification(String message) {
		String messageContent = null;
		logger.finest("*******lead message handler Received message********");
		logger.finest(message);
		frame.addWholeMessage(message);
		// parse the received String message and create XmlElement object
		XmlElement messageEl = builder
				.parseFragmentFromReader(new StringReader(message));
		SoapUtil soapFragrance = null;
		for (int i = 0; i < soapFragrances.length; i++) {
			if (soapFragrances[i].isSoapEnvelopeSupported(messageEl)) {
				soapFragrance = soapFragrances[i];
				break;
			}
		}
		if (soapFragrance == null) {
			throw new RuntimeException("only SOAP 1.1 or 1.2 is supported");
		}
		XmlElement bodyContent = soapFragrance.requiredBodyContent(messageEl);
		XmlElement messageContentEl = bodyContent.requiredElement(
				WsmgConstants.WSNT_NS, "NotificationMessage").requiredElement(
				WsmgConstants.WSNT_NS, "Message");
		StringWriter sw = null;
		try {
			XmlSerializer xs = builder.getFactory().newSerializer();
			sw = new StringWriter();
			xs.setOutput(sw);
			for (Iterator i = messageContentEl.children(); i.hasNext();) {
				builder.serialize(i.next(), xs);
			}
			xs.flush();
		} catch (Exception ex2) {
			throw new XsulException("could not convert message content to XML",
					ex2);
		}
		String messageContentAsXml = sw.toString();
	

	}

}
