package wsmg.wsrm.axis2;

import javax.xml.namespace.QName;

import org.apache.axis2.AxisFault;
import org.apache.axis2.context.ConfigurationContext;
import org.apache.axis2.description.AxisOperation;
import org.apache.axis2.description.AxisService;
import org.apache.axis2.description.InOutAxisOperation;
import org.apache.axis2.transport.http.SimpleHTTPServer;

import wsmg.WSMGService;
import wsmg.WsmgConstants;
import wsmg.WsmgRuntimeException;
import wsmg.axis2.BrockerMessageReceiver;

/**
 * @author Chathura Herath (cherath@cs.indiana.edu)
 */

public class DedicatedSimpleAxis2Server {

	private WSMGService broker;

	public DedicatedSimpleAxis2Server(WSMGService broker) {
		this.broker = broker;
	}

	public void start() {

		SimpleHTTPServer server = null;
        ConfigurationContext systemContext = new ConfigurationContext(null);
		try {
			server = new SimpleHTTPServer(systemContext, 2222);
		} catch (AxisFault e) {
			throw new WsmgRuntimeException("Axis2 trasport failed to start", e);
		}
        
		//ConfigurationContext systemContext = server.getSystemContext();

		systemContext.setProperty(WsmgConstants.BROKER_KEY_FOR_AXIS2,
				broker);

		AxisService service = new AxisService();
		service.setName("brocker");

		service.setClassLoader(Thread.currentThread().getContextClassLoader());

		AxisOperation axisOp = new InOutAxisOperation(new QName("publish"));

		axisOp.setMessageReceiver(new BrockerMessageReceiver());
		service.addOperation(axisOp);
        axisOp.setSoapAction("http://www.extreme.indiana.edu/WseNotification");

		AxisOperation op2 = new InOutAxisOperation(new QName("subscribe"));
		op2.setMessageReceiver(new BrockerMessageReceiver());
        op2.setSoapAction("http://schemas.xmlsoap.org/ws/2004/08/eventing/Subscribe");
		service.addOperation(op2);

		try {
			systemContext.getAxisConfiguration().addService(service);
			server.start();
		} catch (AxisFault e) {
			throw new WsmgRuntimeException("Axis2 trasport failed to start", e);
		}
		System.out.println("Axis2 based Brocker running");
	}

}

/*
 * Indiana University Extreme! Lab Software License, Version 1.2
 * 
 * Copyright (C) 2004 The Trustees of Indiana University. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 * 
 * 2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 * 
 * 3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 * 
 * "This product includes software developed by the Indiana University Extreme!
 * Lab. For further information please visit http://www.extreme.indiana.edu/"
 * 
 * Alternatively, this acknowledgment may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 * 
 * 4) The name "Indiana University" or "Indiana University Extreme! Lab" shall
 * not be used to endorse or promote products derived from this software without
 * prior written permission from Indiana University. For written permission,
 * please contact http://www.extreme.indiana.edu/.
 * 
 * 5) Products derived from this software may not use "Indiana University" name
 * nor may "Indiana University" appear in their name, without prior written
 * permission of the Indiana University.
 * 
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of any
 * other entity. Indiana University disclaims any liability to any recipient for
 * claims brought by any other entity based on infringement of intellectual
 * property rights or otherwise.
 * 
 * LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 * NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 * INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 * "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 * LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 * GENERATED USING SOFTWARE.
 */

