package wsmg.wsrm.axis2;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;

import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.OMException;
import org.apache.axiom.soap.SOAPBody;
import org.apache.axis2.AxisFault;
import org.apache.axis2.context.MessageContext;
import org.apache.axis2.receivers.AbstractMessageReceiver;

import wsmg.NotificationHandler;
import wsmg.WsmgConstants;
import wsmg.XMLConstants;

/**
 * @author Chathura Herath (cherath@cs.indiana.edu)
 */

public class WSRMBrockerCallbackMessageReceiver extends AbstractMessageReceiver
        implements XMLConstants {

    // static {
    // SOAP11Factory fac = new SOAP11Factory();
    // OMNamespace wsntNamespace = fac.createOMNamespace(
    // ReliableWSNTClientAPI.WEB_SERVICES_WS_BASE_NOTIFICATION,
    // ReliableWSNTClientAPI.XMLNS_WSNT);
    // }

    public void receive(MessageContext messageCtx) throws AxisFault {
        NotificationHandler handler = (NotificationHandler) messageCtx
                .getConfigurationContext().getProperty(
                        WsmgConstants.INVOCATION_HANDLER_KEY_FOR_SANDESHA2);

        try {
            
            SOAPBody body = messageCtx.getEnvelope().getBody();
            OMElement notifyElement = body.getFirstChildWithName(new QName(
                    WEB_SERVICES_WS_BASE_NOTIFICATION, "Notify"));
            if (notifyElement != null) {
                OMElement notificationMessage = notifyElement
                        .getFirstChildWithName(new QName(
                                WEB_SERVICES_WS_BASE_NOTIFICATION,
                                "NotificationMessage"));
                if (notificationMessage != null) {
                    OMElement message = notificationMessage
                            .getFirstChildWithName(new QName(
                                    WEB_SERVICES_WS_BASE_NOTIFICATION,
                                    "Message"));
                    if (message != null) {
                        handler.handleNotification(message.getFirstElement()
                                .toString());
                    }
                }
            }
        } catch (OMException e) {
            // FIXME @author Chathura What are you suppose to do when this fails
            e.printStackTrace();
        }

    }

}

/*
 * Indiana University Extreme! Lab Software License, Version 1.2
 * 
 * Copyright (C) 2004 The Trustees of Indiana University. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 * 
 * 2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 * 
 * 3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 * 
 * "This product includes software developed by the Indiana University Extreme!
 * Lab. For further information please visit http://www.extreme.indiana.edu/"
 * 
 * Alternatively, this acknowledgment may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 * 
 * 4) The name "Indiana University" or "Indiana University Extreme! Lab" shall
 * not be used to endorse or promote products derived from this software without
 * prior written permission from Indiana University. For written permission,
 * please contact http://www.extreme.indiana.edu/.
 * 
 * 5) Products derived from this software may not use "Indiana University" name
 * nor may "Indiana University" appear in their name, without prior written
 * permission of the Indiana University.
 * 
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of any
 * other entity. Indiana University disclaims any liability to any recipient for
 * claims brought by any other entity based on infringement of intellectual
 * property rights or otherwise.
 * 
 * LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 * NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 * INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 * "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 * LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 * GENERATED USING SOFTWARE.
 */

