package org.indiana.extreme.queue;

import junit.framework.TestCase;

import edu.indiana.extreme.q.Queue;
import edu.indiana.extreme.q.QueueFactory;

import wsmg.processors.ConsumerInfo;
import wsmg.processors.OutGoingMessage;
import wsmg.processors.AdditionalMessageContent;


/**
 * @author Chathura Herath (cherath@cs.indiana.edu)
 */

public class QueueStressTest extends TestCase{
	
	private static int REPETITIONS = 10000;
	private static String TEST_STRING = "Testing the rate the queue can enqueue";
	private static OutGoingMessage message;

	public void setUp(){
		OutGoingMessage outGoingMessage = new OutGoingMessage();
		String testString = "This is a test string that would be inserted to the database"; 
		outGoingMessage.setTextMessage("testString");
		outGoingMessage.setAdditionalMessageContent(new AdditionalMessageContent(testString,testString));
		outGoingMessage.addConsumerInfo(new ConsumerInfo(testString, testString, true,true));
		outGoingMessage.addConsumerInfo(new ConsumerInfo(testString, testString, true,true));
		this.message = outGoingMessage;
	}
	
//	public void testQueueLimit() throws Exception{
//		
//		OutGoingMessage outGoingMessage = new OutGoingMessage();
//		String testString = "This is a test string that would be inserted to the database"; 
//		outGoingMessage.setTextMessage("testString");
//		outGoingMessage.setSoapHeader(new UnChangedHeaderContent(testString,testString));
//		outGoingMessage.addConsumerInfo(new ConsumerInfo(testString, testString, true,true));
//		outGoingMessage.addConsumerInfo(new ConsumerInfo(testString, testString, true,true));
//		
//		Queue queue = QueueFactory.createQueue();
//		long start = System.currentTimeMillis();
//		for(int i=0; i< REPETITIONS; i++){
//			queue.enqueue(outGoingMessage);
////			queue.dequeue();
//		}
//		long end = System.currentTimeMillis();
//		System.out.println("Rate is :"+1000*(long)REPETITIONS/(end-start));
	
//	}
	
	
	public void testDistrebutedQueue() throws Exception{
		Queue dq = QueueFactory.createDistrebutedQueue();
		long start = System.currentTimeMillis();
		for(int i=0; i< REPETITIONS; i++){
//			dq.enqueue(message);
			dq.blockingDequeue();
		}
		long end = System.currentTimeMillis();
		System.out.println("Rate is :"+1000*(long)REPETITIONS/(end-start));
		
	}
	
}


/*
 * Indiana University Extreme! Lab Software License, Version 1.2
 * 
 * Copyright (C) 2004 The Trustees of Indiana University. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 * 
 * 2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 * 
 * 3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 * 
 * "This product includes software developed by the Indiana University Extreme!
 * Lab. For further information please visit http://www.extreme.indiana.edu/"
 * 
 * Alternatively, this acknowledgment may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 * 
 * 4) The name "Indiana University" or "Indiana University Extreme! Lab" shall
 * not be used to endorse or promote products derived from this software without
 * prior written permission from Indiana University. For written permission,
 * please contact http://www.extreme.indiana.edu/.
 * 
 * 5) Products derived from this software may not use "Indiana University" name
 * nor may "Indiana University" appear in their name, without prior written
 * permission of the Indiana University.
 * 
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of any
 * other entity. Indiana University disclaims any liability to any recipient for
 * claims brought by any other entity based on infringement of intellectual
 * property rights or otherwise.
 * 
 * LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 * NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 * INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 * "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 * LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 * GENERATED USING SOFTWARE.
 */
